/**
 * Считает число треугольников-ответов
 * Время работы: O(n^4), "число пустых треугольников"*n
 * Баллы: ~41
 */

#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

struct point {
	ll x, y;
	point(): x(0), y(0) {};
	point(ll x, ll y): x(x), y(y) {};
};

ll area(point& a, point& b, point& c) {
	return abs((b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x));
}

vector<point> p;

bool isIn( int i, int j, int k, int l ) {
     return area(p[i], p[j], p[k]) == 
          area(p[i], p[j], p[l]) + area(p[k], p[j], p[l]) + area(p[i], p[k], p[l]);
}

int main() {
     // cerr << "Run!" << endl;
	int n;
     srand(239);
	cin >> n;
     p.resize(n);
	for (auto& x: p) cin >> x.x >> x.y;
	int q;
	cin >> q;
	while (q--) {
     	vector<int> ans;
     	string s;
          int answerCount = 0;
          for (int i = 0; i < n; i++) 
               for (int j = i + 1; j < n; j++) 
                    for (int k = j + 1; k < n; k++) {
                         bool isSomeIn = 0;
                         for (int l = 0; l < n; l++) {
                              if (l != i && l != j && l != k && isIn(i, j, k, l)) {
                                   isSomeIn = 1;
                                   break;
                              }
                         }
                         if (isSomeIn) 
                              continue;
                         cout << "? 3 " << i + 1 << " " <<  j + 1 << " " << k + 1 << endl;
                         cin >> s;
                         if (s == "Yes") {
                              ans = {i + 1, j + 1, k + 1};
                              answerCount++;
                         }    
                    }
          cout << "! 3 " << ans[0] << " " << ans[1] << " " << ans[2] << endl;
          //fprintf(stderr, "%d answers\n", answerCount);
	 }
}
