/**
 * Идея: перебрать все треугольники в порядке random_shuffle, для тех, 
          в которых 0 точек сделать запрос, вернуть первый подходящий
 * Время: >= n*"Число запросов", <= n*(n^3/6)
 * Запросы: в среднем O(n), есть тесты на которых n^3/6
 * Баллы: 15
 */

#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

struct point {
	ll x, y;
	point(): x(0), y(0) {};
	point(ll x, ll y): x(x), y(y) {};
};

ll area(point& a, point& b, point& c) {
	return abs((b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x));
}

vector<point> p;

bool isIn( int i, int j, int k, int l ) {
     return area(p[i], p[j], p[k]) == 
          area(p[i], p[j], p[l]) + area(p[k], p[j], p[l]) + area(p[i], p[k], p[l]);
}

int main() {
     // cerr << "Run!" << endl;
	int n;
     srand(239);
	cin >> n;
     p.resize(n);
	for (auto& x: p) cin >> x.x >> x.y;
	int q;
	cin >> q;
	while (q--) {
     	long long minA = 4e18;
     	vector<int> ans;
     	string s;
          int checkCount = 0, askCount = 0;
          while (1) {
               int i = rand() % n;
               int j = rand() % n;
               int k = rand() % n;
               if (i == j || j == k || i == k)
                    continue;
               checkCount++;
               bool isSomeIn = 0;
               for (int l = 0; l < n; l++) {
                    if (l != i && l != j && l != k && isIn(i, j, k, l)) {
                         isSomeIn = 1;
                         break;
                    }
               }
               if (isSomeIn) 
                    continue;
               askCount++;
               // cerr << "? 3 " << i + 1 << " " <<  j + 1 << " " << k + 1 << endl;
               cout << "? 3 " << i + 1 << " " <<  j + 1 << " " << k + 1 << endl;
     		cin >> s;
               // cerr << "result = " << s << endl;
     		if (s == "Yes") {
                    //fprintf(stderr, "%d checked, %d asked, ratio = %.3f\n", checkCount, askCount, 1. * checkCount / askCount);
                    cout << "! 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
                    break;
     		} 	
     	}
          // cerr << "!" << endl;
	 }
}
