#include <iostream>
#include <cstring>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <stack>
#include <bitset>
#define _USE_MATH_DEFINES
#include <math.h>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <assert.h>
#include <stdlib.h>
using namespace std;

void smain();
int main() {
    ios_base::sync_with_stdio(0);
#ifdef TASK
    freopen(TASK".in","rt",stdin);
    // freopen(TASK".out","wt",stdout);
    const clock_t start = clock();
#else
    freopen("trains.in", "rt", stdin);
    freopen("trains.out", "wt", stdout);
#endif
    smain();
#ifdef TASK
    cerr << "\nTotal Execution Time: " << float( clock () - start ) /  CLOCKS_PER_SEC << endl;
#endif
    return 0;
}

#ifndef M_PI
#define M_PI 3.14159265358979311599796346854418516
#endif
#define forn(i,n) for (int i=0;i<n;i++)
#define rforn(i,n) for (int i=n-1;i>=0;i--)
#define int long long
#define LL long long
#define mp(a,b) make_pair(a,b)
#define MOD 1000000007
#define EPS 1E-9
#define N 2000002
/* --------- END TEMPLATE CODE --------- */

int n, m;

vector<pair<int, pair<int, int> > > edges[N];
map<int, set<pair<int, int> > > pr[N];
map<int, pair<int, int> > mem[N];
bool visited[N];

pair<int, int> opt(const pair<int, int> &a, const pair<int, int> &b) {
    int va = a.first + a.second * a.second;
    int vb = b.first + b.second * b.second;
    if (va == vb) return a.second > b.second ? a : b;
    return va > vb ? a : b;
}

void dfs(int v) {
    if (visited[v]) return;
    visited[v] = 1;
    mem[v].clear();
    if (v == 0) mem[v].emplace(-1, mp(0, 0));
    if (v == 0) assert(pr[v].size() == 0);
     
    for (auto it : pr[v]) {
        int route = it.first;
        for (auto j : it.second) {
            dfs(j.first);
            for (auto rt : mem[j.first]) {
                pair<int, int> cost = rt.second;
                if (rt.first == route) cost.second += j.second;
                else {
                    cost.first += cost.second * cost.second;
                    cost.second = j.second;
                }
                mem[v][route] = opt(cost, mem[v][route]);
            }
        }
    }
    /* cerr << "------------\n" << v << endl;
    for (auto it : mem[v]) {
        cerr << it.first << ": ";
        for (auto jt : it.second) cout << "(" << jt.first << "," << jt.second << ") "; cout << endl;
    } */
}

void smain() {
    for (; cin >> n >> m; ) { 
        forn(i, m) {
            int k, u, t, v;
            cin >> k >> u;
            u -= 1;
            forn(j, k) {
                cin >> t >> v;
                v -= 1;
                edges[u].emplace_back(v, mp(t, i));
                u = v;
            }
        }
        vector<int> d(n, 2e9);
        d[0] = 0;
        priority_queue<pair<int, int> > q;
        q.emplace(0, 0);
        while (!q.empty()) {
            int i = q.top().second, l = -q.top().first;
            q.pop();
            if (d[i] != l) continue;
            if (i == n - 1) break;
            for (auto jt : edges[i]) {
                int len = l + jt.second.first;
                int route = jt.second.second;
                int j = jt.first;
                if (len < d[j]) {
                    d[j] = len;
                    q.emplace(-d[j], j);
                    pr[j].clear();
                    pr[j][route].emplace(i, jt.second.first);
                } else if (len == d[j]) {
                    pr[j][route].emplace(i, jt.second.first);
                }
            }
        }
        dfs(n - 1);
        int res = 0;
        for (auto it : mem[n - 1]) res = max(res, it.second.first + it.second.second * it.second.second);
        cout << d[n - 1] << ' ' << res << endl;

    }   
}
