/*
File name: ry_n2.cpp
Tag: REJECTED
Author: pkunyavskiy
Change time: Thu Mar 30 02:23:54 MSK 2017

*/
#include <iostream>
#include <cstring>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <stack>
#include <bitset>
#define _USE_MATH_DEFINES
#include <math.h>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <assert.h>
#include <stdlib.h>
using namespace std;

void smain();
int main() {
    ios_base::sync_with_stdio(0);
#ifdef TASK
    freopen(TASK".in","rt",stdin);
    // freopen(TASK".out","wt",stdout);
    const clock_t start = clock();
#endif
    smain();
#ifdef TASK
    cerr << "\nTotal Execution Time: " << float( clock () - start ) /  CLOCKS_PER_SEC << endl;
#endif
    return 0;
}

#ifndef M_PI
#define M_PI 3.14159265358979311599796346854418516
#endif
#define forn(i,n) for (int i=0;i<n;i++)
#define rforn(i,n) for (int i=n-1;i>=0;i--)
#define int long long
#define LL long long
#define mp(a,b) make_pair(a,b)
#define MOD 1000000007
#define EPS 1E-9
#define N 1000001
/* --------- END TEMPLATE CODE --------- */

const int INF = 1e18;
struct edge { int to, l, r; };
vector<edge> edges[N];
int t[N], n;

pair<int, int> dfs(int v, int p = -1) {
    pair<int, int> res(-INF, INF);
    for (auto e : edges[v]) if (e.to != p) {
        auto c = dfs(e.to, v);
        int l = max(e.l, c.first);
        int r = min(e.r, c.second);
        if (l > r) res = {INF, -INF};
        else res.first = max(res.first, l == e.l ? l - t[v] : l);
        res.second = min(res.second, r);
    }
    return res;
}

vector<int> solve() {
    vector<int> res(n);
    forn(i, n) {
        auto c = dfs(i);
        res[i] = c.first > c.second ? -1 : max(0LL, c.first);
    }
    return res;
}

void smain() {
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);
	
    for (; cin >> n; ) { 
        forn(i, n) cin >> t[i];
        forn(i, n) edges[i].clear();
        forn(i, n - 1) {
            int u = i, v = i + 1, l, r;
            cin >> l >> r;
            edges[u].push_back({v, l, r});
            edges[v].push_back({u, l, r});
        }
        for (auto i : solve()) cout << i << '\n';
    } 
}

