/*
File name: ry_n.cpp
Tag: ACCEPTED
Author: pkunyavskiy
Change time: Thu Mar 30 02:24:24 MSK 2017

*/
#include <iostream>
#include <cstring>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <stack>
#include <bitset>
#define _USE_MATH_DEFINES
#include <math.h>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <assert.h>
#include <stdlib.h>
using namespace std;

void smain();
int main() {
    ios_base::sync_with_stdio(0);
#ifdef TASK
    freopen(TASK".in","rt",stdin);
    // freopen(TASK".out","wt",stdout);
    const clock_t start = clock();
#endif
    smain();
#ifdef TASK
    cerr << "\nTotal Execution Time: " << float( clock () - start ) /  CLOCKS_PER_SEC << endl;
#endif
    return 0;
}

#ifndef M_PI
#define M_PI 3.14159265358979311599796346854418516
#endif
#define forn(i,n) for (int i=0;i<n;i++)
#define rforn(i,n) for (int i=n-1;i>=0;i--)
#define int long long
#define LL long long
#define mp(a,b) make_pair(a,b)
#define MOD 1000000007
#define EPS 1E-9
#define N 1000001
/* --------- END TEMPLATE CODE --------- */

const int INF = 1e18;
struct edge { int to, l, r; };
vector<edge> edges[N];
int t[N], n;
pair<int, int> dp[N], dp_up[N];


pair<int, int> dfs1(int v, int p = -1) {
    pair<int, int> res(-INF, INF);
    for (auto e : edges[v]) if (e.to != p) {
        auto c = dfs1(e.to, v);
        int l = max(e.l, c.first);
        int r = min(e.r, c.second);
        if (l <= r && l == e.l) l -= t[v];
        res.first = max(res.first, l);
        res.second = min(res.second, r);
    }
    return dp[v] = res;
}

void dfs2(int v, int p = -1) {
    if (p == -1) dp_up[v] = {-INF, INF};
    int mn1 = -INF, mn2 = -INF, mx1 = INF, mx2 = INF;   
    for (auto e : edges[v]) if (e.to != p) {
        auto c = dp[e.to];
        int l = max(e.l, c.first);
        int r = min(e.r, c.second);
        if (l <= r && l == e.l) l -= t[v];

        if (l > mn1) mn2 = mn1, mn1 = l;
        else if (l > mn2) mn2 = l;
        if (r < mx1) mx2 = mx1, mx1 = r;
        else if (r < mx2) mx2 = r;
    }
    for (auto e : edges[v]) if (e.to != p) {
        auto c = dp[e.to];
        int l = max(e.l, c.first);
        int r = min(e.r, c.second);
        if (l <= r && l == e.l) l -= t[v];

        int x = l == mn1 ? mn2 : mn1;
        int y = r == mx1 ? mx2 : mx1;

        x = max(x, dp_up[v].first);
        y = min(y, dp_up[v].second);

        x = max(x, e.l);
        y = min(y, e.r);

        if (x <= y && x == e.l) x -= t[e.to];
        dp_up[e.to] = {x, y};
        dfs2(e.to, v);
    }
}

vector<int> solve() {
    vector<int> res(n);
    dfs1(0);
    dfs2(0);
    forn(i, n) {
        auto c = dp[i];
        c.first = max(c.first, dp_up[i].first);
        c.second = min(c.second, dp_up[i].second);
        res[i] = c.first > c.second ? -1 : max(0LL, c.first);
    }
    return res;
}

void smain() {
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);	
    for (; cin >> n; ) { 
        forn(i, n) cin >> t[i];
        forn(i, n) edges[i].clear(); 
        forn(i, n - 1) {
            int u = i, v = i + 1, l, r;
            cin >> l >> r; 
            edges[u].push_back({v, l, r});
            edges[v].push_back({u, l, r});
        }
        for (auto i : solve()) cout << i << '\n';
    } 
}

