/*
File name: ak_n.cpp
Tag: ACCEPTED
Author: pkunyavskiy
Change time: Thu Mar 30 02:23:43 MSK 2017

*/
/*
* C++11 code template for contests.
* @author: Andrey Kalendarov
* @e-mail: andreykalendarov@gmail.com
*/

//#pragma GCC optimize ("O3")
//#define ANDREIKKAA_TOPCODER
//#define ANDREIKKAA_ALLOCATOR
#define ANDREIKKAA_CLASS Solution
#define ANDREIKKAA_METHOD solve
#define ANDREIKKAA_PARAMETERS void
#define ANDREIKKAA_CALL
#define ANDREIKKAA_RETURN_TYPE void

#define first x
#define second y
#include "bits/stdc++.h"
using namespace std;

typedef long long ll;
typedef long double ld;

#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
const ld PI = acos(-1);

const int _ML = 500;
const char _inpf[] =
#if defined(ANDREIKKAA)
"input.txt"
#else
""
#endif
;
const char _outf[] =
#if defined(ANDREIKKAA)
""
#else
""
#endif
;

#if defined(ANDREIKKAA_ALLOCATOR)
char _mem[_ML * 1024LL * 1024LL];
size_t _ptr = 0;
inline void* operator new(size_t _x) { _ptr += _x; return _mem + _ptr - _x; }
inline void operator delete(void*) { }
#endif

template<typename T, typename U> inline ostream &operator << (ostream &_out, const pair<T, U> &_p) { _out << _p.first << ' ' << _p.second; return _out; }
template<typename T, typename U> inline istream &operator >> (istream &_in, pair<T, U> &_p) { _in >> _p.first >> _p.second; return _in; }
template<typename T> inline ostream &operator << (ostream &_out, const vector<T> &_v) { if (_v.empty()) return _out; _out << _v.front(); for (auto _it = ++_v.begin(); _it != _v.end(); ++_it) _out << ' ' << *_it; return _out; }
template<typename T> inline istream &operator >> (istream &_in, vector<T> &_v) { for (auto &_i : _v) _in >> _i; return _in; }
template<typename T> inline ostream &operator << (ostream &_out, const set<T> &_s) { if (_s.empty()) return _out; _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) _out << ' ' << *_it; return _out; }
template<typename T> inline ostream &operator << (ostream &_out, const multiset<T> &_s) { if (_s.empty()) return _out; _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) _out << ' ' << *_it; return _out; }
template<typename T> inline ostream &operator << (ostream &_out, const unordered_set<T> &_s) { if (_s.empty()) return _out; _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) _out << ' ' << *_it; return _out; }
template<typename T> inline ostream &operator << (ostream &_out, const unordered_multiset<T> &_s) { if (_s.empty()) return _out; _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) _out << ' ' << *_it; return _out; }
template<typename T, typename U> inline ostream &operator << (ostream &_out, const map<T, U> &_m) { if (_m.empty()) return _out; _out << '(' << _m.begin()->first << ": " << _m.begin()->second << ')'; for (auto _it = ++_m.begin(); _it != _m.end(); ++_it) _out << ", (" << _it->first << ": " << _it->second << ')'; return _out; }
template<typename T, typename U> inline ostream &operator << (ostream &_out, const unordered_map<T, U> &_m) { if (_m.empty()) return _out; _out << '(' << _m.begin()->first << ": " << _m.begin()->second << ')'; for (auto _it = ++_m.begin(); _it != _m.end(); ++_it) _out << ", (" << _it->first << ": " << _it->second << ')'; return _out; }

/* ________ CODE ________ */

const int N = 200 * 1000 + 228;
const int T = 1000 * 1000 * 1000 + 228;

struct seg
{
	int l, r;
	bool ok;
};

const seg NEUTRAL = { 0, T, true };
const seg BAD = { -1, -1, false };

inline seg merge_seg(seg a, seg b)
{
	int l = max(a.l, b.l);
	int r = min(a.r, b.r);

	if (!a.ok || !b.ok || l > r)
	{
		return BAD;
	}
	return { l, r, true };
}

inline seg merge_edg_sub(seg a, seg b, int x)
{
	if (!a.ok || !b.ok || a.r < b.l || b.r < a.l)
		return BAD;

	if (b.l <= a.l)
		return { max(a.l - x, 0), min(a.r, b.r), true };
	else
		return { b.l, min(a.r, b.r), true };
}

struct edge
{
	int to;
	seg s;
};


int t[N];
vector<edge> g[N];
seg dp[N];
seg ans[N];


seg dfs_dp(int v, int p)
{
	auto s = NEUTRAL;

	for (auto it = g[v].begin(); it != g[v].end(); ++it)
	{
		if (it->to == p)
		{
			g[v].erase(it);
			break;
		}
	}

	for (auto i : g[v])
	{
		s = merge_seg(s, merge_edg_sub(i.s, dfs_dp(i.to, v), t[v]));
	}
	if (s.r + t[v] < s.l)
	{
		return dp[v] = BAD;
	}
	return dp[v] = s;
}

void dfs_ans(int v, int p, seg cur, seg edg)
{
	vector<seg> prf;
	for (auto i : g[v])
	{
		prf.push_back(merge_edg_sub(i.s, dp[i.to], t[v]));
		if (sz(prf) > 1)
		{
			prf.back() = merge_seg(prf.back(), prf[sz(prf) - 2]);
		}
	}

	cur = merge_edg_sub(edg, cur, t[v]);
	ans[v] = merge_seg(cur, dp[v]);

	seg suf = NEUTRAL;
	for (int i = sz(g[v]) - 1; i >= 0; --i)
	{
		auto now = merge_seg(suf, cur);
		if (i > 0)
		{
			now = merge_seg(now, prf[i - 1]);
		}
		dfs_ans(g[v][i].to, v, now, g[v][i].s);

		suf = merge_seg(suf, merge_edg_sub(g[v][i].s, dp[g[v][i].to], t[v]));
	}
}

inline ANDREIKKAA_RETURN_TYPE mainFunction(ANDREIKKAA_PARAMETERS)
{
	int n;
	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> t[i];
	}

	for (int i = 0; i < n - 1; ++i)
	{
		int a, b, l, r;
		cin >> l >> r;
		a = i + 1, b = i + 2;
		g[a].push_back({ b, l, r, true });
		g[b].push_back({ a, l, r, true });
	}

	dfs_dp(1, -1);
	dfs_ans(1, -1, NEUTRAL, NEUTRAL);

	for (int i = 1; i <= n; ++i)
	{
		if (ans[i].ok)
		{
			cout << ans[i].l << endl;
		}
		else
		{
			cout << -1 << endl;
		}
	}
}

/* ________ CODE ________ */

#if defined(ANDREIKKAA) || !defined(ANDREIKKAA_TOPCODER)
int main()
{
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);
#if defined(ANDREIKKAA)
	time_t _start = clock();
#endif
	if (_inpf[0] != '\0')
		assert(freopen(_inpf, "r", stdin) != nullptr);
	if (_outf[0] != '\0')
		assert(freopen(_outf, "w", stdout) != nullptr);
	cin.tie(nullptr);
	ios_base::sync_with_stdio(false);
	cout << setprecision(20);
	//cout << fixed;	
	mainFunction(ANDREIKKAA_CALL);
#if defined(ANDREIKKAA)
	cerr << "Time: " << (clock() - _start) / (ld)CLOCKS_PER_SEC << endl;
	while (true);
#endif
}
#else
class ANDREIKKAA_CLASS { public: ANDREIKKAA_RETURN_TYPE ANDREIKKAA_METHOD(ANDREIKKAA_PARAMETERS) { return mainFunction(ANDREIKKAA_CALL); } };
#endif

