/*
File name: coffee_sk_rangetree.cpp
Tag: REJECTED
Author: pkunyavskiy
Change time: Wed Mar 29 23:28:22 MSK 2017

*/
/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 * Time = O(nA*logA)
 * Memory = O(A)
 * idea = backward-DP with A states, use range tree 
 */

#include <climits>
#include <fstream>
#include <vector>
#include <functional>

using namespace std;
const long long MUL = 1000 * 1000 * 1000;
#define forn(i, n) for (int i = 0; i < (int)(n); i++)

int main() {
	ifstream in("anti.in");
	ofstream out("anti.out");

	int n, A;
	in >> n >> A;
	vector<int> x(n), y(n), c(n);
	forn(i, n)
		in >> x[i] >> y[i] >> c[i];

	int N = A + 1;
	vector<long long> result(N, 0), f(2 * N);
	auto finish = [&]( int a ) {
		f[a + N] = result[a];
		for (a = (a + N) / 2; a > 0; a >>= 1)
			f[a] = min(f[2 * a], f[2 * a + 1]);
	};
	auto get = [&]( int l, int r ) {
		long long res = (long long)1e18;
		for (l += N, r += N; l < r; l >>= 1, r >>= 1) {
			if (l & 1) res = min(res, f[l++]);
			if (r & 1) res = min(res, f[--r]);
		}
		return res;
	};

	result[A] = 1LL * A * MUL, finish(A);
	for (int a = A - 1; a >= 0; a--) {
		result[a] = 1LL * a * MUL;
		forn(i, n) {
			if (a + y[i] > A) continue;
			long long tmp = get(a + x[i], a + y[i] + 1);
			tmp -= c[i];
			result[a] = max(result[a], tmp);
		}
		finish(a);
	}
	out << result[0] << endl;
}

