#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

const int MAXA = 3000000;
const int MAXN = 100000;
const int MAXLOG = 22;

pair<int, int> dp[MAXA];
int l[MAXN], r[MAXN], c[MAXN];

int p[MAXA];
int mv[MAXA];
int rk[MAXA];
int A;

int get(int a) {
  int res = a;
  while (p[res] != res) res = p[res];
  while (p[a] != a) {
    int t = p[a];
    p[a] = res;
    a = t;
  }
  return res;
}

void join(int a, int b) {
  a = get(a);
  b = get(b);
  if (rk[a] > rk[b]) swap(a, b);
  p[a] = b;
  if (dp[mv[b]] > dp[mv[a]]) {
    mv[b] = mv[a];
  }
  if (rk[a] == rk[b]) rk[b]++;
}

pair<int, int> get_min(int r) {
  return dp[mv[get(r)]];
}

vector<int> stack;

void add(int pos) {
  mv[pos] = pos;
  while (!stack.empty() && dp[stack.back()] > dp[pos]) {
    join(pos, stack.back());
    stack.pop_back();
  }
  stack.push_back(pos);
}

int main() {
  freopen("coffee.in", "r", stdin);
  freopen("coffee.out", "w", stdout);
  int n;
  scanf("%d%d", &n, &A);

  for (int i = 0; i < n; i++) {
    scanf("%d%d%d", &l[i], &r[i], &c[i]);
  }

  for (int i = 0; i <= A; i++) {
    dp[i] = make_pair(i, 0);
    p[i] = i;
    rk[i] = i;
    mv[i] = -1;
  }

  for (int i = A; i >= 0; i--) {
    add(i);
    for (int j = 0; j < n; j++) {
      if (i - l[j] <= 0) continue;
      int st = i - l[j];
      if (st + r[j] > A) continue;
      pair<int, int> mv = get_min(st + r[j]);
      mv.second -= c[j];
      dp[st] = max(dp[st], mv);
    }
  }

  printf("%d %d\n", dp[0].first, -dp[0].second);
}
