/*
File name: segments_nn_hack.cpp
Tag: REJECTED
Author: niyaznigmatul
Change time: Wed Mar 29 22:30:24 MSK 2017

*/
#include <cstdio>
#include <cassert>
#include <algorithm>
int const N = 2234567;

struct answer {
  long long ans;
  int l1, r1;
  int l2, r2;
};

answer mx(answer a, answer b) {
  return a.ans > b.ans ? a : b;
}

int where[N];
bool removed[N], toRemove[N];
int p[N];
long long sz[N];
int lp[N], rp[N];

int get(int x) {
  return x == p[x] ? x : (p[x] = get(p[x]));
}

void join(int from, int to) {
  assert(from != to);
  p[from] = to;
  sz[to] += sz[from];
  lp[to] = std::min(lp[to], lp[from]);
  rp[to] = std::max(rp[to], rp[from]);
}

long long rem(int pos, int m) {
  assert(!removed[pos]);
  if (pos > 0 && removed[pos - 1]) {
    int from = get(pos - 1);
    int to = get(pos);
    join(from, to);
  }
  if (pos + 1 < m && removed[pos + 1]) {
    int from = get(pos);
    int to = get(pos + 1);
    join(from, to);
  }
  removed[pos] = true;
  return sz[get(pos)];
}

answer solve(int n, int m, int *a, int *wa, int *b, int *wb) {
  for (int i = 0; i <= n + m; i++) where[i] = -1;
  long long sumW1 = 0;
  for (int i = 0; i < m; i++) {
    where[b[i]] = i;
    toRemove[i] = true;
    sz[i] = wb[i];
    p[i] = i;
    lp[i] = rp[i] = i;
    removed[i] = false;
  }
  for (int i = 0; i < n; i++) {
    sumW1 += wa[i];
    toRemove[where[a[i]]] = false;
  }
  long long cur = 0;
  int cl2 = -1;
  int cr2 = -1;
  for (int i = 0; i < m; i++) {
    if (toRemove[i]) {
      long long val = rem(i, m);
      if (cur < val) {
        cur = val;
        cl2 = lp[get(i)];
        cr2 = rp[get(i)];
      }
    }
  }
  int l1 = -1;
  int r1 = -1;
  int l2 = -1;
  int r2 = -1;
  long long ans = 0;
  for (int i = n - 1; i >= 0; i--) {
    if (ans < cur + sumW1) {
      ans = cur + sumW1;
      l1 = 0;
      r1 = i;
      l2 = cl2;
      r2 = cr2;
    }
    ans = std::max(ans, cur + sumW1);
    sumW1 -= wa[i];
    int pos = where[a[i]];
    if (pos < 0) continue;
    long long val = rem(pos, m);
    if (cur < val) {
      cur = val;
      cl2 = lp[get(pos)];
      cr2 = rp[get(pos)];
    }
  }
  return {ans, l1, r1, l2, r2};
}


long long sum[N], cur[N];
int a[N], wa[N], b[N], wb[N], curc[N], st[N];

int main() {
  assert(freopen("internship.in", "r", stdin));
  assert(freopen("internship.out", "w", stdout));
  int n, m;
  assert(2 == scanf("%d%d", &n, &m));
  for (int i = 0; i < n; i++) assert(scanf("%d", a + i) == 1);
  for (int i = 0; i < n; i++) assert(scanf("%d", wa + i) == 1);
  for (int i = 0; i < m; i++) assert(scanf("%d", b + i) == 1);
  for (int i = 0; i < m; i++) assert(scanf("%d", wb + i) == 1);
  if ((long long) n * m < 100000000) {
    for (int i = 0; i < m; i++) {
      sum[i] = wb[i];
    }
    for (int i = 1; i < m; i++) sum[i] += sum[i - 1];
    long long ans = 0;
    int l1 = -1, l2 = -1, r1 = -1, r2 = -1;
    if (sum[m - 1] > ans) {
      ans = sum[m - 1];
      l1 = r1 = -1;
      l2 = 0;
      r2 = m - 1;
    }
    {
      long long q = 0;
      for (int i = 0; i < n; i++) q += wa[i];
      if (q > ans) {
        ans = q;
        l1 = 0;
        r1 = n - 1;
        l2 = r2 = -1;
      }
    }
    for (int i = 0; i <= m; i++) {
      cur[i] = 0;
      curc[i] = 0;
    }
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        if (a[i] != b[j]) {
          cur[j] += wa[i];
          curc[j]++;
        } else {
          cur[j] = 0;
          curc[j] = 0;
        }
      }
      int cn = 0;
      for (int j = 0; j <= m; j++) {
        while (cn > 0 && cur[st[cn - 1]] > cur[j]) {
          int last = st[cn - 1];
          long long val = cur[last] + sum[j - 1] - (cn > 1 ? sum[st[cn - 2]] : 0);
          if (ans < val) {
            ans = val;
            l1 = i - curc[last] + 1;
            r1 = i;
            l2 = cn > 1 ? st[cn - 2] + 1 : 0;
            r2 = j - 1;
          }
          --cn;
        }
        st[cn++] = j;
      }
    }
    printf("%lld\n", ans);
    printf("%d %d\n%d %d\n", l1 + 1, r1 + 1, l2 + 1, r2 + 1);
  } else {
    answer ans1 = solve(n, m, a, wa, b, wb);
    std::reverse(a, a + n);
    std::reverse(wa, wa + n);
    answer ans2 = solve(n, m, a, wa, b, wb);
    ans2 = {ans2.ans, n - ans2.r1 - 1, n - ans2.l1 - 1, ans2.l2, ans2.r2};
    std::reverse(a, a + n);
    std::reverse(wa, wa + n);
    answer ans3 = solve(m, n, b, wb, a, wa);
    ans3 = {ans3.ans, ans3.l2, ans3.r2, ans3.l1, ans3.r1};
    std::reverse(b, b + m);
    std::reverse(wb, wb + m);
    answer ans4 = solve(m, n, b, wb, a, wa);
    ans4 = {ans4.ans, ans4.l2, ans4.r2, m - ans4.r1 - 1, m - ans4.l1 - 1};
    answer ans = mx(mx(mx(ans1, ans2), ans3), ans4);
    printf("%lld\n", ans.ans);
    printf("%d %d\n%d %d\n", ans.l1 + 1, ans.r1 + 1, ans.l2 + 1, ans.r2 + 1);
  }
}

