#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

vector<string> plusSolution(vector<pair<string, string> > data) {
	vector<string> ans;

	for (auto t : data) {
		string a = t.first, b = t.second;

		vector<int> tmp;

		int cnt = 0;
		bool mb = 0;

		for (int i = 0; i < (int)a.size(); i++) {
			mb |= (a[i] == '+');

			if (i && a[i - 1] == '+' && a[i] == '-' && cnt) {
				while (!tmp.empty() && cnt > tmp.back()) {
					cnt += tmp.back();
					tmp.pop_back();
					if (!tmp.empty()) {
						cnt += tmp.back();
						tmp.pop_back();
					}
				}

				tmp.push_back(cnt);
				cnt = 1;
			} else if (i && a[i - 1] == '-' && a[i] == '+' && cnt) {
				if (!tmp.empty() && cnt < tmp.back()) {
					while (i < (int)a.size() && a[i] == '+') i++, cnt++;
					cnt += tmp.back();
					tmp.pop_back();

					while (!tmp.empty() && cnt > tmp.back()) {
						cnt += tmp.back();
						tmp.pop_back();
						if (!tmp.empty()) {
							cnt += tmp.back();
							tmp.pop_back();
						}
					}
				}

				tmp.push_back(cnt);

				cnt = (i == (int)a.size() ? 0 : 1);
			} else {
				cnt++;
			}
		}

		if (a.back() == '+' && cnt) {
			while (!tmp.empty() && cnt > tmp.back()) {
				cnt += tmp.back();
				tmp.pop_back();
				if (!tmp.empty()) {
					cnt += tmp.back();
					tmp.pop_back();
				}
			}

			tmp.push_back(cnt);
			cnt = 0;
		} else if (a.back() == '-' && cnt) {
			if (!tmp.empty() && cnt < tmp.back()) {
				cnt += tmp.back();
				tmp.pop_back();

				while (!tmp.empty() && cnt > tmp.back()) {
					cnt += tmp.back();
					tmp.pop_back();
					if (!tmp.empty()) {
						cnt += tmp.back();
						tmp.pop_back();
					}
				}
			}

			tmp.push_back(cnt);
			cnt = 0;
		}

		ans.push_back(tmp.back() == (int)a.size() && mb ? "Yes" : "No");
	}

	return ans;
}

vector<string> sqSolution(vector<pair<string, string> > data) {
	vector<string> ans;

	for (auto t : data) {
		string a = t.first, b = t.second;
		int n = a.size();

		unordered_map<string, bool> can;
		can[a] = 1;

		queue<string> q;
		q.push(a);

		while (!q.empty()) {
			string now = q.front();
			q.pop();

			for (int i = 0; i < n; i++) {
				if (now[i] != b[i]) {
					int l = i, r = i;

					while (l >= 0 && now[l] == now[i]) l--;
					while (r < n && now[r] == now[i]) r++;

					int l1 = l, r2 = r;

					while (l1 >= 0 && now[l1] == now[l]) l1--;
					while (r2 < n && now[r2] == now[r]) r2++;

					if (r2 - r > r - l - 1 || l - l1 > r - l - 1) {
						string next = now;

						for (int j = l + 1; j < r; j++) {
							next[j] = b[i];
						}

						if (!can[next]) {
							can[next] = 1;
							q.push(next);
						}
					}

					i = r - 1;
				}
			}
		}

		ans.push_back(can.count(b) ? "Yes" : "No");
	}

	return ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef GA_ROI
	freopen("/home/roi/prjs/file.in", "r", stdin);
	freopen("/home/roi/prjs/file.out", "w", stdout);
#else
	freopen("storage.in", "r", stdin);
	freopen("storage.out", "w", stdout);
#endif

	int n, s = 0;
	cin >> n;

	vector<pair<string, string> > data;

	while (n--) {
		string a, b;
		cin >> a >> b;
		data.push_back({a, b});
		s += a.size();
	}

	vector<string> ans;

	if (s <= 1000) {
		ans = sqSolution(data);
	} else {
		ans = plusSolution(data);
	}

	for (auto t : ans) {
		cout << t << "\n";
	}

	return 0;
}
