#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

inline vector<int> modelSolution(int n, vector<int> ts, vector<pair<int, int> > lrs) {
	vector<pair<int, int> > tol(n, {-1, -1}), tor(n, {-1, -1});

	tor[0] = {0, INF};

	for (int i = 1; i < n; i++) {
		tor[i] = {max(tor[i - 1].first, lrs[i - 1].first), min(tor[i - 1].second, lrs[i - 1].second)};
		if (tor[i].second < tor[i].first) {
			tor[i] = {-1, -1};
			break;
		}
		if (tor[i - 1].first <= lrs[i - 1].first) tor[i].first = max(0, tor[i].first - ts[i]);
	}

	tol[n - 1] = {0, INF};

	for (int i = n - 2; i >= 0; i--) {
		tol[i] = {max(tol[i + 1].first, lrs[i].first), min(tol[i + 1].second, lrs[i].second)};
		if (tol[i].second < tol[i].first) {
			tol[i] = {-1, -1};
			break;
		}
		if (tol[i + 1].first <= lrs[i].first) tol[i].first = max(0, tol[i].first - ts[i]);
	}

	vector<int> ans(n);

	for (int i = 0; i < n; i++) {
		pair<int, int> tmp = {max(tol[i].first, tor[i].first), min(tol[i].second, tor[i].second)};
		if (tor[i].second < tor[i].first || tol[i].second < tol[i].first || tol[i].first == -1 || tor[i].first == -1 || tmp.second < tmp.first) {
			ans[i] = -1;
		} else {
			ans[i] = tmp.first;
		}
	}

	return ans;
}

inline vector<int> naiveSolution(int n, vector<int> ts, vector<pair<int, int> > lrs) {
	vector<int> ans(n, -1);

	for (int i = 0; i < n; i++) {
		for (int send = 0; send <= 500; send++) {
			int l = send, r = send + ts[i];
			bool bad = 0;

			for (int j = i + 1; j < n; j++) {
				l = max(l, lrs[j - 1].first);
				r = min(min(l, r), lrs[j - 1].second);
				if (r < l) {
					bad = 1;
					break;
				}
				r += ts[j];
			}

			l = send, r = send + ts[i];

			for (int j = i - 1; j >= 0; j--) {
				l = max(l, lrs[j].first);
				r = min(min(l, r), lrs[j].second);
				if (r < l) {
					bad = 1;
					break;
				}
				r += ts[j];
			}

			if (!bad) {
				ans[i] = send;
				break;
			}
		}
	}

	return ans;
}

pair<vector<int>, vector<pair<int, int> > > gen() {
	int n = rand() % 5 + 1;
	vector<int> ts(n);
	vector<pair<int, int> > lrs(n - 1);

	for (int i = 0; i < n; i++) {
		ts[i] = rand() % 10;
	}

	for (int i = 0; i < n - 1; i++) {
		int l = rand() % 10;
		int r = rand() % 10 + l;
		lrs[i] = {l, r};
	}

	return {ts, lrs};
}

void stress() {
	srand(time(NULL));

	while (1) {
		auto tmp = gen();

		if (modelSolution(tmp.first.size(), tmp.first, tmp.second) != naiveSolution(tmp.first.size(), tmp.first, tmp.second)) {
			cout << "BAD AT:\n";
			cout << tmp.first.size() << "\n";

			for (auto t : tmp.first) {
				cout << t << " ";
			}
			cout << "\n";

			for (auto t : tmp.second) {
				cout << t.first << " " << t.second << "\n";
			}

			exit(0);
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef GA_ROI
	freopen("/home/roi/prjs/file.in", "r", stdin);
	freopen("/home/roi/prjs/file.out", "w", stdout);
#else
	freopen("servers.in", "r", stdin);
	freopen("servers.out", "w", stdout);
#endif

	stress();

	int n;
	cin >> n;

	vector<int> ts(n);

	for (int i = 0; i < n; i++) {
		cin >> ts[i];
	}

	vector<pair<int, int> > lrs(n - 1);

	for (int i = 0; i < n - 1; i++) {
		cin >> lrs[i].first >> lrs[i].second;
	}

	// vector<int> ans = naiveSolution(n, ts, lrs);
	vector<int> ans = modelSolution(n, ts, lrs);

	for (auto t : ans) {
		cout << t << "\n";
	}

	return 0;
}
