//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define ll long long
using namespace std;

const ll INF = 1e18;
const ll PRICE = 1e9;
struct tree {
    vector <ll> a;
    int n;
    tree (int sz) {
        n = 1;
        while (n < sz) n*=2;
        a.resize(2*n);
    }
    void refresh (int v, ll sz) {
        if (v == 0) return;
        a[v] = min(a[2*v], a[2*v + 1] + sz*PRICE);
        refresh(v/2, sz*2);
    }
    void change (int i, ll val) {
        a[n + i] = val;
        refresh((n+i)/2, 1ll);
    }
    ll get (int l, int r) {
        return get (1, l, r, 0, n-1);
    }
    ll get (int v, int l, int r, int tl, int tr) {
        if (l > tr || tl > r) return INF;
        if (l <= tl && tr <= r) return a[v];
        int tm = (tl + tr)/2;
        ll sz = (tm - max(tl, l) + 1);
        sz = max (sz, 0ll);
        return min (get(2*v, l, r, tl, tm), get(2*v + 1, l, r, tm+1, tr) + sz*PRICE);
    }
};

int n, a;

int main() {
    //freopen("input.txt", "r", stdin);

    cin >> n >> a;
    tree dp(a+1);
    vector <ll> c(n);
    vector <int> lk(n), rk(n);

    for (int i = 0; i < n; i++) cin >> lk[i] >> rk[i] >> c[i];

    for (int i = a-1; i >= 0; i--) {
        ll val = 0;
        for (int e = 0; e < n; e++) {
            if (i + rk[e] > a) continue;
            ll new_val = dp.get(i + lk[e], i + rk[e]) + PRICE*(ll)(lk[e]) - c[e];
            //cerr << dp.get(i + lk[e], i + rk[e]) << "+" << PRICE*(ll)(lk[e]) << "+" << c[e] << " = " << new_val << "\n";
            val = max (val, new_val);
        }
        dp.change(i, val);
        //cout << i << "  " << val << "\n";
    }

    cout << dp.get(0, 0);
}
/*
    tree tr(10);
    while (true) {
        int tp;
        cin >> tp;
        if (tp == 0) {
            int l, r;
            cin >> l >> r;
            cout << tr.get(l, r) << "\n";
        }
        else {
            int x; ll val;
            cin >> x >> val;
            tr.change(x, val);
        }
    }
*/
