#include <bits/stdc++.h>

using namespace std;

struct DSU
{
    int n;
    vector<int> par, sz, l, r, real_sz;
    DSU(int _n)
    {
        n = _n;
        par.resize(n);
        sz.resize(n, 1);
        l.resize(n);
        r.resize(n);
        real_sz.resize(n);
        for(int i = 0; i < n; i++) par[i] = i, l[i] = i, r[i] = i;
    }
    int find(int v)
    {
        if(v != par[v]) par[v] = find(par[v]);
        return par[v];
    }
    void unite(int u, int v)
    {
        u = find(u);
        v = find(v);
        if(u != v)
        {
            if(sz[u] < sz[v]) swap(u, v);
            par[v] = u;
            sz[u] += sz[v];
            l[u] = min(l[u], l[v]);
            r[u] = max(r[u], r[v]);
            real_sz[u] += real_sz[v];
        }
    }
};

int main()
{
    //freopen("in.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    while(n--)
    {
        string a, b;
        cin >> a >> b;
        int m = a.size();
        vector<pair<char, int>> A, B;
        for(int i = 0; i < m; i++)
            if(!i || a[i] != a[i - 1]) A.push_back({a[i], 1});
            else A.back().second++;
        for(int i = 0; i < m; i++)
            if(!i || b[i] != b[i - 1]) B.push_back({b[i], 1});
            else B.back().second++;
        vector<vector<pair<char,int>>> A1;
        int i1 = 0;
        bool bad = false;
        for(int i = 0; i < B.size(); i++)
        {
            int sz = 0;
            A1.push_back({});
            while(i1 < A.size() && sz < B[i].second) A1.back().push_back(A[i1]), sz += A[i1].second, i1++;
            if(sz != B[i].second) { bad = true; break; }
            if(i && A1.back()[0].first != B[i].first) { bad = true; break; }
            if(i < B.size() - 1 && A1.back().back().first != B[i].first) { bad = true; break; }
        }
        if(bad) { cout << "No\n"; continue; }
        for(int i = 0; i < A1.size(); i++)
        {
            int w = A1[i].size();
            if(w == 1 && A1[i][0].first != B[i].first) { bad = true; break; }
            DSU dsu(w);
            set<pair<int,int>> q;
            int tot = 0;
            for(int j = 0; j < w; j++)
            {
                if(A1[i][j].first == B[i].first) q.insert({A1[i][j].second, j});
                tot += A1[i][j].second;
            }
            for(int j = 0; j < w; j++)
                dsu.real_sz[j] = A1[i][j].second;
            while(!q.empty())
            {
                auto y = q.end(); y--;
                int big = dsu.find(y->second);
                //cout << dsu.real_sz[big] << endl;
                q.erase(y);
                int lf = dsu.l[big], rg = dsu.r[big];
                if(lf)
                {
                    lf--;
                    int ee = dsu.find(lf);
                    if(dsu.real_sz[big] > dsu.real_sz[ee])
                    {
                        dsu.unite(big, ee);
                        big = dsu.find(big);
                        if(lf)
                        {
                            lf--;
                            int ee1 = dsu.find(lf);
                            q.erase({dsu.real_sz[ee1], ee1});
                            dsu.unite(big, ee1);
                            big = dsu.find(big);
                            q.insert({dsu.real_sz[big], big});
                        }
                        else
                        {
                            q.insert({dsu.real_sz[big], big});
                        }
                    }
                }
                if(rg < w - 1)
                {
                    rg++;
                    int ee = dsu.find(rg);
                    if(dsu.real_sz[big] > dsu.real_sz[ee])
                    {
                        dsu.unite(big, ee);
                        big = dsu.find(big);
                        if(rg < w - 1)
                        {
                            rg++;
                            int ee1 = dsu.find(rg);
                            q.erase({dsu.real_sz[ee1], ee1});
                            dsu.unite(big, ee1);
                            big = dsu.find(big);
                            q.insert({dsu.real_sz[big], big});
                        }
                        else
                        {
                            q.insert({dsu.real_sz[big], big});
                        }
                    }
                }
            }
            if(dsu.real_sz[dsu.find(0)] != tot) { bad = true; break; }
        }
        if(bad) { cout << "No\n"; continue; }
        cout << "Yes\n";
    }
}
