# include <iostream>
# include <cstdio>
# include <string>
# include <cstring>
# include <vector>
# include <stack>
# include <queue>
# include <set>

using namespace std;

vector<pair<int, int> > get(const string &s)
{
    vector<pair<int, int> > ans;
    if (s[0] == '+') ans.push_back({1, 1});
    else ans.push_back({1, 0});
    for (int i = 1; i < (int)s.size(); i++)
    {
        if (s[i] == s[i - 1]) ++(*ans.rbegin()).first;
        else
        {
            if (s[i] == '+') ans.push_back({1, 1});
        else ans.push_back({1, 0});
        }
    }
    return ans;
}

const int MAX_N = 1e6;
int lft[MAX_N], rght[MAX_N];
bool used[MAX_N];

void solve()
{
    string s, t;
    cin >> s >> t;
    memset(used, 0, (int)s.size() * sizeof(bool));
    vector<pair<int, int> > s1 = get(s), t1 = get(t);
    vector<int> need;
    int n = s1.size(), m = t1.size();
    int cnt = 0;
    for (int i = 0; i < n; i++)
    {
        if (i == 0) lft[i] = -1;
        else lft[i] = i - 1;
        if (i == n - 1) rght[i] = -1;
        else rght[i] = i + 1;
        for (int j = 0; j < s1[i].first; j++)
        {
            if (t[cnt + j] != t[cnt])
            {
                cout << "No\n";
                return;
            }
        }
        if (t[cnt] != s[cnt]) need.push_back(i);
        cnt += s1[i].first;
    }
    int p = need.size();
    for (int i = 0; i < p - 1; i++)
    {
        if (need[i] == need[i + 1] - 1)
        {
            cout << "No\n";
            return;
        }
    }
    set<int> all;
    all.insert(0);
    for (int i = 1; i < s.size(); i++)
    {
        if (s[i] != s[i - 1]) all.insert(i);
    }
    all.insert(s.size());
    queue<int> can;
    cnt = 0;
    set<int> need1;
    for (int i : need) need1.insert(i);
    set<int> need2;
    for (int i = 0; i < n; i++)
    {
        if (need1.find(i) != need1.end()) need2.insert(cnt);
        if (need1.find(i) != need1.end()) if ((i > 0 && s1[i].first < s1[i - 1].first) || (i < n - 1 && s1[i].first < s1[i + 1].first))
        {
            used[cnt] = true;
            can.push(cnt);
        }
        cnt += s1[i].first;
    }
    int ans = 0;
    while (!can.empty())
    {
        int i = can.front();
        can.pop();
        ++ans;
        set<int>::iterator it = all.lower_bound(i);
        set<int>::iterator it1, it2;
        if (it == all.begin())
        {
            it1 = it;
            it2 = it1;
            ++it2;
            all.erase(it2);
            it2 = it1;
            it2++;
        }
        else
        {
            it1 = (--it)++;
            it2 = (++it)--;
            all.erase(it);
        }
        if ((++it2)-- != all.end())
        {
            all.erase(it2);
            it2 = (++it1)--;
        }
        need2.erase(i);
        if (it1 == all.begin())
        {
            int one = *it2;
            if ((++it2)-- == all.end()) continue;
            int two = *(++it2), three = *it1;
            if (!used[one] && need2.find(one) != need2.end() && two - one < one - three)
            {
                used[one] = true;
                can.push(one);
            }
            continue;
        }
        if ((++it2)-- == all.end())
        {
            int one = *it1;
            int two = *(--it1);
            int three = *it2;
            if (!used[two] && need2.find(two) != need2.end() && three - one < one - two)
            {
                used[two] = true;
                can.push(two);
            }
            continue;
        }
        int one = *it1;
        int two = *(--it1), three = *it2;
        ++it2;
        int four = *it2;
        if (!used[three] && need2.find(three) != need2.end() && four - three < three - one)
        {
            used[three] = true;
            can.push(three);
        }
        if (!used[two] && need2.find(two) != need2.end() && one - two < three - one)
        {
            used[two] = true;
            can.push(two);
        }
    }
    if (ans < p)
    {
        cout << "No\n";
    }
    else cout << "Yes\n";
}

int main()
{
   // freopen("input.txt", "r", stdin);
   // ios::sync_with_stdio(false);
   // cin.tie(NULL);
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        solve();
    }
}
