#include <iostream>
#include <fstream>
#include <utility>
#include <set>
#include <unordered_set>
#include <map>
#include <algorithm>
#include <vector>
#include <stack>
#include <string>
using namespace std;

/*

ifstream fin("input.txt");
ofstream fout("output.txt");

ifstream fin("order.in");
ofstream fout("order.out");

*/

int sgn(int a) {
	if (a < 0)
		return -1;
	else if (a > 0)
		return 1;
	return 0;
}

struct pt {
	int x, y, id;
	pt(int x = 0, int y = 0, int id = 0) : x(x), y(y), id(id) {}
};

struct vec {
	int x, y, id;
	vec(int x = 0, int y = 0, int id = 0) : x(x), y(y), id(id) {}
	vec(pt a, pt b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
};

int operator^(vec a, vec b) {
	return a.x * b.y - a.y * b.x;
}

bool query(vector<pt> &a) {
	cout << "? ";
	for (auto p : a) {
		cout << p.id + 1 << " ";
	}
	cout << endl;

	string dec;
	cin >> dec;
	return (dec == "Yes");
}

bool equal_line(pt a, pt b, pt p1, pt p2) {
	vec v1(a, b);
	vec v2(a, p1);
	vec v3(a, p2);

	return (sgn(v1 ^ v2) == sgn(v1 ^ v3));
}

bool in_tr(pt f, vector<pt> &cur) {
	pt a = cur[0];
	pt b = cur[1];
	pt c = cur[2];

	return equal_line(a, b, f, c) && equal_line(a, c, f, b) && equal_line(c, b, f, a);
}

bool is_good(vector<pt> &p, vector<pt> &cur) {
	for (auto f : p) {
		if (in_tr(f, cur))
			return false;
	}
	return true;
}

vector<pt> search(vector<pt> &p) {
	int n = p.size();
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			for (int k = j + 1; k < n; k++) {
				vector<pt> cur;
				cur.push_back(p[i]);
				cur.push_back(p[j]);
				cur.push_back(p[k]);
				bool ans = query(cur);
				if (ans && is_good(p, cur)) {
					return cur;
				}
			}
		}
	}
}

signed main() {
	int n;
	cin >> n;
	vector<pt> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i].x >> p[i].y;
		p[i].id = i;
	}
	int q;
	cin >> q;
	for (int qq = 0; qq < q; qq++) {
		vector<pt> ans = search(p);
		cout << "! ";
		for (auto t : ans)
			cout << t.id + 1 << " ";
		cout << endl;
	}
}