#include <iostream>
#include <fstream>
#include <utility>
#include <set>
#include <unordered_set>
#include <map>
#include <algorithm>
#include <vector>
#include <stack>
#include <string>
using namespace std;

/*

ifstream fin("input.txt");
ofstream fout("output.txt");

ifstream fin("trains.in");
ofstream fout("trains.out");

*/

ifstream fin("trains.in");
ofstream fout("trains.out");

const int inf = 1000000000;

void dij(int start, vector<vector<pair<int, int> > > &g, vector<int> &dist, vector<int> &sq) {
	int n = g.size();
	dist.resize(n, inf);
	dist[start] = 0;
	sq.resize(n, 0);

	set<pair<int, int> > s;
	s.insert({dist[start], start});
	vector<bool> used(n);

	while (!s.empty()) {
		auto v = s.begin()->second;
		used[v] = true;
		s.erase(s.begin());

		for (auto e : g[v]) {
			int u = e.second, wt = e.first;
			if (!used[u] && dist[u] > dist[v] + wt) {
				s.erase({ dist[u], u });
				dist[u] = dist[v] + wt;
				s.insert({ dist[u], u });
				sq[u] = sq[v] + wt * wt;
			}
			else if (!used[u] && dist[u] == dist[v] + wt) {
				sq[u] = max(sq[u], sq[v] + wt * wt);
			}
		}
	}
}

signed main() {
	int n, m;
	fin >> n >> m;
	vector<vector<pair<int, int> > > g(n);
	for (int i = 0; i < m; i++) {
		int s, v;
		fin >> s;
		fin >> v;
		v--;
		for (int j = 0; j < s; j++) {
			int wt, u;
			fin >> wt >> u;
			u--;
			g[v].push_back({ wt, u });
			v = u;
		}
	}

	vector<int> dist, sq;
	dij(0, g, dist, sq);

	fout << dist[n - 1] << " " << sq[n - 1] << endl;
}
