#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 2e5 + 100, inf = 1e9 + 100, mod = 1e9 + 993;

struct treap{
    int v, x, y, sz;
    treap *l, *r;
};

typedef treap * ptr;

ptr create(int v, int x){
    ptr t = new treap;
    t->v = v;
    t->x = x;
    t->y = rand();
    t->sz = 1;
    t->l = nullptr;
    t->r = nullptr;
    return t;
}

int sz(ptr t){
    return t == nullptr ? 0 : t->sz;
}

void upd(ptr &t){
    if (t != nullptr)
        t->sz = 1 + sz(t->l) + sz(t->r);
}

void split(ptr t, ptr &l, ptr &r, ll key){
    if (t == nullptr){
        l = nullptr;
        r = nullptr;
        return;
    }
    if (t->x <= key)
        split(t->r, t->r, r, key), l = t;
    else
        split(t->l, l, t->l, key), r = t;
    upd(l);
    upd(r);
}

void merge(ptr &t, ptr l, ptr r){
    if (l == nullptr){
        t = r;
        return;
    }
    if (r == nullptr){
        t = l;
        return;
    }
    if (l->y <= r->y)
        merge(l->r, l->r, r), t = l;
    else
        merge(r->l, l, r->l), t = r;
    upd(t);
}

ptr root = nullptr;

ll n;


int mas[maxn];

int main(){
    #ifdef ONPC
    ifstream cin("a.in");
    ofstream cout("a.out");
    #else
    ifstream cin("sum.in");
    ofstream cout("sum.out");
    #endif // ONPC
    ios::sync_with_stdio(0);
    n = maxn - 100;
    for (int i = 1; i <= n; i++){
        ptr t1, t2;
        split(root, t1, t2, i * i);
        merge(root, t1, create(i * i, i * i));
        merge(root, root, t2);
    }
    for (int i = 1; i <= n; i++){
        int l = 0, r = n + 1;
        while (r - l > 1){
            int m = (l + r) / 2;
            bool is;
            ptr t1, t2, t3;
            split(root, t1, t2, m * m - 1);
            split(t2, t2, t3, m * m);
            if (t2->v >= m * m)
                is = 1;
            else
                is = 0;
            merge(root, t1, t2);
            merge(root, root, t3);
            if (is)
                r = m;
            else
                l = m;
        }
        mas[i] = r;
    }
    ll a1, a2;
    cin >> a1 >> a2;
    cout << a1 + a2;
}
