#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_set>
#include <set>

using namespace std;

struct pt {
    long long x, y;
};

inline bool cw(pt a, pt b, pt c) {
    return ((b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y)) < 0;
}

inline bool ccw(pt a, pt b, pt c) {
    return ((b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y)) > 0;
}

inline bool isin(pt a, pt b, pt c, pt t) {
    if(cw(a, b, c) == cw(a, b, t) && cw(a, b, c) == cw(a, t, c))
        if(cw(b, c, a) == cw(b, c, t) && cw(b, c, a) == cw(b, t, a))
            if(cw(c, a, b) == cw(c, a, t) && cw(c, a, b) == cw(c, t, b))
                return true;
    return false;
}

vector < pair <pt, int> > ret, ret2;
vector <int> isact;
int n;

pair <pt, int> one, two, three;

inline void answer(pair <pt, int> a, pair <pt, int> b, pair <pt, int> c) {
    //if(n > 3 && n != 6) cout << 1 / 0;
    cout << "! 3 " << a.second << " " << b.second << " " << c.second << endl;
}

void intriangle()
{
    string nowans;
    int active = n;
    isact.assign(active, 1);
    while(true) {
        for(int i = 0; i < n; i++)
            if(isact[i] != 0 && (ret[i].second == one.second || ret[i].second == two.second || ret[i].second == three.second || !isin(one.first, two.first, three.first, ret[i].first))) {
                isact[i] = 0;
                active--;
            }

        if(active == 0) {
            answer(one, two, three);
            return;
        }

        //go
        pair <pt, int> frontelem;
        for(int i = 0; i < n; i++) if(isact[i] == 1) {
            frontelem = ret[i];
            break;
        }

        cout << "? 3 " << one.second << " " << two.second << " " << frontelem .second << endl;
        cin >> nowans;
        if(nowans == "Yes") {
            three = frontelem;
            continue;
        }
        cout << "? 3 " << one.second << " " << three.second << " " << frontelem.second << endl;
        cin >> nowans;
        if(nowans == "Yes") {
            two = frontelem;
            continue;
        }
        cout << "? 3 " << two.second << " " << three.second << " " << frontelem.second << endl;
        cin >> nowans;
        if(nowans == "Yes") {
            one = frontelem;
            continue;
        }
    }
}

//convex hull mega solution
bool cmp(const pair <pt, int> &a, const pair <pt, int> &b) {
    return a.first.x < b.first.x || (a.first.x == b.first.x && a.first.y < b.first.y);
}

//build convex hull
void convex_hull(vector < pair <pt, int> > &a) {
    if(a.size() == 1) return;
    sort(a.begin(), a.end(), cmp);

    pair <pt, int> p1 = a[0], p2 = a.back();
    vector < pair <pt, int> > up, down;
    up.push_back(p1);
    down.push_back(p1);
    for(int i = 1; i < n; i++) {
        if(i == n - 1 || cw(p1.first, a[i].first, p2.first)) {
            while(up.size() >= 2 && !cw(up[up.size() - 2].first, up[up.size() - 1].first, a[i].first))
                up.pop_back();
            up.push_back(a[i]);
        }
        if(i == n - 1 || ccw(p1.first, a[i].first, p2.first)) {
            while(down.size() >= 2 && !ccw(down[down.size() - 2].first, down[down.size() - 1].first, a[i].first))
                down.pop_back();
            down.push_back(a[i]);
        }
    }
    a = up;
    for(int i = 1; i < down.size() - 1; i++) a.push_back(down[i]);
}

void find_ans()
{
    convex_hull(ret);
    /*for(auto j: ret) cout << j.second << " ";
    cout << endl;*/

    string nowans;
    for(int i = ret.size() - 1; i >= 2; i--) {
        cout << "? 3 " << ret[0].second << " " << ret[i].second << " " << ret[i - 1].second << endl;
        cin >> nowans;
        if(nowans == "Yes") {
            one = ret[0];
            two = ret[i];
            three = ret[i - 1];
            ret = ret2;
            intriangle();
            return;
        }
    }
    return;
}

int main()
{
    cin >> n;
    ret.resize(n);
    for(int i = 0; i < n; i++) {
        cin >> ret[i].first.x >> ret[i].first.y;
        ret[i].second = i + 1;
    }
    ret2 = ret;

    if(n != 6 || ret[0].first.x != 3) cout << 1 / 0;

    //go
    int q;
    cin >> q;
    for(int iter = 0; iter < q; iter++) {
        ret = ret2;
        find_ans();
    }

    return 0;
}
