#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_set>
#include <set>

using namespace std;

struct pt {
    long long x, y;
};

inline bool cw(pt a, pt b, pt c) {
    return ((b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y)) < 0;
}

inline bool ccw(pt a, pt b, pt c) {
    return ((b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y)) > 0;
}

inline bool isin(pt a, pt b, pt c, pt t) {
    if(cw(a, b, c) == cw(a, b, t) && cw(a, b, c) == cw(a, t, c))
        if(cw(b, c, a) == cw(b, c, t) && cw(b, c, a) == cw(b, t, a))
            if(cw(c, a, b) == cw(c, a, t) && cw(c, a, b) == cw(c, t, b))
                return true;
    return false;
}

vector < pair <pt, int> > ret, ret2;
vector <int> isact;
int n;

pair <pt, int> one, two, three;

inline void answer(pair <pt, int> a, pair <pt, int> b, pair <pt, int> c) {
    cout << "! 3 " << a.second << " " << b.second << " " << c.second << endl;
    cout.flush();
}

void intriangle()
{

    string nowans;
    int active = n;
    isact.assign(active, 1);
    while(true) {
        for(int i = 0; i < n; i++)
            if(isact[i] != 0 && (ret[i].second == one.second || ret[i].second == two.second || ret[i].second == three.second || !isin(one.first, two.first, three.first, ret[i].first))) {
                isact[i] = 0;
                active--;
            }

        if(active == 0) {
            answer(one, two, three);
            return;
        }

        //go
        pair <pt, int> frontelem;
        for(int i = 0; i < n; i++) if(isact[i] == 1) {
            frontelem = ret[i];
            break;
        }

        cout << "? 3 " << one.second << " " << two.second << " " << frontelem.second << endl;
        cout.flush();
        cin >> nowans;
        if(nowans == "Yes") {
            three = frontelem;
            continue;
        }
        cout << "? 3 " << one.second << " " << three.second << " " << frontelem.second << endl;
        cout.flush();
        cin >> nowans;
        if(nowans == "Yes") {
            two = frontelem;
            continue;
        }
        cout << "? 3 " << two.second << " " << three.second << " " << frontelem.second << endl;
        cout.flush();
        cin >> nowans;
        if(nowans == "Yes") {
            one = frontelem;
            continue;
        }
    }
}

//convex hull mega solution
bool cmp(const pair <pt, int> &a, const pair <pt, int> &b) {
    return a.first.x < b.first.x || (a.first.x == b.first.x && a.first.y < b.first.y);
}

//build convex hull
vector < pair <pt, int> > convex_hull(vector < pair <pt, int> > a) {
    if(a.size() == 1) return a;
    sort(a.begin(), a.end(), cmp);

    pair <pt, int> p1 = a[0], p2 = a.back();
    vector < pair <pt, int> > up, down;
    up.push_back(p1);
    down.push_back(p1);
    for(int i = 1; i < n; i++) {
        if(i == n - 1 || cw(p1.first, a[i].first, p2.first)) {
            while(up.size() >= 2 && !cw(up[up.size() - 2].first, up[up.size() - 1].first, a[i].first))
                up.pop_back();
            up.push_back(a[i]);
        }
        if(i == n - 1 || ccw(p1.first, a[i].first, p2.first)) {
            while(down.size() >= 2 && !ccw(down[down.size() - 2].first, down[down.size() - 1].first, a[i].first))
                down.pop_back();
            down.push_back(a[i]);
        }
    }
    a.clear();
    for(auto j: up) a.push_back(j);
    for(int i = 1; i < down.size() - 1; i++) a.push_back(down[i]);
    return a;
}

void find_ans()
{
    vector < pair <pt, int> > kal;
    for(int i = 0; i < ret.size(); i++) kal.push_back(ret[i]);
    ret2 = convex_hull(kal);

    string nowans;
    for(int i = ret2.size() - 1; i >= 2; i--) {
        cout << "? 3 " << (int)ret2[0].second << " " << (int)ret2[i].second << " " << (int)ret2[i - 1].second << endl;
        cout.flush();
        cin >> nowans;
        if(nowans != "No") {
            one = ret2[0];
            two = ret2[i];
            three = ret2[i - 1];
            intriangle();
            return;
        }
    }

    /*ret.clear();
    for(auto j: ret2) ret.push_back(j);

    for(int i = 0; i < n; i++) for(int j = i + 1; j < n; j++) for(int k = j + 1; k < n; k++) {
        cout << "? 3 " << ret[i].second << " " << ret[j].second << " " << ret[k].second << endl;
        cin >> nowans;
        if(nowans == "Yes") {
            one = ret[i];
            two = ret[j];
            three = ret[k];
            intriangle();
            return;
        }
    }*/
    return;
}

int main()
{
    cin >> n;
    ret.resize(n);
    for(int i = 0; i < n; i++) {
        cin >> ret[i].first.x >> ret[i].first.y;
        ret[i].second = i + 1;
    }

    //go
    int q;
    cin >> q;
    for(int iter = 0; iter < q; iter++) {
        find_ans();
    }

    return 0;
}
