#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <queue>
#include <string>

using namespace std;

int solve();

typedef long long ll;

int main() {
#ifdef ROII
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int dd = (int)1e6 + 1;
const int LOG = 30;
int A[dd];

int prv0[LOG][dd], prv1[LOG][dd];
int cnt01[LOG][dd], cnt10[LOG][dd];
int can0[LOG], can1[LOG];

void go(int t, int l, int r) {
	if (l >= r) return;
	if (t >= LOG) return;

	int c01 = cnt01[t][r] - cnt01[t][l];
	int c10 = cnt10[t][r] - cnt10[t][l];

	if (c01 + c10 > 1) {
		can0[t] = can1[t] = 0;
		return;
	}
	if (c01 == 1) {
		can1[t] = 0;
		int ind = prv0[t][r];
		go(t + 1, l, ind);
		go(t + 1, ind + 1, r);
	} else if (c10 == 1) {
		can0[t] = 0;
		int ind = prv1[t][r];
		go(t + 1, l, ind);
		go(t + 1, ind + 1, r);
	} else {
		go(t + 1, l, r);
	}
}

int n;

int get() {
	for (int i = 0; i < LOG; i++) can0[i] = can1[i] = 1;
	go(0, 0, n - 1);
	int ans = 0;
	for (int i = 0; i < LOG; i++) {
		if (!can0[i]) {
			if (can1[i]) ans += (1 << (LOG - i - 1));
			else return -1;
		}
	}
	return ans;
}

void calc() {
	for (int t = 0; t < LOG; t++) {
		int p = -1;
		for (int i = 0; i < n; i++) {
			int x = (A[i] >> (LOG - t - 1)) & 1;

			if (x == 0) prv0[t][i] = i, prv1[t][i] = (i ? prv1[t][i - 1] : -1);
			else prv1[t][i] = i, prv0[t][i] = (i ? prv0[t][i - 1] : -1);

			cnt01[t][i] = cnt01[t][i - 1] + (p == 0 && x == 1);
			cnt10[t][i] = cnt10[t][i - 1] + (p == 1 && x == 0);

			p = x;
		}
	}
}

int solve() {
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &A[i]);
	}

	calc();

	printf("%d\n", get());

	int q;
	scanf("%d", &q);

	while (q--) {
		int a, b;
		scanf("%d %d", &a, &b);
		A[a - 1] = b;
		calc();
		printf("%d\n", get());
	}
	return 0;
}