#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9 + 1;

struct Point
{
    long long x, y;
    int ind;
    Point(long long x, long long y, int ind): x(x), y(y), ind(ind) {}
    operator <(const Point &a) const
    {
        return x < a.x || (x == a.x && y < a.y);
    }
    Point operator -(const Point &a) const
    {
        return {x - a.x, y - a.y, -1};
    }
    long long vp(const Point &a)
    {
        return x * a.y - y * a.x;
    }
    long long len2()
    {
        return x * x + y * y;
    }
};

struct Triangle
{
    int a, b, c;
    Triangle(const Point &a, const Point &b, const Point &c): a(a.ind), b(b.ind), c(c.ind) {}
};

vector<Point> p;
bool comp(const Point &a, const Point &b)
{
    Point aa = a - p[0];
    Point bb = b - p[0];
    return aa.vp(bb) > 0/* || (aa).vp(bb) == 0 && aa.len2() < bb.len2()*/;
}


bool check(const Triangle &a)
{
    cout << "? 3 " << a.a + 1 << ' ' << a.b + 1 << ' ' << a.c + 1 << endl;
    string str;
    cin >> str;
    return str == "Yes";
}

void answer(const Triangle &a)
{
    cout << "! 3 " << a.a + 1 << ' ' << a.b + 1 << ' ' << a.c + 1 << endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        p.push_back({x, y, i});
    }
    int ind = 0;
    for (int i = 0; i < n; i++)
        if (p[i] < p[ind])
            ind = i;
    swap(p[0], p[ind]);
    sort(p.begin() + 1, p.end(), comp);
    vector<Triangle> triangle;
    while (p.size() > 2)
    {
        for (int i = 0; i < p.size(); i++)
        {
            if ((p[(i + 1) % p.size()] - p[i]).vp(p[(i + p.size() - 1) % p.size()] - p[i]) > 0 &&
                (p[(i + p.size() - 1) % p.size()] - p[(i + 1) % p.size()]).vp(p[(i + 2) % p.size()] - p[(i + 1) % p.size()]) <= 0 &&
                (p[(i + 1) % p.size()] - p[(i + p.size() - 1) % p.size()]).vp(p[(i + p.size() - 2) % p.size()] - p[(i + p.size() - 1) % p.size()]) >= 0)
            {
                triangle.push_back({p[i], p[(i + 1) % p.size()], p[(i + p.size() - 1) % p.size()]});
                vector<Point> pp;
                ///cout << triangle.back().a << ' ' << triangle.back().b << ' ' << triangle.back().c << endl;
                for (int j = 0; j < i; j++)
                    pp.push_back(p[j]);
                for (int j = i + 1; j < p.size(); j++)
                    pp.push_back(p[j]);
                swap(p, pp);
                break;
            }
        }
    }
    int q;
    cin >> q;
    for (int test = 0; test < q; test++)
    {
        random_shuffle(triangle.begin(), triangle.end());
        int ind = -1;
        for (int i = 0; i < triangle.size(); i++)
        {
            if (check(triangle[i]))
            {
                ind = i;
                break;
            }
        }
        answer(triangle[ind]);
    }
}
/*
6
3 0
0 2
2 4
4 2
5 5
6 1
*/
