#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

typedef pair<int, int> pii;

#define TASK "servers"
#define inb push_back
#define X first
#define Y second

const int M = 2e5 + 5;
int n;
int t[M];
pii b[M];
pii pr[M], pl[M];

int ch(int x, int i)
{
	int tl = x;
	int j = i;
	while (j < n - 1)
	{
		if (tl > b[j].Y)
			return 2;
		if (b[j].X - tl > t[j])
			return 1;
		tl = max(tl, b[j].X);
		++j;
	}
	j = i;
	tl = x;
	while (j > 0)
	{
		if (tl > b[j - 1].Y)
			return 2;
		if (b[j - 1].X - tl > t[j])
			return 1;
		tl = max(tl, b[j - 1].X);
		--j;
	}
	return 0;
}

void solve1()
{
	for (int i = 0; i < n; ++i)
		cin >> t[i];
	for (int i = 0; i < n - 1; ++i)
		cin >> b[i].X >> b[i].Y;
	for (int i = 0; i < n; ++i)
	{
		int l = 0, r = 5e3;
		while (l < r)
		{
			int m = (l + r) / 2;
			int x = ch(m, i);
			if (x == 2)
				r = m - 1;
			else if (x == 1)
				l = m + 1;
			else
				r = m;
		}
		if (!ch(l, i))
			cout << l << '\n';
		else
			cout << "-1\n";
	}
	exit(0);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	ios_base::sync_with_stdio();
	cin >> n;
	if (n <= 5000)
		solve1();
	for (int i = 1; i <= n; ++i)
		cin >> t[i];
	for (int i = 1; i <= n - 1; ++i)
		cin >> b[i].X >> b[i].Y;
	pr[n - 1] = b[n - 1];
	for (int i = n - 1; i > 1; --i)
	{
		if (pr[i].X == -1)
			pr[i - 1].X = pr[i - 1].Y = -1;
		else if (b[i - 1].X > b[i].Y)
			pr[i - 1].X = pr[i - 1].Y = -1;
		else if (b[i - 1].X > b[i].X)
		{
			if (pr[i].X <= b[i - 1].X && b[i - 1].X <= pr[i].Y)
				pr[i - 1].X = b[i - 1].X, pr[i - 1].Y = min(b[i - 1].Y, pr[i].Y);
			else
				pr[i - 1].X = pr[i - 1].Y = -1;
		}
		else
		{
			if (pr[i].X == b[i].X)
				pr[i - 1].X = max(pr[i].X - t[i], b[i - 1].X);
			else
				pr[i - 1].X = max(pr[i].X, b[i - 1].X);
			pr[i - 1].Y = min(b[i - 1].Y, pr[i].Y);
		}
	}
	pl[1] = b[1];
	b[n] = { 1, 1e9 };
	for (int i = 1; i < n; ++i)
	{
		if (pl[i].X == -1)
			pl[i + 1].X = pl[i + 1].Y = -1;
		else if (b[i + 1].X > b[i].Y)
			pl[i + 1].X = pl[i + 1].Y = -1;
		else if (b[i + 1].X > b[i].X)
		{
			if (pl[i].X <= b[i + 1].X && b[i + 1].X <= pl[i].Y)
				pl[i + 1].X = b[i + 1].X, pl[i + 1].Y = min(b[i + 1].Y, pl[i].Y);
			else
				pl[i + 1].X = pl[i + 1].Y = -1;
		}
		else
		{
			if (pl[i].X == b[i].X)
				pl[i + 1].X = max(pl[i].X - t[i + 1], b[i + 1].X);
			else
				pl[i + 1].X = max(pl[i].X, b[i + 1].X);
			pl[i + 1].Y = min(b[i + 1].Y, pl[i].Y);
		}
	}
	for (int i = 0; i < n; ++i)
	{
		if (pr[i + 1].X == -1 || pl[i].X == -1)
		{
			cout << "-1\n";
			continue;
		}
		if (i == 0)
		{
			if (pr[i + 1].X == b[i + 1].X)
				pr[i + 1].X = max(0, pr[i + 1].X - t[i + 1]);
			cout << pr[i + 1].X << '\n';
		}
		else if (i == n - 1)
		{
			if (pl[i].X == b[i].X)
				pl[i].X = max(0, pl[i].X - t[i + 1]);
			cout << pl[i].X << '\n';
		}
		else
		{
			if (pr[i + 1].X == b[i + 1].X)
				pr[i + 1].X = max(0, pr[i + 1].X - t[i + 1]);
			if (pl[i].X == b[i].X)
				pl[i].X = max(0, pl[i].X - t[i + 1]);
			if (max(pl[i].X, pr[i + 1].X) > min(pl[i].Y, pr[i + 1].Y))
				cout << "-1\n";
			else
				cout << max(pr[i + 1].X, pl[i].X) << '\n';
		}
	}
}