// 6_serversPackets.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

const int INF = (1e9) + 7;

struct Cut
{
	int L, R;

	Cut() :
		L(0), R(INF) {}
	Cut(int a, int b = -1) :
		L(a), R(b) {}
};

const int LEN = 200000;

Cut cut[LEN], bc[LEN], forw[LEN];
int n, wt[LEN];

Cut inter(Cut a, Cut b)
{
	if (a.L == -1 || b.L == -1)
		return Cut(-1);
	if (a.L > b.L)
		swap(a, b);
	if (a.R < b.L)
		return Cut(-1);
	return Cut(b.L, min(b.R, a.R));
}

int main()
{
	cin.tie(NULL);

	cin >> n;

	for (int i = 0; i < n; i++)
	{
		cin >> wt[i];
	}
	for (int i = 0; i < n - 1; i++)
		cin >> cut[i].L >> cut[i].R;

	bc[0] = Cut();
	for (int i = 1; i < n; i++)
	{
		//bc[i] = inter(bc[i - 1], Cut(max(0, cut[i - 1].L - wt[i]), cut[i - 1].R));
		bc[i] = inter(bc[i - 1], cut[i - 1]);
		//if (bc[i].L != -1)
		//	bc[i].L = max(0, bc[i].L - wt[i]);
		if (bc[i].L != -1 && bc[i].L == cut[i - 1].L)
			bc[i].L = max(0, bc[i].L - wt[i]);
	}
	forw[n - 1] = Cut();
	for (int i = n - 2; i >= 0; i--)
	{
		//forw[i] = inter(forw[i + 1], Cut(max(0, cut[i].L - wt[i]), cut[i].R));
		forw[i] = inter(forw[i + 1], cut[i]);
		//if (forw[i].L != -1)
		//	forw[i].L = max(0, forw[i].L - wt[i]);
		if (forw[i].L != -1 && forw[i].L == cut[i].L)
			forw[i].L = max(0, forw[i].L - wt[i]);
	}

	for (int i = 0; i < n; i++)
	{
		cout << inter(bc[i], forw[i]).L << '\n';
		cout.flush();
	}
	
	return 0;
}