#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <bitset>
#include <algorithm>
#define ll long long
#define mp make_pair
#define MOD 1000000007

using namespace std;

struct vect {
    ll x, y;
};

const int mx = 500;
ll n, q;
vector<pair<vect, ll> > p, a;

vect make_point(ll x, ll y) {
    vect res;
    res.x = x;
    res.y = y;
    return res;
}

vect make_vector(vect p1, vect p2) {
    vect res;
    res.x = p2.x - p1.x;
    res.y = p2.y - p1.y;
    return res;
}

ll p_scal(vect v1, vect v2) {
    return v1.x*v2.x + v1.y*v2.y;
}

ll p_vect(vect v1, vect v2) {
    return v1.x*v2.y - v1.y*v2.x;
}

bool clock(vect p1, vect p2, vect p3) {
    if (p_vect(make_vector(p1, p3), make_vector(p1, p2)) > 0)
        return 1;
    else
        return 0;
}

bool unclock(vect p1, vect p2, vect p3) {
    if (p_vect(make_vector(p1, p3), make_vector(p1, p2)) < 0)
        return 1;
    else
        return 0;
}

bool cmp(pair<vect, ll> p1, pair<vect, ll> p2) {
    return (p1.first.x < p2.first.x) || ((p1.first.x == p2.first.x) && (p1.first.y < p2.first.y));
}

void convix_hull(vector<pair<vect, ll> > &a) {
    if (a.size() < 3)
        return;
    sort(a.begin(), a.end(), &cmp);
    pair<vect, ll> p1 = a.front(), p2 = a.back();
    vector<pair<vect, ll> > up, down;
    up.push_back(p1);
    down.push_back(p1);
    for (int i = 1; i < a.size(); ++i) {
        if ((clock(p1.first, a[i].first, p2.first)) || (i == (a.size()-1))) {
            while ((up.size() >= 2)) {
                if (clock(up[up.size()-2].first, up[up.size()-1].first, a[i].first))
                    break;
                up.pop_back();
            }
            up.push_back(a[i]);
        }
        if ((unclock(p1.first, a[i].first, p2.first) || (i == (a.size()-1)))) {
            while (down.size() >= 2) {
                if (unclock(down[down.size()-2].first, down[down.size()-1].first, a[i].first))
                    break;
                down.pop_back();
            }
            down.push_back(a[i]);
        }
    }
    a.clear();
    for (int i = 0; i < up.size(); ++i) {
        a.push_back(up[i]);
    }
    for (int i = (down.size() - 2); i >= 1 ; --i) {
        a.push_back(down[i]);
    }
}

bool inside(vect p1, vect p2, vect p3, vect pp) {
    ll vct1 = p_vect(make_vector(p1, p2), make_vector(p1, pp));
    ll vct2 = p_vect(make_vector(p2, p3), make_vector(p2, pp));
    ll vct3 = p_vect(make_vector(p3, p1), make_vector(p3, pp));
    if ((vct1 > 0) && (vct2 > 0) && (vct3 > 0))
        return 1;
    if ((vct1 < 0) && (vct2 < 0) && (vct3 < 0))
        return 1;
    return 0;
}

void write(int p1, int p2, int p3) {
    printf("%s", "? 3 ");
    printf("%d", p1);
    printf("%c", ' ');
    printf("%d", p2);
    printf("%c", ' ');
    printf("%d", p3);
    printf("%c", '\n');
    fflush(stdout);
}

int main()
{
    string s;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    ll x, y;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        p.push_back({make_point(x, y), i+1});
        a.push_back({make_point(x, y), i+1});
    }
    convix_hull(p);
    cin >> q;
    for (int h = 0; h < q; ++h) {
        int p1, p2, p3;
        for (int i = 1; i < (p.size()-1); ++i) {
            write(p[0].second, p[i].second, p[i+1].second);
            cin >> s;
            if (s == "Yes") {
                p1 = p[0].second;
                p2 = p[i].second;
                p3 = p[i+1].second;
                break;
            }
        }
        vector<pair<vect, ll> > b;
        b.clear();
        for (auto i: a) {
            if (inside(a[p1-1].first, a[p2-1].first, a[p3-1].first, i.first))
                b.push_back(i);
        }
        while (!b.empty()) {
            a.clear();
            for (auto i: b)
                a.push_back(i);
            write(p1, p2, b[0].second);
            cin >> s;
            if (s == "Yes") {
                p3 = b[0].second;
                b.clear();
                for (auto i: a) {
                    if (inside(a[p1-1].first, a[p2-1].first, a[p3-1].first, i.first))
                        b.push_back(i);
                }
                continue;
            }
            write(p1, b[0].second, p3);
            cin >> s;
            if (s == "Yes") {
                p2 = b[0].second;
                b.clear();
                for (auto i: a) {
                    if (inside(a[p1-1].first, a[p2-1].first, a[p3-1].first, i.first))
                        b.push_back(i);
                }
                continue;
            }
            p1 = b[0].second;
            b.clear();
            for (auto i: a) {
                if (inside(a[p1-1].first, a[p2-1].first, a[p3-1].first, i.first))
                    b.push_back(i);
            }
        }
        printf("%s", "! 3 ");
        printf("%d", p1);
        printf("%c", ' ');
        printf("%d", p2);
        printf("%c", ' ');
        printf("%d", p3);
        printf("%c", '\n');
        fflush(stdout);
    }
    return 0;
}
