#include <bits/stdc++.h>

using namespace std;

struct Point
{
    long long x, y;
};

istream & operator >> (istream & in, Point & a)
{
    in >> a.x >> a.y;
    return in;
}

struct Vector
{
    long long x, y;
    Vector(Point a, Point b)
    {
        x = b.x - a.x;
        y = b.y - a.y;
    }
    long long operator * (Vector b)
    {
        return x * b.x + y * b.y;
    }

    long long operator % (Vector b)
    {
        return x * b.y - y * b.x;
    }
};

bool in(vector<Point> & our, Point a)
{
    long double ang = 0;
    for (int i = 0; i < our.size(); i++)
    {
        Vector AB = Vector(a, our[i]), AC = Vector(a, our[(i + 1) % our.size()]);
        ang += atan2(AB % AC, AB * AC);
    }
    ang = abs(ang);
    return abs(ang - M_PI * 2) < 1e-5;
}

vector<vector<int>> ques;
vector<Point> our;

bool check(vector<Point> & a)
{
    for (int i = 0; i < a.size(); i++)
    {
        Vector A = Vector(a[i], a[(i + 1) % a.size()]);
        for (int j = 0; j < a.size(); j++)
        {
            Vector B = Vector(a[i], a[j]);
            if (atan2(A % B, A * B) < 0)
                return false;
        }
    }
    return true;
}

void gen(vector<Point> made, vector<int> tp, set<int> left)
{
    if (made.size() > 3)
        return ;
    if (made.size() < 2)
    {
        auto it = left;
        for (auto e : it)
        {
            made.push_back(our[e]);
            tp.push_back(e + 1);
            left.erase(e);
            gen(made, tp, left);
            made.pop_back();
            tp.pop_back();
            left.insert(e);
        }
    } else
    {
        if (made.size() >= 3)
        {
            bool good = true;
            for (auto e : left)
                if (in(made, our[e]))
                    good = false;
            if (good && check(made))
            {
                ques.push_back(tp);
            }
        }
        auto p1 = made[made.size() - 2], p2 = made.back();
        auto it = left;
        for (auto e : it)
        {
            bool good = true;
            if (good)
            {
                left.erase(e);
                tp.push_back(e + 1);
                made.push_back(our[e]);
                gen(made, tp, left);
                made.pop_back();
                tp.pop_back();
                left.insert(e);
            }
        }
    }
}

int main() {
    int n;
    cin >> n;
    our.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> our[i];
    }
    set<int> temp;
    for (int i = 0; i < n; i++)
        temp.insert(i);
    gen(vector<Point>(), vector<int>(), temp);
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        for (auto e : ques) {
            cout << "? " << e.size() << " ";
            for (auto u : e)
                cout << u << " ";
            cout << endl;
            string res;
            cin >> res;
            if (res == "Yes")
            {
                cout << "! " << e.size() << " ";
                for (auto u : e)
                    cout << u << " ";
                cout << endl;
                break;
            }
        }
    }
}