#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>

using namespace std;
const int MAXN = 1e6 + 10;
const int MAXST = 30;

struct V{
    bool nrm;
    int first;
    int second;
    int mask[MAXST];
};

struct Tree{
    V tree[MAXN * 4];

    void recalc(int v){
        int cl = v * 2 + 1;
        int cr = v * 2 + 2;
        bool fl = false;

        if (!tree[cl].nrm || !tree[cr].nrm){
            tree[v].nrm = false;
            tree[v].first = tree[cl].first;
            tree[v].second = tree[cr].second;
            return;
        }

        for (int i = MAXST - 1; i >= 0; --i){
            int bit_cl = tree[cl].second & (1 << i);
            int bit_cr = tree[cr].first & (1 << i);

            int rez = tree[cl].mask[i] & tree[cr].mask[i];

            if (fl){
                if (rez == 0){
                    tree[v].nrm = false;
                    tree[v].first = tree[cl].first;
                    tree[v].second = tree[cr].second;
                    return;
                } else {
                    tree[v].mask[i] = rez;
                }
            } else {
                if (rez == 0){
                    tree[v].nrm = false;
                    tree[v].first = tree[cl].first;
                    tree[v].second = tree[cr].second;
                    return;
                } else if (rez == 3){
                    if (bit_cl == bit_cr){
                        tree[v].mask[i] = 3;
                    } else if (bit_cl < bit_cr){
                        tree[v].mask[i] = 1;
                    } else {
                        tree[v].mask[i] = 2;
                    }
                } else if (rez == 1){
                    tree[v].mask[i] = 1;
                } else if (rez == 2){
                    tree[v].mask[i] = 2;
                }

                if (tree[v].mask[i] == 1){
                    if (bit_cl < bit_cr){
                        fl = true;
                    } else if (bit_cl > bit_cr){
                        tree[v].nrm = false;
                        tree[v].first = tree[cl].first;
                        tree[v].second = tree[cr].second;
                        return;
                    }
                } else if (tree[v].mask[i] == 2){
                    if (bit_cl > bit_cr){
                        fl = true;
                    } else if (bit_cl < bit_cr){
                        tree[v].nrm = false;
                        tree[v].first = tree[cl].first;
                        tree[v].second = tree[cr].second;
                        return;
                    }
                }
            }
        }

        tree[v].nrm = true;
        tree[v].first = tree[cl].first;
        tree[v].second = tree[cr].second;
    }

    void Build(int v, int l, int r, int* mas){
        if (l + 1 == r){
            tree[v].nrm = true;
            tree[v].first = mas[l];
            tree[v].second = mas[l];

            for (int i = 0; i < MAXST; ++i){
                tree[v].mask[i] = 3;
            }

            return;
        }

        int m = (l + r) / 2;

        Build(v * 2 + 1, l, m, mas);
        Build(v * 2 + 2, m, r, mas);

        recalc(v);
    }

    void Upd(int v, int cl, int cr, int pos, int zn){
        if (pos >= cr || cl > pos){
            return;
        }

        if (cl + 1 == cr){
            tree[v].first = zn;
            tree[v].second = zn;
        } else {
            int cm = (cl + cr) / 2;

            Upd(v * 2 + 1, cl, cm, pos, zn);
            Upd(v * 2 + 2, cm, cr, pos, zn);

            recalc(v);
        }
    }

    int Get(){
        if (!tree[0].nrm){
            return -1;
        } else {
            int ans = 0;

            for (int i = 0; i < MAXST; ++i){
                if (tree[0].mask[i] == 2){
                    ans |= (1 << i);
                }
            }

            return ans;
        }
    }
};

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    int mas[MAXN];

    for (int i = 0; i < n; ++i){
        cin >> mas[i];
    }

    Tree DO;
    DO.Build(0, 0, n, mas);

    cout << DO.Get() << '\n';

    int q;
    cin >> q;

    for (int i = 0; i < q; ++i){
        int pos, x;
        cin >> pos >> x;
        pos--;

        DO.Upd(0, 0, n, pos, x);
        cout << DO.Get() << '\n';
    }

    cout << endl;
    return 0;
}
