#include <bits/stdc++.h>
#define int long long

using namespace std;

struct pt
{
    int x, y, ind;
};

vector <pt> e;

int vect(int x1, int y1, int x2, int y2)
{
    return x1 * y2 - x2 * y1;
}

pt s;

bool operator < (const pt &a, const pt &b)
{
    return vect(a.x - s.x, a.y - s.y, b.x - s.x, b.y - s.y) < 0;
}

vector <pt> hull(vector <pt> e)
{
    if (e.size() <= 3)
    {
        return e;
    }
    sort(e.begin(), e.end(), [] (const pt &a, const pt &b)
    {
        return a.x < b.x;
    });
    s = e[0];
    sort(e.begin() + 1, e.end());
    stack <pt> st;
    for (auto c : e)
    {
        while (st.size() > 1)
        {
            pt a = c;
            pt b = st.top();
            st.pop();
            pt c = st.top();
            st.push(b);
            if (vect(b.x - c.x, b.y - c.y, a.x - b.x, a.y - b.y) > 0)
            {
                st.pop();
            }
            else
            {
                break;
            }
        }
        st.push(c);
    }
    e.clear();
    while (st.size() > 0)
    {
        e.push_back(st.top());
        st.pop();
    }
    return e;
}

main()
{
    int n;
    cin >> n;
    vector <int> x(n + 1), y(n + 1);
    for (int i = 1; i <= n; i++)
    {
        cin >> x[i] >> y[i];
        e.push_back({x[i], y[i], i});
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        vector <pt> cur = e;
        vector <pt> he = hull(cur);
        vector <bool> used(n + 1);
        //while (cur.size() != 3)
        {
            for (auto c : he)
            {
                if (!used[c.ind])
                {
                    auto t = cur;
                    int lel = -1;
                    for (int i = 0; i < (int) cur.size(); i++)
                    {
                        if (cur[i].ind == c.ind)
                        {
                            lel = i;
                            break;
                        }
                    }
                    t.erase(t.begin() + lel);
                    auto pe = hull(t);
                    cout << "? ";
                    cout << pe.size() << ' ';
                    for (auto c : pe)
                    {
                        cout << c.ind << ' ';
                    }
                    cout << endl;
                    string s;
                    cin >> s;
                    if (s == "Yes")
                    {
                        cur = t;
                        he = pe;
                        break;
                    }
                    else
                    {
                        used[c.ind] = true;
                        continue;
                    }
                }
            }
        }
        cout << "! " << 3 << endl;
        for (auto c : cur)
        {
            cout << c.ind << ' ';
        }
        cout << endl;
    }
}
