#include <iostream>
#include <set>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <climits>
#include <vector>
#include <functional>

using namespace std;

typedef unsigned int index;

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	ios::sync_with_stdio(false);
	size_t n, m;
	cin >> n >> m;
	vector<index> g(n + m, (index)-1);
	vector<bool> used(n + m);
	vector<int> c1(n);
	vector<long long> c2(m + 1);
	vector<index> md1(n);
	for (index i = 0; i < n; i++)
	{
		cin >> md1[i];
		md1[i]--;
	}
	for (index i = 0; i < n; i++)
	{
		cin >> c1[i];
	}
	for (index i = 0; i < m; i++)
	{
		index x;
		cin >> x;
		x--;
		g[x] = i;
	}
	for (index i = 0; i < m; i++)
	{
		cin >> c2[i + 1];
		c2[i + 1] += c2[i];
	}
	long long bans = -1;
	index l1 = 0, l2 = 0, r1 = 0, r2 = 0;
	for (index i1 = 0; i1 < n; i1++)
	{
		set<pair<pair<index, size_t>, long long>> me = {{{0, m}, c2[m]}};
		set<pair<long long, pair<index, size_t>>> vs = {{c2[m], {0, m}}};
		long long sum = 0;
		for (index j = i1; j <= n; j++)
		{
			if (vs.size() > 0)
			{
				auto cur = *vs.rbegin();
				if (cur.first + sum > bans)
				{
					bans = cur.first + sum;
					l1 = i1;
					r1 = j - 1;
					l2 = cur.second.first;
					r2 = (index)cur.second.second - 1;
				}
			}
			if (j < n)
			{
				sum += c1[j];
				if (g[md1[j]] != (index)-1)
				{
					index del = g[md1[j]];
					auto svs = me.upper_bound({{del, 0}, 0});
					svs--;
					auto sv = *svs;
					vs.erase({sv.second, sv.first});
					me.erase(sv);
					if (del > sv.first.first)
					{
						me.insert({{sv.first.first, (size_t)del}, c2[del] - c2[sv.first.first]});
						vs.insert({c2[del] - c2[sv.first.first], {sv.first.first, (size_t)del}});
					}
					if (del + 1 < sv.first.second)
					{
						me.insert({{del + 1, sv.first.second}, -c2[del + 1] + c2[sv.first.second]});
						vs.insert({-c2[del + 1] + c2[sv.first.second], {del + 1, sv.first.second}});
					}
				}
			}
		}
	}
	cout << bans << endl;
	if (l1 <= r1 and l1 <= n and r1 <= n)
	{
		cout << l1 + 1 << " " << r1 + 1 << endl;
	}
	else
	{
		cout << "0 0" << endl;
	}
	if (l2 <= r2 and l2 <= m and r2 <= m)
	{
		cout << l2 + 1 << " " << r2 + 1 << endl;
	}
	else
	{
		cout << "0 0" << endl;
	}
}
