#include <random>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <string>

#pragma comment(linker, "/STACK:512000000")

using namespace std;
#define coord int64_t

int rard() {
	return rand() * RAND_MAX + rand();
}

struct vec {
	int inf;
	coord x, y;
	vec() : x(), y(), inf() {};
	vec(coord x, coord y) : x(x), y(y), inf() {}
	coord l2() {
		return x * x + y * y;
	}
};

bool operator==(vec a, vec b) {
	return a.x == b.x && a.y == b.y;
}
vec operator+(vec a, vec b) {
	return vec(a.x + b.x, a.y + b.y);
}
vec operator-(vec a, vec b) {
	return vec(a.x - b.x, a.y - b.y);
}
int64_t cross(vec a, vec b) {
	return a.x * b.y - a.y * b.x;
}

vec comprel;
bool compang(vec a, vec b) {
	a = a - comprel; b = b - comprel;
	if (a.x == 0 && a.y == 0)
		return true;
	if (cross(a, b) != 0)
		return cross(a, b) > 0;
	return a.l2() < b.l2();
}
bool compc(vec a, vec b) {
	if (a.x != b.x)
		return a.x < b.x;
	return a.y < b.y;
}

bool inters(vec a0, vec a1, vec b0, vec b1) {
	return (cross(b0 - a0, a1 - a0) > 0) == (cross(a1 - a0, b1 - a0) > 0) &&
		(cross(a0 - b0, b1 - b0) > 0) == (cross(b1 - b0, a1 - b0) > 0);
}

bool ask(vector<int> v) {
	cout << "? " << v.size() << ' ';
	for (int &i : v) cout << i + 1 << ' ';
	cout << endl;
	string r; cin >> r;
	return r == "Yes";
}
void win(vector<int> v) {
	cout << "! " << v.size() << ' ';
	for (auto& i : v) cout << i + 1 << ' ';
	cout << endl;
	return;
}

void sortangvec(vector<vec> &v) {
	if (v.size() == 0)
		return;
	int minp = 0;
	for (int i = 1; i < v.size(); i++) {
		if (compc(v[i], v[minp]))
			minp = i;
	}
	comprel = v[minp];
	//for (int i = 0; i < v.size(); i++)
	//	v[i].inf = i;
	sort(v.begin(), v.end(), compang);
}

vector<int> conv(vector<vec> v) {
	if (v.empty())
		return vector<int>();
	sortangvec(v);

	vector<int> st;
	for (int i = 0; i < v.size(); i++) {
		if (st.size() < 2) {
			st.push_back(i);
			continue;
		}
		int l = st.size() - 1;
		while (st.size() >= 2 && cross(v[st[l]] - v[st[l - 1]], v[i] - v[st[l]]) <= 0) {
			st.pop_back();
			l = st.size() - 1;
		}
	}
	for (auto& i : st)
		i = v[i].inf;
	return st;
}

bool isin(vector<vec> v, vec p) {
	int n = v.size();
	int c = 0;
	for (int i = 0; i < v.size(); i++) {
		if (p == v[i]) return true;

		int j = i + 1;
		if (j >= n) j -= n;

		vec a = v[i], b = v[j];
		if (a.y > b.y) swap(a, b);
		if (a.y < p.y && b.y >= p.y)
			if (a.x * (b.y - p.y) + b.x * (p.y - a.y) > p.y * (b.y - a.y))
				c++;
	}
	return c & 1;
}

pair<vector<int>, vector<int>> convq(vector<vec> v, int q = -1) {
	if (q == -1)
		q = max(3, (int)v.size() / 2);

	if (v.empty())
		return{ vector<int>(), vector<int>() };

	int minp = 0;
	for (int i = 1; i < v.size(); i++) {
		if (compc(v[i], v[minp]))
			minp = i;
	}
	comprel = v[minp];
	for (int i = 0; i < v.size(); i++)
		v[i].inf = i;
	sort(v.begin(), v.end(), compang);

	vector<int> st;
	vector<int> take;
	for (int i = 0; i < v.size(); i++) {
		if (st.size() < 2) {
			st.push_back(i);
			continue;
		}
		int l = st.size() - 1;
		while (st.size() >= 2 && cross(v[st[l]] - v[st[l - 1]], v[i] - v[st[l]]) <= 0) {
			st.pop_back();
			l = st.size() - 1;
		}
	}

	int i0 = st[0]; // == 0
	vector<int> take0;
	for (int i = 0; i < v.size(); i++) {
		take.push_back(v[i].inf);
		if (take.size() >= q || i0 + 2 >= st.size())
			break;
		if (st[i0] == i)
			i0++;
	}
	vector<int> take1(1, 0);
	for (int i = i0; i < v.size(); i++) {
		take.push_back(v[i].inf);
		if (i0 < st.size() && st[i0] == i)
			i0++;
	}

	return{ take0, take1 };
}
/*
vector<int> randq(vector<vec> v) {
	for (int i = 0; i < v.size(); i++)
		v[i].inf = i;
	while (true) {
		int q = 3 + rand() % 7;
		if (q > v.size()) q = max(3, (int)v.size() - 2);

		for (int i = 0; i < 1; i++) {
			int p = rard() % ((int)v.size() - i);
			swap(v[i], v[p]);
		}

		vector<vec> w(q);
		vector<int> a(q);
		for (int i = 0; i < q; i++) {
			a[i] = v[i].inf;
			w[i] = v[i];
		}
		auto b = conv(w);
		vector<int>  t_ask(b.size());
		for (int i = 0; i < )

		if (ask(a)) {
			vector<vec> vv(q);
			for (int i = 0; i < q; i++)
				vv.push_back(v[i]);

			for (int i = q; i < v.size(); i++)
				if (isin(vv, v[i]))
					a.push_back(v[i].inf);


		}
	}
}
*/

void all(vector<vec> v) {
	if (v.size() < 3)
		return;
	sortangvec(v);
	for (int i = 1; i + 1 < v.size(); i++) {
		vector<int> as(3);
		as[0] = v[0].inf;
		as[1] = v[i].inf;
		as[2] = v[i + 1].inf;
		if (ask(as)) {
			win(as);
			return;
		}
	}
	for (int i = 0; i + 1 < v.size(); i++)
		v[i] = v[i + 1];
	v.pop_back();
	all(v);
	int deb = 34;
	return;
}

void solve(int n, vector<vec> v) {
	all(v);
	return;

	while (true) {
		vector<int> con = conv(v);
		if (con.size() == v.size()) {
			vector<int> as;
			for (auto& i : v) as.push_back(i.inf);
			win(as);
			return;
		}

		if (con.size() < 4) {
			all(v);
			return;
		}
		
		int a1 = 0, a2 = con.size() / 2;
		vector<int> id;
		vector<vec> res;
		for (int ad = 0; ad < a2 - a1; ad++) {
			int pos = a1 + ad;
			if (pos >= con.size())
				pos -= con.size();
			id.push_back(v[con[pos]].inf);
			res.push_back(v[con[pos]]);
		}

		if (!ask(id)) {

		}

		/*bool fl = true;
		for (int i = 0; fl && i < con.size(); i++) {
			for (int d = 0; fl && d + 3 < con.size(); d++) {
				int j = i + 2 + d;
				if (j > con.size()) j -= con.size();

				for (int k = 0; fl && k < con.size(); k++) {
					int k1 = (k + 1);
					if (k1 > con.size()) k1 -= con.size();

					if (k == i || k == j || k1 == i || k1 == j) continue;

					vector<int> id;
					vector<vec> res;
					for (int ad = 0; ad < d; ad++) {
						int pos = i + ad;
						if (pos >= con.size())
							pos -= con.size();
						res.push_back()
						id.push_back(v[con[pos]].inf);
					}

					if (ask(id)) {
						fl = false;
					}
				}
			}
		}*/
		
	}

}

int main() {
	ios::sync_with_stdio(false);
#ifdef _DEBUG
	ifstream cin("input.in");
	ofstream cout("output.out");
#endif
	srand(128313);
	int n;
	cin >> n;
	vector<vec> c(n);
	for (int i = 0; i < n; i++) {
		cin >> c[i].x >> c[i].y;
		c[i].inf = i;
	}
	int q;
	cin >> q;
	for (int qu = 0; qu < q; qu++) {
		solve(n, c);
	}

	return 0;
}