#include <ctime>
#include <random>
#include <map>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#define lint int64_t
#define int int64_t
using namespace std;
#define all(x) (x).begin(), (x).end()

const lint C = 1000000000;
const lint inf = 100000000000000000;

vector<lint> pa, pb;

struct border {
	set<int> bord;
	set<pair<lint, pair<int, int>>> seg;
	border(int n) {
		bord.insert(-1);
		bord.insert(n);
		seg.insert({ pb.back(),{ -1, n } });
	}

	void add(int b) {
		if (b != -1) {
			auto nextb_it = bord.upper_bound(b);
			auto prevb_it = nextb_it;
			prevb_it--;

			int prevb = *prevb_it;
			int nextb = *nextb_it;

			lint sum = pb[nextb] - pb[prevb + 1];
			seg.erase({ sum,{ prevb, nextb } });

			bord.insert(b);
			seg.insert({ pb[b] - pb[prevb + 1] ,{ prevb, b } });
			seg.insert({ pb[nextb] - pb[b + 1] ,{ b, nextb } });
		}
	}

	pair<lint, pair<int, int>> top() {
		return *(--seg.end());
	}
};


int32_t main() {
	ios::sync_with_stdio(false);
#ifdef _DEBUG
	//ifstream cin ("a.in");
	ofstream cout("a.out");
	freopen("a.in", "r", stdin);
#endif

	auto ttt = clock();
	int n, m;
	cin >> n >> m;
	vector<int> a(n), b(m);
	vector<lint> x(n), y(m);
	for (auto& i : a) cin >> i;
	for (auto& i : x) cin >> i;
	for (auto& i : b) cin >> i;
	for (auto& i : y) cin >> i;

	reverse(all(a));
	reverse(all(x));
	reverse(all(b));
	reverse(all(y));

	srand(241235996);
	bool swapped = false;
	if (true) {
		swap(n, m);
		swap(a, b);
		swap(x, y);
		swapped = true;
	}

	pa.resize(n + 1);
	pb.resize(m + 1); // sum[0, r) = pb[r]; sum[l, r) = sum[r] - sum[l]
	for (int i = 0; i < n; i++)
		pa[i + 1] = pa[i] + x[i];
	for (int i = 0; i < m; i++)
		pb[i + 1] = pb[i] + y[i];

	vector<int> bpos(n);
	map<int, int> tmap;
	for (int i = 0; i < m; i++) {
		tmap[b[i]] = i;
	}
	for (int i = 0; i < n; i++) {
		if (tmap.count(a[i]))
			bpos[i] = tmap[a[i]];
		else bpos[i] = -1;
	}

	lint maxr = -1;
	int la = 0, ra = 0, lb = 0, rb = 0;

	int mrprev = 1;
	for (int l = 0; l < n; l++) {
		if (clock() - ttt > CLOCKS_PER_SEC * 7 / 9)
			break;
		lint asum = 0;

		border bor(m);
		int mv = -1;
		for (int r = l + 1; r <= n; r++) {
			asum += x[r - 1];

			int addb = bpos[r - 1];
			if (addb != -1) {
				bor.add(addb);
			}

			auto bv = (*(--bor.seg.end()));
			lint bsum = bv.first;

			if (maxr > bsum + pa[n] - pa[l])
				break;
			if (maxr < asum + bsum) {
				maxr = asum + bsum;
				la = l;
				ra = r - 1;
				lb = bv.second.first + 1;
				rb = bv.second.second - 1;

				if (lb > rb)
					lb = rb = 0;
			}
		}
	}

	if (swapped) {
		swap(la, lb);
		swap(ra, rb);
		swap(pa, pb);
		swap(n, m);
		swap(a, b);
		swap(x, y);
	}
	if (true) {
		la = n - la - 1;
		ra = n - ra - 1;
		lb = m - lb - 1;
		rb = m - rb - 1;
		swap(la, ra);
		swap(lb, rb);
	}

	if (pb.back() >= maxr) {
		maxr = pb.back();
		la = -1; ra = -1;
		lb = 0; rb = m - 1;
	}
	if (pa.back() >= maxr) {
		maxr = pa.back();
		la = 0; ra = n - 1;
		lb = -1; rb = -1;
	}



	cout << maxr << '\n';
	cout << la + 1 << ' ' << ra + 1 << '\n';
	cout << lb + 1 << ' ' << rb + 1 << '\n';

	return 0;
}