#include <bits/stdc++.h>
using namespace std;
 
#define mp(a, b) make_pair((a), (b))
#define int int64_t

struct point
{
    int x, y;
    bool operator < (const point& a) const
    {
        return y < a.y || (y == a.y && x < a.x);
    }
    point(int x1, int y1)
    {
        x = x1;
        y = y1;
    }
    point()
    {
        x = 0;
        y = 0;
    }
    bool operator == (const point& b) const
    {
        return x == b.x && y == b.y;
    }
};

vector < point > coord;

int pow2(int i)
{
    return i * i;
}

struct Vector
{
    int x, y;
    Vector(const point& a, const point& b)
    {
        x = b.x - a.x;
        y = b.y - a.y;
    }
};

istream& operator >> (istream&, point&);
ostream& operator << (ostream&, const point&);
istream& operator >> (istream&, Vector&);
ostream& operator << (ostream&, const Vector&);

int operator % (const Vector& a, const Vector& b)
{
    return a.x * b.y - a.y * b.x;
}

int sign(int i)
{
    return i == 0 ? 0 : (i > 0 ? 1 : -1);
}

point for_cmp;

int dist(const point& a, const point& b)
{
    return pow2(b.x - a.x) + pow2(b.y - a.y);
}

bool cmp(int a, int b)
{
    Vector a1(for_cmp, coord[a]), b1(for_cmp, coord[b]);
    return mp(atan2(a1.y, a1.x), dist(for_cmp, coord[a])) < mp(atan2(b1.y, b1.x), dist(for_cmp, coord[b]));
}

void fix(vector < int >& a)
{
    int res = 0;
    for (int i = 1; i < (int)a.size(); ++i)
    {
        if (coord[a[i]] < coord[a[res]])
        {
            res = i;
        }
    }
    for_cmp = coord[a[res]];
    sort(a.begin(), a.end(), cmp);
    vector < int > stack;
    stack.push_back(a[0]);
    for (int i = 1; i < (int)a.size(); ++i)
    {
        while (stack.size() > 1 && Vector(coord[stack[stack.size() - 2]], coord[stack.back()]) % Vector(coord[stack[stack.size() - 2]], coord[a[i]]) < 0)
        {
            stack.pop_back();
        }
        stack.push_back(a[i]);
    }
    a = stack;
}

template < typename type >
bool notin(const vector < type >& a, const type& b)
{
    int i = 0;
    while (i < (int)a.size() && a[i] != b) ++i;
    return i == (int)a.size();
}

bool check_intersection(int x, int y, point a, point b)
{
    if (a.y > b.y)
    {
        swap(a, b);
    }
    if (a.x == b.x)
    {
        if (a.x < x)
        {
            return false;
        }
        if (a.y <= y && b.y >= y)
        {
            return true;
        }
    }
    if (a.y > y || b.y < y) return false;
    return Vector(a, point(x, y)) % Vector(a, b) < 0;
}

bool checkin(vector < int >& needed, const point& a)
{
    int cnt = 0;
    needed.push_back(needed[0]);
    for (int i = 0; i + 1 < (int)needed.size(); ++i)
    {
        cnt += check_intersection(a.x, a.y, coord[needed[i]], coord[needed[i + 1]]);
    }
    needed.pop_back();
    return cnt % 2;
}

vector < int > check(vector < int >& needed)
{
    vector < int > res;
    for (int i = 0; i < (int)coord.size(); ++i)
    {
        if (notin(needed, i))
        {
            if (checkin(needed, coord[i]))
            {
                res.push_back(i);
            }
        }
    }
    return res;
}

istream& operator >> (istream& in, point& a)
{
    in >> a.x >> a.y;
    return in;
}

ostream& operator << (ostream& out, const point& a)
{
    out << a.x << "-" << a.y;
    return out;
}

istream& operator >> (istream& in, Vector& a)
{
    in >> a.x >> a.y;
    return in;
}

ostream& operator << (ostream& out, const Vector& a)
{
    out << a.x << "-" << a.y;
    return out;
}

bool cmpx(int a, int b)
{
    return coord[a].x < coord[b].x;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    coord.resize(n);
    for (auto& x : coord)
    {
        cin >> x;
    }
    int q;
    cin >> q;
    for (int qwe = 0; qwe < q; ++qwe)
    {
        vector < int > needed(n);
        for (int i = 1; i < n; ++i)
        {
            needed[i] = i;
        }
        while (true)
        {
            fix(needed);
            vector < int > needed1 = check(needed);
            if (needed1.size() == 0)
            {
                cout << "! " << needed.size();
                for (auto& x : needed)
                {
                    cout << " " << x + 1;
                }
                cout << endl;
                break;
            }
            vector < int > all_needed(needed.size() + needed1.size());
            copy(needed.begin(), needed.end(), all_needed.begin());
            copy(needed1.begin(), needed1.end(), all_needed.begin() + needed.size());
            sort(all_needed.begin(), all_needed.end(), cmpx);
            vector < int > need_try(all_needed.size() / 2);
            copy(all_needed.begin(), all_needed.begin() + all_needed.size() / 2, need_try.begin());
            string ans;
            if (need_try.size() > 2)
            {
            cout << "? " << need_try.size();
            for (auto& x : need_try)
            {
                cout << " " << x + 1;
            }
            cout << endl;
            cin >> ans;
            }
            else
            {
                ans = "No";
            }
            if (ans == "Yes")
            {
                needed = need_try;
            }
            else
            {
                int res1 = 0;
                for (int i = 1; i < (int)need_try.size(); ++i)
                {
                    if (coord[need_try[res1]].y < coord[need_try[i]].y)
                    {
                        res1 = i;
                    }
                }
                needed.resize(all_needed.size() - need_try.size());
                copy(all_needed.begin() + need_try.size(), all_needed.end(), needed.begin());
                needed.push_back(need_try[res1]);
                int res2 = 0;
                for (int i = 1; i < (int)need_try.size(); ++i)
                {
                    if (coord[need_try[res2]].y > coord[need_try[i]].y)
                    {
                        res1 = i;
                    }
                }
                if (res2 != res1)
                {
                    needed.push_back(need_try[res2]);
                }
            }
        }
    }
    return 0;
}
