#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <numeric>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const ll dd = (ll)1e6 + 7;
const ll inf = (ll)2e18 + 7;

struct edge {
	ll to, tim;
};
vector<edge> G[dd];

pair<ll, ll> d[dd];

void dijkstra() {
	fill(d, d + dd, make_pair(inf, -inf));
	d[0] = { 0, 0 };
	priority_queue<pair<ll, ll> > Q;
	Q.push({ 0, 0 });
	while ((ll)Q.size()) {
		ll v = Q.top().second, dist = -Q.top().first;
		Q.pop();
		pair<ll, ll> tmp;
		for (auto to : G[v]) {
			if (d[to.to] > (tmp = make_pair(d[v].first + to.tim, d[v].second + to.tim * to.tim))) {
				d[to.to] = tmp;
				Q.push({ -d[to.to].first, to.to });
			}
		}
	}
}

int solve() {
	ll n, m;
	scanf("%lld %lld", &n, &m);
	for (ll i = 0; i < m; ++i) {
		ll sz, lst = -1, t, to;
		scanf("%lld", &sz);
		for (ll i = 0; i < sz; ++i) {
			if (lst == -1) scanf("%lld", &lst), --lst;
			scanf("%lld %lld", &t, &to);
			G[lst].push_back({ to - 1, t });
		}
	}
	dijkstra();
	printf("%lld %lld\n", d[n - 1].first, d[n - 1].second);
	return 0;
}