#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define size(a) (int(a.size()))

using namespace std;

typedef long long llong;
const llong inf = (llong) 1e9 + 7ll;
const llong linf = (llong) 1e18 + 7ll;

static char buff[(int) 1e6 + 17];
const int maxn = (int) 1e6 + 17;

struct edge
{
    int u;
    llong w, ww;
    edge() { }
    edge(int u, int w) : u(u), w(w), ww(w * w) { }
};

struct cmp
{
    const bool operator()(pair< pair<llong, llong>, int> a, pair< pair<llong, llong>, int> b) const
    {
        if (a.first == b.first)
            return a.second < b.second;

        return a.first.first < b.first.first || (a.first.first == b.first.first && a.first.second > b.first.second);
    }
};

int n, m;
vector<edge> g[maxn];
pair<llong, llong> d[maxn];

bool read()
{
    if (scanf("%d %d", &n, &m) != 2)
        return false;

    for (int i = 0; i < m; ++i)
    {
        int k;
        scanf("%d", &k);
        vector< pair<int, llong> > v;

        for (int j = 0; j < k; ++j)
        {
            int vv;
            llong tt;
            scanf("%d %lld", &vv, &tt);
            v.push_back(make_pair(vv - 1, tt));
        }

        int vv;
        scanf("%d", &vv);
        --vv;

        for (int j = 0; j < k; ++j)
        {
            llong w = v[j].second;

            for (int jj = j + 1; jj < k; ++jj)
            {
                g[v[j].first].push_back(edge(v[jj].first, w));
                w += v[jj].second;
            }

            g[v[j].first].push_back(edge(vv, w));
        }
    }

    return true;
}

void solve()
{
    for (int i = 0; i < n; ++i)
        d[i] = make_pair(linf, -1);

    multiset< pair< pair<llong, llong>, int>, cmp> st;
    d[0] = make_pair(0, 0);
    st.insert(make_pair(make_pair(0, 0), 0));

    for (; !st.empty(); )
    {
        pair< pair<llong, llong>, int> cur = *st.begin();
        st.erase(st.begin());

        if (cur.first != d[cur.second])
            continue;

        int v = cur.second;
        llong w = cur.first.first;
        llong ww = cur.first.second;

        for (auto to : g[v])
            if (d[to.u].first > w + to.w || (d[to.u].first == w + to.w && d[to.u].second < ww + to.ww))
            {
                d[to.u].first = w + to.w;
                d[to.u].second = ww + to.ww;
                st.insert(make_pair(d[to.u], to.u));
            }
    }

    printf("%lld %lld\n", d[n - 1].first, d[n - 1].second);
}

int main()
{
#ifdef SEREZHKA
    freopen("file.in", "r", stdin);
#endif // SEREZHKA

    while (read())
        solve();

    return 0;
}
