#include <bits/stdc++.h>

using namespace std;
#define all(x) (x).begin(),(x).end()
typedef long long ll;
typedef long double ld;

const ld eps = 1e-12;
const ll inf = numeric_limits<ll>::max() / 2 - 100;
const ll maxn = 1234;

struct edge {
    ll to;
    ll t;
};

ll n, m;
map<ll, edge> edges[maxn];
map<ll, edge> pedges[maxn];
bool used[maxn];
ll distfrom[maxn];
ll distto[maxn];
ll dp[maxn];

ll getans(ll v) {
    if (v == 0) return 0;
    if (dp[v] != -1) return dp[v];
    ll ans = 0;
    ll curd = 0;
    ll cur = v;
    for (auto i : pedges[cur]) {
        curd = 0;
        cur = v;
        while (true) {
            if (!pedges[cur].count(i.first)) break;
            curd += pedges[cur][i.first].t;
            cur = pedges[cur][i.first].to;
            if (distfrom[cur] + curd > distfrom[v]) {
                break;
            } else {
                ans = max(ans, curd * curd + getans(cur));
            }
        }
    }
    return dp[v] = ans;
}

int run() {
    for (int i = 0; i < maxn; ++i) {
        dp[i] = -1;
    }
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        ll s;
        cin >> s;
        ll predv = -1;
        cin >> predv;
        predv--;
        for (int j = 1; j < 2 * s + 1; j += 2) {
            ll v, t;
            cin >> t >> v;
            v--;
            edge e;
            e.to = v;
            e.t = t;
            edges[predv][i] = e;
            e.to = predv;
            pedges[v][i] = e;
            predv = v;
        }
    }
    set<pair<ll, ll>> st;
    st.insert(make_pair(0, 0));
    while (!st.empty()) {
        ll curlen = st.begin()->first;
        ll curv = st.begin()->second;
        st.erase(st.begin());
        if (used[curv]) continue;
        distfrom[curv] = curlen;
        used[curv] = true;
        for (auto i : edges[curv]) {
            if (!used[i.second.to]) {
                st.insert(make_pair(curlen + i.second.t, i.second.to));
            }
        }
    }
    memset(used, 0, sizeof(used));
    st.insert(make_pair(0, n - 1));
    while (!st.empty()) {
        ll curlen = st.begin()->first;
        ll curv = st.begin()->second;
        st.erase(st.begin());
        if (used[curv]) continue;
        distto[curv] = curlen;
        used[curv] = true;
        for (auto i : pedges[curv]) {
            if (!used[i.second.to]) {
                st.insert(make_pair(curlen + i.second.t, i.second.to));
            }
        }
    }
    memset(used, 0, sizeof(used));
    cout << distfrom[n - 1] << " ";
    cout << getans(n - 1);
    return 0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}