#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>

using namespace std;

typedef pair<int, int> pii;
typedef vector<int> ints;
typedef vector<char> chars;
typedef vector<pii> piis;

int n, q;
piis ps;

int prod(pii v1, pii v2) {
    return v1.first * v2.second - v1.second * v2.first;
}

pii v(pii f, pii s) {
    return {f.first - s.first, f.second - s.second};
}

bool inside(pii v1, pii v2, pii v3, pii p) {
    pii a1 = v(v2, v1);
    pii a2 = v(v3, v2);
    pii a3 = v(v1, v3);
    pii b1 = v(p, v1);
    pii b2 = v(p, v2);
    pii b3 = v(p, v3);

    int s1 = prod(v(v2, v1), v(v3, v1));
    int s2 = prod(a1, b1) + prod(a2, b2) + prod(a3, b3);
    return abs(s1) == abs(s2);
}

void init() {
    cin >> n;
    ps.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> ps[i].first >> ps[i].second;
    }
    cin >> q;
}

bool ask(int i, int j, int k) {
    cout << "? 3 " << (i + 1) << ' ' << (j + 1) << ' ' << (k + 1) << endl;
    string resp;
    cin >> resp;
    return resp == "Yes";
}

void finish(int i, int j, int k) {
    cout << "! 3 " << (i + 1) << ' ' << (j + 1) << ' ' << (k + 1) << endl;
}


int main() {
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

//    cerr << inside({1, 1}, {2, 4}, {4, 4}, {2, 3});

    init();
    for (int t = 0; t < q; ++t) {
        bool fin = false;
        for (int i = 0; i < n && !fin; ++i) {
            for (int j = i + 1; j < n && !fin; ++j) {
                for (int k = j + 1; k < n && !fin; ++k) {
                    bool ok = true;
                    for (int l = 0; l < n; ++l) {
                        if (l != i && l != j && l != k) {
                            if (inside(ps[i], ps[j], ps[k], ps[l])) {
                                ok = false;
                                break;
                            }
                        }
                    }
                    if (!ok) continue;

                    if (ask(i, j, k)) {
                        finish(i, j, k);
                        fin = true;
                    }
                }
            }
        }
    }
}