#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <unordered_map>

using namespace std;

typedef pair<int, int> pii;
typedef vector<int> ints;
typedef vector<char> chars;
typedef vector<pii> piis;

#define INF (1 << 30)

/*
2 1
1 1 3 2

5 2
4 1 3 2 3 3 5 5 10 4
3 4 2 2 1 3 4 1

5 2
3 1 1 2 2 3 3 4
3 2 2 3 3 4 4 5
 */

int main() {
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<ints> c(m);
    vector<ints> t(m);
    for (int i = 0; i < m; ++i) {
        int cnt;
        cin >> cnt;
        c[i].resize(cnt + 1);
        t[i].resize(cnt + 1);
        cin >> c[i][0];
        for (int j = 1; j <= cnt; ++j) {
            cin >> t[i][j] >> c[i][j];
        }
    }

    piis dist(n + 1, {INF, INF});
    queue<int> q;
    q.push(1);
    dist[1] = {0, 0};
    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (int i = 0; i < m; ++i) {
            int next = -1;
            int time = 0;
            for (int j = 0; j < c[i].size() - 1; ++j) {
                if (c[i][j] == v) {
                    next = c[i][j + 1];
                }

                if (next != -1) {
                    time += t[i][j + 1];

                    int cur_time = dist[v].first + time;
                    int cur_sqr = dist[v].second + time * time;
                    if (dist[c[i][j + 1]].first > cur_time ||
                        (dist[c[i][j + 1]].first == cur_time && dist[c[i][j + 1]].second < cur_sqr)) {
                        dist[c[i][j + 1]] =  {cur_time, cur_sqr};
                        q.push(c[i][j + 1]);
                    }
                }
            }
        }
    }

    cout << dist[n].first << ' ' << dist[n].second << endl;
}