#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define long long long

typedef pair<int, int> pii;
typedef pair<long, long> pll;
typedef vector<int> ints;
typedef vector<char> chars;
typedef vector<pii> piis;
typedef vector<pll> plls;

#define INF (1ll << 30)

/*
2 1
1 1 3 2

5 2
4 1 3 2 3 3 5 5 10 4
3 4 2 2 1 3 4 1

5 2
3 1 1 2 2 3 3 4
3 2 2 3 3 4 4 5
 */

int main() {
#ifndef LOCAL
    freopen("trains.in", "r", stdin);
    freopen("trains.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<ints> c(m);
    vector<ints> t(m);
    vector<vector<pair<int, int>>> rs(n + 1); // {route idx, num}
    for (int i = 0; i < m; ++i) {
        int cnt;
        cin >> cnt;
        c[i].resize(cnt + 1);
        t[i].resize(cnt + 1);
        cin >> c[i][0];
        rs[c[i][0]].push_back({i, 0});
        for (int j = 1; j <= cnt; ++j) {
            cin >> t[i][j] >> c[i][j];
            rs[c[i][j]].push_back({i, j});
        }
    }

    plls dist(n + 1, {INF, INF});
    queue<int> q;
    q.push(1);
    dist[1] = {0ll, 0ll};
    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (int gg = 0; gg < rs[v].size(); ++gg) {
            int i = rs[v][gg].first;

            int next = -1;
            long time = 0;
            for (int j = rs[v][gg].second; j < c[i].size() - 1; ++j) {
                if (c[i][j] == v) {
                    next = c[i][j + 1];
                }

                if (next != -1) {
                    time += t[i][j + 1];

                    long cur_time = dist[v].first + time;
                    long cur_sqr = dist[v].second + time * time;
                    if (dist[c[i][j + 1]].first > cur_time ||
                        (dist[c[i][j + 1]].first == cur_time && dist[c[i][j + 1]].second < cur_sqr)) {
                        dist[c[i][j + 1]] = {cur_time, cur_sqr};
                        q.push(c[i][j + 1]);
                    }
                }
            }
        }
    }

    cout << dist[n].first << ' ' << dist[n].second;
}