#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <map>

using namespace std;

const int MX = 5011;
const int up = 16500;
long long t[up], pref[up], suf[up];
int l[up], r[up];
int prefr[up], sufl[up];
bool is[up];
int b[MX], c2[MX], a[MX], c1[MX];
const long long INF = 4e18;


void merge(int v) {
	t[v] = t[v << 1];
	l[v] = l[v << 1];
	r[v] = r[v << 1];
	if (t[(v << 1) | 1] > t[v]) {
		t[v] = t[(v << 1) | 1];
		l[v] = l[(v << 1) | 1];
		r[v] = r[(v << 1) | 1];
	}
	if (suf[v << 1] + pref[(v << 1) | 1] > t[v]) {
		t[v] = suf[v << 1] + pref[(v << 1) | 1];
		l[v] = sufl[v << 1]; r[v] = prefr[(v << 1) | 1];
	}
	pref[v] = pref[v << 1];
	prefr[v] = prefr[v << 1];
	if (!is[v << 1]) {
		pref[v] += pref[(v << 1) | 1];
		prefr[v] = prefr[(v << 1) | 1];
	}
	suf[v] = suf[(v << 1) | 1];
	sufl[v] = sufl[(v << 1) | 1];
	if (!is[(v << 1) | 1]) {
		suf[v] += suf[v << 1];
		sufl[v] = sufl[v << 1];
	}
	return;
}

void build(int v, int tl, int tr) {
	if (tl == tr) {
		t[v] = c2[tl];
		pref[v] = c2[tl];
		suf[v] = c2[tl];
		sufl[v] = tl;
		prefr[v] = tr;
		l[v] = tl;
		r[v] = tl;
	}
	else {
		int tm = (tl + tr) >> 1;
		build(v << 1, tl, tm);
		build((v << 1) | 1, tm + 1, tr);
		merge(v);
	}
	return;
}

void update(int v, int tl, int tr, int pos) {
	if (tl == tr) {
		t[v] = -INF;
		pref[v] = 0; suf[v] = 0;
		prefr[v] = tl - 1;
		sufl[v] = tr + 1;
		l[v] = tl; r[v] = tl;
		is[v] = 1;
	}
	else {
		int tm = (tl + tr) >> 1;
		if (pos <= tm)
			update(v << 1, tl, tm, pos);
		else
			update((v << 1) | 1, tm + 1, tr, pos);
		is[v] = 1;
		merge(v);
	}
	return;
}

int main() {
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++)
		cin >> c1[i];
	for (int i = 0; i < m; i++)
		cin >> b[i];
	for (int i = 0; i < m; i++)
		cin >> c2[i];
	bool done = 0;
	if (m < n) {
		done = 1;
		swap(m, n);
		swap(a, b);
		swap(c1, c2);
	}
	vector<int> pos(n);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++)
			if (a[j] == b[i])
				pos[j] = i + 1;
	}
	long long res = -1;
	int la = 0, lb = 0, ra = 0, rb = 0;
	long long sum1 = 0, sum2 = 0;
	for (int i = 0; i < n; i++)
		sum1 += c1[i];
	for (int i = 0; i < m; i++)
		sum2 += c2[i];
	if (sum1 > res) {
		la = 1, ra = n;
		res = sum1;
		rb = 0; lb = 0;
	}
	if (sum2 > res) {
		lb = 1, rb = m;
		la = 0; ra = 0;
		res = sum2;
	}

	for (int i = 0; i < n; i++) {
		if (!i || pos[i - 1]) {
			for (int j = 0; j < up; j++) {
				is[j] = 0;
				t[j] = 0;
			}
			build(1, 0, m - 1);
			long long cnt = 0;
			for (int j = i; j < n; j++) {
				cnt += c1[j];
				if (pos[j])
					update(1, 0, m - 1, pos[j] - 1);
				if (cnt + t[1] > res) {
					res = cnt + t[1];
					la = i + 1; ra = j + 1;
					lb = l[1] + 1; rb = r[1] + 1;
				}
			}
		}
	}
	if (done) {
		swap(la, lb);
		swap(ra, rb);
	}
	cout << res << '\n';
	cout << la << ' ' << ra << '\n';
	cout << lb << ' ' << rb << '\n';
	return 0;
}