#include <iostream>
#include <string>
#include <vector>
#include <bitset>
using namespace std;

const int maxN = 1e6 + 100;

int a[maxN];
bitset<maxN> bits[30];
int fw[30][maxN];
int f(int x)
{
	return x & -x;
}

void add(int k, int i, int val)
{
	for (; i < maxN; i += f(i))
	{
		fw[k][i] += val;
	}
}

int get(int k, int i)
{
	int res = 0;
	for (; i > 0; i -= f(i))
	{
		res += fw[k][i];
	}
	return res;
}

int get_bit(int mask, int pos)
{
	return (mask >> pos) & 1;
}

int get_mask(int n)
{
	int mask = 0;
	for (int b = 29; b >= 0; b--)
	{
		mask <<= 1;
		bool flag = true;
		for (int j = 0; j < n - 1; j++)
		{
			if (((a[j] >> b) ^ mask) >((a[j + 1] >> b) ^ mask))
			{
				flag = false;
			}
		}
		if (!flag)
			mask += 1;
	}
	return mask;
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	int q;
	cin >> q;
	for (int i = 0; i <= q; i++)
	{
		if (i != 0)
		{
			int p, v;
			cin >> p >> v;
			p--;
			a[p] = v;
			for (int b = 29; b >= 0; b--)
			{
				bits[b][p] = get_bit(v, b);
			}
		}
		int mask = get_mask(n);

		bool corr = true;
		for (int j = 0; j < n - 1; j++)
		{
			if ((a[j] ^ mask) >(a[j + 1] ^ mask))
				corr = false;
		}
		if (corr)
			cout << mask << "\n";
		else
			cout << -1 << "\n";
	}

    return 0;
}

