#include <iostream>
#include <string>
#include <vector>
#include <bitset>
#include <random>
using namespace std;

const int maxN = 5000 + 100;

mt19937_64 gen;

long long random(long long l, long long r)
{
	uniform_int_distribution<long long> dist(l, r);
	return dist(gen);
}

struct point
{
	long long x, y;

	point() {}
	point(long long x, long long y) : x(x), y(y) {}
};

struct vect
{
	long long x, y;
	vect() {}
	vect(long long x, long long y) : x(x), y(y) {}

	vect(point a, point b)
	{
		x = b.x - a.x;
		y = b.y - a.y;
	}

	long long operator% (vect b)
	{
		return x * b.y - y * b.x;
	}

	long long operator* (vect b)
	{
		return x * b.x + y * b.y;
	}
};

bool inside(point a, point b, point c, point d)
{
	long long area = abs(vect(a, b) % vect(a, c));
	long long tmp = abs(vect(a, b) % vect(a, d)) + abs(vect(a, d) % vect(a, c)) + abs(vect(b, d) % vect(b, c));
	return area == tmp;
}


bool check(vector<int> pts)
{
	cout << "? " << pts.size() << " ";
	for (int x : pts)
	{
		cout << x + 1 << " ";
	}
	cout << endl;
	string a;
	cin >> a;
	if (a == "Yes")
		return true;
	return false;
}

bool check(int a, int b, int c)
{
	cout << "? " << 3 << " " << a + 1 << " " << b + 1 << " " << c + 1;
	cout << endl;
	string ans;
	cin >> ans;
	if (ans == "Yes")
		return true;
	return false;
}

point pts[maxN];

void solve(int a, int b, int c, vector<int> in)
{
	if (in.empty())
	{
		cout << "! 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;
		return;
	}
	int pos = random(0, (int)in.size() - 1);
	int pivot = in[pos];
	if (check(a, b, pivot))
	{
		vector<int> tmp;
		for (int i = 0; i < in.size(); i++)
		{
			if (i == pos)
				continue;
			if (inside(pts[a], pts[b], pts[pivot], pts[in[i]]))
				tmp.push_back(in[i]);
		}
		solve(a, b, pivot, tmp);
	}
	else if (check(b, c, pivot))
	{
		vector<int> tmp;
		for (int i = 0; i < in.size(); i++)
		{
			if (i == pos)
				continue;
			if (inside(pts[b], pts[c], pts[pivot], pts[in[i]]))
				tmp.push_back(in[i]);
		}
		solve(b, c, pivot, tmp);
	}
	else
	{
		vector<int> tmp;
		for (int i = 0; i < in.size(); i++)
		{
			if (i == pos)
				continue;
			if (inside(pts[a], pts[c], pts[pivot], pts[in[i]]))
				tmp.push_back(in[i]);
		}
		solve(a, c, pivot, tmp);
	}
	return;
}

int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		long long x, y;
		cin >> x >> y;
		pts[i] = point(x, y);
	}

	int q;
	cin >> q;

	for (int i = 0; i < q; i++)
	{
		bool found = false;
		for (int j = 0; j < n; j++)
		{
			for (int k = j + 1; k < n; k++)
			{
				for (int l = k + 1; l < n; l++)
				{
					if (check(j, k, l))
					{
						vector<int> tmp;
						for (int x = 0; x < n; x++)
						{
							if (x == j || x == k || x == l)
								continue;
							if (inside(pts[j], pts[k], pts[l], pts[x]))
								tmp.push_back(x);
						}
						solve(j, k, l, tmp);
						found = true;
						break;
					}
				}
				if (found)
					break;
			}
			if (found)
				break;
		}
	}

    return 0;
}

