#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second
#define mp(a, b) make_pair(a, b)

using namespace std;

struct Point
{
    ll x, y;
    int id;
    Point() {}
    Point(ll x, ll y) : x(x), y(y) {}
    ll len()
    {
        return x * x + y * y;
    }
};

bool operator == (Point &p1, Point &p2)
{
    return p1.x == p2.x && p1.y == p2.y;
}

Point operator - (Point p1, Point p2)
{
    return Point(p1.x - p2.x, p1.y - p2.y);
}

ll operator * (Point p1, Point p2)
{
    return p1.x * p2.x + p1.y * p2.y;
}

ll operator % (Point p1, Point p2)
{
    return p1.x * p2.y - p2.x * p1.y;
}

bool comp(Point &p1, Point &p2)
{
    return (p1.y != p2.y ? p1.y < p2.y : p1.x < p2.x);
}

Point mi;

bool comp1(Point &p1, Point &p2)
{
    ll res = (p1 - mi) % (p2 - mi);
    return (res != 0 ? res > 0 : p1.len() < p2.len());
}

vector<Point> convex_hull(vector<Point> a)
{
    sort(a.begin(), a.end(), comp);
    mi = a[0];
    sort(a.begin() + 1, a.end(), comp1);
    vector<Point> hull;
    for (auto p : a)
    {
        while (sz(hull) > 1 && (hull[sz(hull) - 1] - hull[sz(hull) - 2]) % (p - hull[sz(hull) - 1]) <= 0)
            hull.pop_back();
        hull.push_back(p);
    }
    return hull;
}

/*bool check(Point p, Point p1, Point p2)
{
    if (p1.y == p2.y)
        return false;
    if (p1.y > p2.y)
        swap(p1, p2);
    if (p1.y > p.y || p2.y <= p.y)
        return false;
    return (p - p1) % (p2 - p1) <= 0;
}

bool check(vector<Point> &a, Point p)
{
    for (auto p1 : a)
        if (p == p1)
            return true;
    int cnt = 0;
    rep(i, 0, sz(a) - 1)
        cnt += check(p, a[i], a[i + 1]);
    cnt += check(p, a[sz(a) - 1], a[0]);
    return (cnt & 1);
}*/

bool check(Point &a, Point &b, Point &c, Point &p)
{
    ll v1 = (b - a) % (p - a);
    ll v2 = (c - b) % (p - b);
    ll v3 = (a - c) % (p - c);
    return (v1 >= 0 && v2 >= 0 && v3 >= 0 || v1 <= 0 && v2 <= 0 && v3 <= 0);
}

bool check(vector<Point> &a, int s, Point &p)
{
    int n = sz(a);
    Point t = a[s];
    if (t == p)
        return true;
    if ((a[(s + 1) % n] - t) % (p - t) < 0)
        return false;
    if ((a[(s - 1 + n) % n] - t) % (p - t) > 0)
        return false;
    int l = s, r = s + n, mid;
    while (r - l > 1)
    {
        mid = (l + r) / 2;
        if ((a[mid % n] - t) % (p - t) >= 0)
            l = mid;
        else
            r = mid;
    }
    return check(t, a[l % n], a[(l + 1) % n], p);
}

char s_[10];

bool ask(vector<Point> &a)
{
    printf("? %d ", sz(a));
    for (auto p : a)
        printf("%d ", p.id + 1);
    printf("\n");
    fflush(stdout);
    scanf("%s", &s_);
    return s_[0] == 'Y';
}

void answer(vector<Point> &a)
{
    printf("! %d ", sz(a));
    for (auto p : a)
        printf("%d ", p.id + 1);
    printf("\n");
    fflush(stdout);
}

bool s[1000000];
int t = 1;

void solve(int n, vector<Point> a)
{
    vector<Point> h = convex_hull(a);
    for (auto p : h)
        s[p.id] = t;
    while (true)
    {
        //cout << sz(a) << " " << sz(h) << endl;
        if (sz(h) == sz(a))
        {
            answer(h);
            break;
        }
        for (auto p : a)
            if (s[p.id] != t)
            {
                int j = 1;
                rep(i, 0, n)
                {
                    while ((p - h[i]) % (h[(j + 1) % sz(h)] - p) < 0)
                        j = (j + 1) % sz(h);
                    vector<Point> h1;
                    int u = i;
                    while (true)
                    {
                        h1.push_back(h[u]);
                        if (u == j)
                            break;
                        u = (u + 1) % sz(h);
                    }
                    h1.push_back(p);
                    if (ask(h1))
                    {
                        int ss = 0;
                        rep(k, 0, sz(h1))
                            if (comp(h1[k], h1[ss]))
                                ss = k;
                        vector<Point> a1;
                        for (auto p1 : a)
                            if (check(h1, ss, p1))
                                a1.push_back(p1);
                        /*for (auto p1 : a1)
                            cout << p1.x << " " << p1.y << "   ";
                        cout << endl;*/
                        a = a1;
                        h = convex_hull(a);
                        /*for (auto p1 : h)
                            cout << p1.x << " " << p1.y << "   ";
                        cout << endl;*/
                        t++;
                        for (auto p1 : h)
                            s[p1.id] = t;
                        break;
                    }
                }
                break;
            }
    }
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    int n;
    scanf("%d", &n);
    //n = 5;
    vector<Point> a(n);
    //vector<Point> a = {{0, 0}, {4, 0}, {3, 2}, {5, 4}, {0, 4}};
    rep(i, 0, n)
    {
        scanf("%lld %lld", &a[i].x, &a[i].y);
        a[i].id = i;
    }
    random_shuffle(a.begin(), a.end());
    int q;
    scanf("%d", &q);
    rep(i, 0, q)
        solve(n, a);
    return 0;
}
