#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 31;

struct TNode {
	int l, r;
	TNode *left, *right;
	int min, max;
	int fl[MAXN];
	bool can;
};

vector<int> num;

TNode *new_node(int l, int r) {
	return new TNode{ l, r, nullptr, nullptr, -1, -1, false };
}

TNode *build_tree(int l, int r) {
	TNode *node = new_node(l, r);
	if (r - l > 1) {
		int mid = (r + l) / 2;
		node->left = build_tree(l, mid);
		node->right = build_tree(mid, r);
	} else {
		node->min = node->max = num[l];
	}
	return node;
}

void fill_tree(TNode *node, int y, int q) {
	if (node->r - node->l == 1) {
		if (q != -1) {
			node->min = node->max = q;
		}
		node->can = true;
		return;
	}
	if (q == -1) {
		fill_tree(node->left, y, q);
		fill_tree(node->right, y, q);
	} else {
		if (node->left->r <= y) {
			fill_tree(node->right, y, q);
		} else {
			fill_tree(node->left, y, q);
		}
	}
	node->min = node->left->min;
	node->max = node->right->max;
	if (!node->left->can || !node->right->can) {
		node->can = false;
		return;
	}
	bool t = true;
	int x = 0;
	for (int i = 0; i < MAXN; i++) {
		if (node->left->fl[i] != 0 && node->left->fl[i] + node->right->fl[i] == 0) {
			t = false;
			break;
		}
		node->fl[i] = node->left->fl[i] + node->right->fl[i];
		if (node->left->fl[i] == 1) {
			x |= (1 << i);
		}
		if (node->right->fl[i] == 1) {
			x |= (1 << i);
		}
	}
	if (!t) {
		node->can = false;
		return;
	}
	int u1 = node->left->max, u2 = node->right->min;
	for (int i = MAXN - 1; i >= 0; i--) {
		int v1 = ((u1 >> i) & 1);
		int v2 = ((u2 >> i) & 1);
		if (v1 == v2) {
			continue;
		}
		if (v1 == 1) {
			if (node->fl[i] == 0) {
				node->fl[i] = 1;
			} else if (node->fl[i] == -1) {
				t = false;
				break;
			}
		} else {
			if (node->fl[i] == 0) {
				node->fl[i] = -1;
			} else if (node->fl[i] == 1) {
				t = false;
				break;
			}
		}
		break;
	}
	if (!t) {
		node->can = false;
	} else {
		node->can = true;
	}
	return;
}

int get_ans(TNode *node) {
	if (!node->can) {
		return -1;
	}
	int x = 0;
	for (int i = 0; i < MAXN; i++) {
		if (node->fl[i] == 1) {
			x |= (1 << i);
		}
	}
	return x;
}

int main() {
	int n;
	cin >> n;
	num.resize(n + 1, 0);
	for (int i = 1; i <= n; i++) {
		cin >> num[i];
	}
	TNode *tree = build_tree(1, n + 1);
	fill_tree(tree, 0, -1);
	cout << get_ans(tree) << endl;
	int m, y, q;
	cin >> m;
	for (int i = 0; i < m; i++) {
		cin >> y >> q;
		fill_tree(tree, y, q);
		cout << get_ans(tree) << endl;
	}
	return 0;
}