#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

struct point {
	int x, y;
};

point operator - (point a, point b) {
	return point{ a.x - b.x, a.y - b.y };
}

int operator * (point a, point b) {
	return a.x * b.y - a.y * b.x;
}

bool is_in(point x, point a, point b, point c) {
	point v1 = a - b, v2 = c - b, v3 = x - b;
	int q = v1 * v3, w = v3 * v2;
	if ((q > 0 && w < 0) || (q < 0 && w > 0)) {
		return false;
	}
	v1 = b - a;
	v2 = c - a;
	v3 = x - a;
	q = v1 * v3;
	w = v3 * v2;
	if ((q > 0 && w < 0) || (q < 0 && w > 0)) {
		return false;
	}
	return true;
}

bool check(vector<point> po, int a, int b, int c) {
	for (int i = 0; i < po.size(); i++) {
		if (i == a | i == b || i == c) {
			continue;
		}
		if (is_in(po[i], po[a], po[b], po[c])) {
			return false;
		}
	}
	return true;
}

string query(int a, int b, int c) {
	cout << "? 3 " << a << " " << b << " " << c << endl;
	fflush(stdout);
	string s;
	cin >> s;
	return s;
}

int main() {
	int n;
	cin >> n;
	vector<point> po(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> po[i].x >> po[i].y;
	}
	int m;
	cin >> m;
	string s;
	for (int e = 0; e < m; e++) {
		bool fl = false;
		for (int i = 1; i <= n; i++) {
			for (int j = i + 1; j <= n; j++) {
				for (int k = j + 1; k <= n; k++) {
					if (!check(po, i, j, k)) {
						continue;
					}
					s = query(i, j, k);
					if (s == "Yes") {
						cout << "! 3 " << i << " " << j << " " << k << endl;
						fflush(stdout);
						fl = true;
						break;
					}
				}
				if (fl) {
					break;
				}
			}
			if (fl) {
				break;
			}
		}
	}
	return 0;
}