#include <iostream>
#include <vector>
using namespace std;

const long long INF = 1e9 + 7;

struct edge {
	long long v, c, sq;
};

long long main() {
	long long n, m;
	cin >> n >> m;
	vector< vector<edge> > ed(n + 1);
	for (long long i = 0; i < m; i++) {
		long long k, a, b;
		cin >> k;
		vector< pair<long long, long long> > w;
		for (long long j = 0; j < k; j++) {
			cin >> a >> b;
			w.push_back({ a, b });
		}
		cin >> a;
		w.push_back({ a, 0 });
		for (long long j = 0; j < w.size(); j++) {
			long long sum = w[j].second;
			for (long long e = j + 1; e < w.size(); e++) {
				ed[w[j].first].push_back(edge{ w[e].first, sum , sum * sum });
				sum += w[e].second;
			}
		}
	}
	vector< pair<long long, long long> > dist(n + 1, { INF, -INF });
	dist[1] = { 0, 0 };
	vector<long long> used(n + 1, 0);
	for (long long e = 0; e < n; e++) {
		long long mc = INF, msq = -INF, v;
		for (long long i = 1; i <= n; i++) {
			if (used[i] == 0 && dist[i].first != INF) {
				if ((dist[i].first < mc) || (dist[i].first == mc && dist[i].second < msq)) {
					mc = dist[i].first;
					msq = dist[i].second;
					v = i;
				}
			}
		}
		used[v] = 1;
		for (long long i = 0; i < ed[v].size(); i++) {
			auto nxt = ed[v][i];
			if (used[nxt.v] == 0) {
				if ((dist[nxt.v].first > dist[v].first + nxt.c) || (dist[nxt.v].first == dist[v].first + nxt.c && dist[nxt.v].second < dist[v].second + nxt.sq)) {
					dist[nxt.v].first = dist[v].first + nxt.c;
					dist[nxt.v].second = dist[v].second + nxt.sq;
				}
			}
		}
	}
	cout << dist[n].first << " " << dist[n].second;
	return 0;
}