#include <iostream>
#include <stack>
#include <vector>
#include <string>
#include <cmath>
#include <stdlib.h>
#include <algorithm>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> llp;
typedef long double ld;

const ll MAXN = 1000000;
const ll INF = 1000000000000000;

vector<llp> v;
ll n, m;
vector<ll> d(MAXN, INF);
vector<pair<llp, ll>> graph[MAXN]; //dst, v, cl
vector<pair<llp, ll>> go[MAXN];

void dijkstra(ll s){
	priority_queue<llp> q;
	d[s] = 0;
	q.push({ 0, s });

	while (!q.empty()) {
		ll dst = -q.top().first;
		ll v = q.top().second;
		q.pop();

		if (dst > d[v]) { continue; }

		for (ll i = 0; i < graph[v].size(); i++) {
			llp edge = graph[v][i].first;
			ll to = edge.second;

			if (dst + edge.first < d[to]) {
				d[to] = dst + edge.first;
				q.push({ -d[to], to });
			}
		}
	}
}

llp mmax(ll v, ll cl, ll cdst, ll cld) { //dst same cl, sum sq, sum sq
	if (v == n - 1) { return { 0, 0 }; }

	llp ans = { 0, 0 };
	

	for (ll i = 0; i < go[v].size(); i++) {
		ll to = go[v][i].first.second;
		ll tdst = go[v][i].first.first;
		ll tcl = go[v][i].second;

		if (d[to] + cdst + tdst != d[0]) { continue; }
		else {
			llp rs;
			if (cl == tcl) {
				rs = mmax(to, tcl, cdst + tdst, cld + tdst);
				ans.first = max(ans.first, rs.first);
				ans.first = max(ans.first, (cld + tdst)*(cld + tdst) + rs.second);
			}
			else {
				if ((tdst + d[to]) * (tdst + d[to]) < ans.second) { continue; }
				rs = mmax(to, tcl, cdst + tdst, tdst);
				ans.second = max(ans.second,  max(rs.first, tdst * tdst + rs.second));
			}
		}
	}

	return ans;
}

int main() {
	cin >> n >> m;

	for (ll i = 0; i < m; i++) {
		ll s, v;
		cin >> s >> v;
		v--;
		for (ll j = 0; j < s; j++) {
			ll t, u;
			cin >> t >> u;
			u--;
			graph[u].push_back({ {t, v}, i });
			go[v].push_back({ { t, u }, i });
			v = u;
		}
	}

	dijkstra(n - 1);

	cout << d[0] << " ";
	
	llp ans = mmax(0, -1, 0, 0);

	cout << ans.second;
	
	return 0;
}