#include <iostream>
#include <stack>
#include <vector>
#include <string>
#include <cmath>
#include <stdlib.h>
#include <algorithm>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> llp;
typedef long double ld;

const ll MAXN = 1000000;
const ll INF = 1000000000000000;

vector<llp> v;
ll n, m;
vector<ll> d(MAXN, INF);
vector<ll> d2(MAXN, 0);
vector<ll> ndst(MAXN, INF);

vector<pair<llp, ll>> graph[MAXN]; //dst, v, cl
vector<pair<llp, ll>> go[MAXN];

void dijkstra(ll s){
	priority_queue<llp> q;
	d[s] = 0;
	q.push({ 0, s });

	while (!q.empty()) {
		ll dst = -q.top().first;
		ll v = q.top().second;
		q.pop();

		if (dst > d[v]) { continue; }

		for (ll i = 0; i < graph[v].size(); i++) {
			llp edge = graph[v][i].first;
			ll to = edge.second;

			if (dst + edge.first < d[to]) {
				d[to] = dst + edge.first;
				q.push({ -d[to], to });
			}
		}
	}
}

void rdijkstra(ll s) {
	priority_queue<llp> q;
	ndst[s] = 0;
	q.push({ 0, s });

	while (!q.empty()) {
		ll dst = -q.top().first;
		ll v = q.top().second;
		q.pop();

		if (dst > ndst[v]) { continue; }

		for (ll i = 0; i < go[v].size(); i++) {
			llp edge = go[v][i].first;
			ll to = edge.second;

			if (dst + edge.first < ndst[to]) {
				ndst[to] = dst + edge.first;
				q.push({ -ndst[to], to });
			}
		}
	}
}


void dijkstra2(ll s) {
	priority_queue<llp> q;
	d2[s] = 0;
	q.push({ 0, s });

	while (!q.empty()) {
		ll dst = q.top().first;
		ll v = q.top().second;
		q.pop();

		if (dst < d2[v]) { continue; }

		for (ll i = 0; i < go[v].size(); i++) {
			llp edge = go[v][i].first;
			ll to = edge.second;
			
			if (ndst[v] + edge.first + d[to] != d[0]) { continue; }

			if (dst + edge.first * edge.first > d2[to]) {
				d2[to] = dst + edge.first * edge.first;
				q.push({ d2[to], to });
			}
		}
	}
}

llp mmax(ll v, ll cl, ll cdst, ll cld) {
	if (v == n - 1) { return { 0, 0 }; }

	llp ans = { 0, 0 };
	

	for (ll i = 0; i < go[v].size(); i++) {
		ll to = go[v][i].first.second;
		ll tdst = go[v][i].first.first;
		ll tcl = go[v][i].second;

		if (d[to] + cdst + tdst != d[0]) { continue; }
		else {
			llp rs;
			if (cl == tcl) {
				rs = mmax(to, tcl, cdst + tdst, cld + tdst);
				ans.first = max(ans.first, rs.first);
				ans.first = max(ans.first, (cld + tdst)*(cld + tdst) + rs.second);
			}
			else {
				rs = mmax(to, tcl, cdst + tdst, tdst);
				ans.second = max(ans.second,  max(rs.first, tdst * tdst + rs.second));
			}
		}
	}

	return ans;
}

int main() {
	cin >> n >> m;

	for (ll i = 0; i < m; i++) {
		ll s, sv, v;
		cin >> s >> sv;
		vector<llp> tv;
		sv--;
		v = sv;
		ll sum = 0;
		for (ll j = 0; j < s; j++) {
			ll t, u;
			cin >> t >> u;
			u--;
			graph[u].push_back({ {t, v}, i });
			sum += t;
			go[sv].push_back({ {sum, u}, i });
			v = u;
			tv.push_back({ t, u });
		}

		for (ll i = 0; i < tv.size(); i++) {
			ll sum = 0;
			ll v = tv[i].second;
			for (ll j = i + 1; j < tv.size(); j++) {
				sum += tv[j].first;
				go[v].push_back({ { sum, tv[j].second }, i });
			}
		}
	}

	dijkstra(n - 1);
	rdijkstra(0);
	dijkstra2(0);

	cout << d[0] << " ";
	
	cout << d2[n-1];
	
	return 0;
}