#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

struct node
{
    int x, y, cnt, fir, las;
    node *L, *R;
    vector <int> bit;
    node(int X)
    {
        x = fir = las = X;
        y = rand() * rand();
        cnt = 1;
        L = R = nullptr;
        bit.resize(31, -1);
    }
};

inline int cnt(node *T)
{
    if (T) return T->cnt;
    return 0;
}

inline void make_bit(int l, int r, vector <int> &bitl, vector <int> &bitr, vector <int> &ans)
{
    bool check = false;
    for (int i = 30; i >= 0; i--)
    {
        if (!check)
        {
            int bl = bitl[i], br = bitr[i];
            if (bl == 2 || br == 2)
            {
                ans[i] = 2;
                check = true;
            }
            else if (bl == -1)
            {
                if (br == -1)
                {
                    if ((l&(1<<i)) == (r&(1<<i)))
                    {
                        ans[i] = -1;
                    }
                    else if ((l&(1<<i)))
                    {
                        ans[i] = 1;
                        check = true;
                    }
                    else
                    {
                        ans[i] = 0;
                        check = true;
                    }
                }
                else if (br == 0)
                {
                    if ((l&(1<<i)) <= (r&(1<<i)))
                    {
                        ans[i] = 0;
                        if ((l&(1<<i)) < (r&(1<<i)))
                            check = true;
                    }
                    else
                    {
                        ans[i] = 2;
                        check = true;
                    }
                }
                else
                {
                    if (!(l&(1<<i)) <= !(r<<i))
                    {
                        ans[i] = 1;
                        if (!(l&(1<<i)) < !(r&(1<<i)))
                            check = true;
                    }
                    else
                    {
                        ans[i] = 2;
                        check = true;
                    }
                }

            }
            else if (bl == 0)
            {
                if (br == 1)
                {
                    ans[i] = 2;
                    check = true;
                }
                if ((l&(1<<i)) <= (r&(1<<i)))
                {
                    ans[i] = 0;
                    if ((l&(1<<i)) < (r&(1<<i)))
                        check = true;
                }
                else
                {
                    ans[i] = 2;
                    check = false;
                }
            }
            else
            {
                if (br == 0)
                {
                    ans[i] = 2;
                    check = true;
                }
                if (!(l&(1<<i)) <= !(r&(1<<i)))
                {
                    ans[i] = 1;
                    if (!(l&(1<<i)) < !(r&(1<<i)))
                        check = true;
                }
                else
                {
                    ans[i] = 2;
                    check = false;
                }
            }
        }
        else
        {
            if (bitl[i] == -1)
                ans[i] = bitr[i];
            else if (bitr[i] == -1)
                ans[i] = bitl[i];
            else
            {
                if (bitl[i] == 2 || bitr[i] == 2)
                    ans[i] = 2;
                else if (bitl[i] == bitr[i])
                    ans[i] = bitl[i];
                else
                    ans[i] = 2;
            }
        }
    }

    /*for (int i = 0; i < 7; i++)
        cout << ans[i] << ' ';
    cout << endl;*/
}

inline void update(node *T)
{
    if (T)
    {
        int x = T->x;
        for (int i = 0; i < 31; i++)
            T->bit[i] = -1;
        if (T->L)
        {
            make_bit(T->L->las, T->x, T->L->bit, T->bit, T->bit);
            T->fir = T->L->fir;
        }
        else
            T->fir = T->x;

        if (T->R)
        {
            make_bit(T->x, T->R->fir, T->bit, T->R->bit, T->bit);
            T->las = T->R->las;
        }
        else
            T->las = T->x;

        T->cnt = cnt(T->L) + 1 + cnt(T->R);
    }
}

inline node* nmerge(node *L, node *R)
{
    if (!L) return R;
    if (!R) return L;
    if (L->y > R->y)
    {
        L->R = nmerge(L->R, R);
        update(L);
        return L;
    }
    else
    {
        R->L = nmerge(L, R->L);
        update(R);
        return R;
    }
}

inline pair <node*, node*> split(node *T, int x, int add = 0)
{
    if (!T) return {nullptr, nullptr};
    int curx = add + cnt(T->L);
    if (x <= curx)
    {
        auto tt = split(T->L, x, add);
        T->L = tt.second;
        update(T);
        return {tt.first, T};
    }
    else
    {
        auto tt = split(T->R, x, curx + 1);
        T->R = tt.first;
        update(T);
        return {T, tt.second};
    }
}

inline int ans(node *T)
{
    int ret = 0;
    if (T)
    {
        for (int i = 0; i < 30; i++)
            if (T->bit[i] == 2)
                return -1;
            else if (T->bit[i] == 1)
                ret += (1<<i);
    }
    return ret;
}

void go(node *T)
{
    if (T)
    {
        go(T->L);
        cout << T->x << ' ';
        go(T->R);
    }
}

int n, q;
node *T = nullptr;

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        T = nmerge(T, new node(a));
    }

    cout << ans(T) << endl;
    cin >> q;
    while (q--)
    {
        int p, v;
        cin >> p >> v;

        auto tt = split(T, p);
        auto tt2 = split(tt.first, p - 1);

        T = nmerge(tt2.first, new node(v));
        T = nmerge(T, tt.second);

        /*cout << "root: " << T->x << endl;
        for (int i = 0; i < 7; i++)
                cout << T->bit[i] << ' ';
        cout << endl;*/
        cout << ans(T) << endl;
    }
    return 0;
}

/*
3
0 1 4
3
2 7
3 3
1 4
*/
