#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

long long n;
vector <long long> t, l, r;
vector <pair <long long, long long> > lleft, rright;

inline bool intersect(long long a, long long b, long long c, long long d)
{
    return a <= d && c <= b;
}

pair <long long, long long> intersection(long long a, long long b, long long c, long long d)
{
    return {max(a, c), min(b, d)};
}

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n;
    t.resize(n);
    l.resize(n);
    r.resize(n);
    lleft.resize(n, {-1, -1});
    rright.resize(n, {-1, -1});
    lleft[0] = {0, 2e18};
    rright[n - 1] = {0, 2e18};

    for (long long i = 0; i < n; i++)
        cin >> t[i];
    for (long long i = 0; i < n - 1; i++)
        cin >> l[i] >> r[i];

    long long nowl = 0, nowr = 2e18;
    for (int i = n - 2; i >= 0; i--)
    {
        if (!intersect(nowl, nowr, l[i], r[i]))
            break;
        else
        {
            rright[i] = intersection(nowl, nowr, l[i], r[i]);
            if (l[i] == rright[i].first)
                rright[i].first -= t[i];

            nowl = rright[i].first, nowr = rright[i].second;
        }
    }

    nowl = 0, nowr = 2e18;
    for (int i = 1; i < n; i++)
    {
        if (!intersect(nowl, nowr, l[i - 1], r[i - 1]))
            break;
        else
        {
            lleft[i] = intersection(nowl, nowr, l[i - 1], r[i - 1]);
            if (l[i - 1] == lleft[i].first)
                lleft[i].first -= t[i];

            nowl = lleft[i].first, nowr = lleft[i].second;
        }
    }

    for (int i = 0; i < n; i++)
    {
        if (lleft[i].first == -1 || rright[i].first == -1)
            cout << -1 << '\n';
        else
        {
            if (intersect(lleft[i].first, lleft[i].second, rright[i].first, rright[i].second))
                cout << intersection(lleft[i].first, lleft[i].second, rright[i].first, rright[i].second).first << '\n';
            else
                cout << -1 << '\n';
        }
    }

    /*cout << endl;
    for (int i = 1; i < n; i++)
        cout << lleft[i].first << ' ' << lleft[i].second << endl;
    cout << endl << endl;
    for (int i = 0; i < n - 1; i++)
        cout << rright[i].first << ' ' << rright[i].second << endl;*/
    return 0;
}

/*

1
10

2
3 5
6 8

3
1 2 4
7 10
3 5

4
1 0 3 2
4 6
5 5
7 10

*/
