#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

struct seg
{
    long long l, r;
    long long w;
};
inline bool operator<(seg a, seg b)
{
    if (a.l == b.l)
        return a.r < b.r;
    return a.l < b.l;
}

struct wei
{
    long long w;
    long long l, r;
};
inline bool operator<(wei a, wei b)
{
    if (a.w == b.w)
    {
        return a.l < b.l;
    }
    return a.w < b.w;
}

long long n, m, lx = 0, rx = 0, ly = 0, ry = 0;
long long ans = 0;
vector <long long> x, a, y, b, rev;
vector <long long> wx, wy;

inline long long get_sum(long long l, long long r)
{
    return wy[r] - (l ? wy[l - 1] : 0);
}

set <seg> sg;
set <wei> sw;
inline void push_seg(long long l, long long r)
{
    if (l <= r)
    {
        sg.insert({l, r, get_sum(l, r)});
        sw.insert({get_sum(l, r), l, r});
    }
}

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n >> m;
    x.resize(n);
    a.resize(n);
    wx.resize(n);
    for (long long i = 0; i < n; i++)
        cin >> x[i];
    for (long long i = 0; i < n; i++)
    {
        cin >> a[i];
        wx[i] = a[i];
        if (i)
            wx[i] += wx[i - 1];
    }
    y.resize(m);
    b.resize(m);
    wy.resize(m, 0);
    rev.resize(n + m + 1, -1);
    for (long long i = 0; i < m; i++)
    {
        cin >> y[i];
        rev[y[i]] = i;
    }
    for (long long i = 0; i < m; i++)
    {
        cin >> b[i];
        wy[i] = b[i];
        if (i)
            wy[i] += wy[i - 1];
    }

    for (long long i = 0; i < n; i++)
    {
        long long now = 0;
        sg.clear();
        sw.clear();
        sg.insert({0, m - 1, get_sum(0, m - 1)});
        sw.insert({get_sum(0, m - 1), 0, m - 1});
        for (long long j = i; j < n; j++)
        {
            now += a[j];

            long long rv = rev[x[j]];
            if (rv != -1)
            {
                auto it = sg.upper_bound({rv, (long long)2e18, (long long)2e18});
                it--;
                seg segment = *it;
                long long l = segment.l, r = segment.r;
                sg.erase(it);
                sw.erase({segment.w, l, r});

                push_seg(l, rv - 1);
                push_seg(rv + 1, r);
            }

            long long pl = 0;
            if (!sw.empty())
                pl = (*sw.rbegin()).w;

            if (ans < now + pl)
            {
                ans = now + pl;
                lx = i + 1, rx = j + 1;
                if (!sw.empty())
                    ly = (*sw.rbegin()).l + 1, ry = (*sw.rbegin()).r + 1;
                else
                    ly = 0, ry = 0;
            }
        }
    }

    if (ans < get_sum(0, m - 1))
    {
        ans = get_sum(0, m - 1);
        lx = 0, rx = 0;
        ly = 1, ry = m;
    }

    cout << ans << endl;
    cout << lx << ' ' << rx << endl;
    cout << ly << ' ' << ry << endl;
    return 0;
}

/*

7 5
3 1 4 8 6 9 2
2 7 4 10 1 5 3
9 2 11 3 8
3 5 3 4 12

2 3
1 2
1 4
2 3 1
17 2 15

*/
