#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <bitset>
#include <utility>
#include <iterator>
#include <sstream>
#include <fstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK ""
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//SAY HELLO TO MY LIL' FRIEND

struct point {
	ll x, y;

	point() {}
	point(ll x, ll y) : x(x), y(y) {}
};

struct vt {
	ll x, y;
	
	vt() {}
	vt(ll x, ll y) : x(x), y(y) {}
	vt(point a, point b) : x(b.x - a.x), y(b.y - a.y) {}

	ll operator^(vt v) {
		return x * v.y - v.x * y;
	}
};

bool is_convex(vector<point> &p) {
	vt lst(p.back(), p[0]);
	for (int i = 0; i < p.size(); i++) {
		vt curr = vt(p[i], p[(i + 1) % p.size()]);
		if ((lst ^ curr) <= 0) {
			return false;
		}
		lst = curr;
	}
	return true;
}

ll sarea(point a, point b, point c) {
	return (vt(a, b) ^ vt(a, c));
}

ll area(point a, point b, point c) {
	return abs(sarea(a, b, c));
}

int bit(int mask, int id) {
	return ((mask >> id) & 1);
}

ll areafrompoint(point a, vector<point>& p) {
	ll res = 0;
	for (int i = 0; i < p.size(); i++) {
		res += area(a, p[i], p[(i + 1) % p.size()]);
	}
	return res;
}

bool ask(vector<int>& p) {
	cout << "? " << p.size() << " ";
	for (int i = 0; i < p.size(); i++) {
		cout << p[i] << " ";
	}
	cout << endl;

	string res;
	cin >> res;
	
	return res[0] == 'Y';
}

void say(vector<int>& p) {
	cout << "! " << p.size() << " ";
	for (int i = 0; i < p.size(); i++) {
		cout << p[i] << " ";
	}
	cout << endl;
}

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	iostream::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;

	vector<point> p(n);
	point mn(INF + 10, INF + 10);
	for (int i = 0; i < n; i++) {
		cin >> p[i].x >> p[i].y;

		if (p[i].y < mn.y || (p[i].y == mn.y && p[i].x < mn.x)) {
			mn = p[i];
		}
	}

	sort(all(p), [mn](point a, point b) {
		return (vt(mn, a) ^ vt(mn, b)) > 0;
	});

	int q;
	cin >> q;
	for (int x = 0; x < q; x++) {
		for (int mask = 0; mask < (1 << n); mask++) {
			vector<int> ids;
			vector<point> gon;
			for (int i = 0; i < n; i++) {
				if (bit(mask, i))
					gon.push_back(p[i]), ids.push_back(i + 1);
			}

			if (gon.size() != 3)
				continue;

			ll ar = 0;
			for (int i = 0; i < gon.size(); i++) {
				ar += sarea(point(0, 0), gon[i], gon[(i + 1) % gon.size()]);
			}
			ar = abs(ar);

			bool flag = true;
			for (int i = 0; i < n; i++) {
				if (!bit(mask, i)) {
					if (areafrompoint(p[i], gon) == ar) {
						flag = false;
						break;
					}
				}
			}

			if (flag) {
				if (ask(ids)) {
					say(ids);
					break;
				}
			}
		}
	}

	return 0;
}