#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int N = 500, P = 9;

int llp2(int x)
{
    return 8*sizeof(x) - __builtin_clz(x) - 1;
}

int n[2];
ll s[2][N], ans = 0;
bitset<2*N> d[2][P][N];
pair<int, int> a[2];

void build()
{
    for(int i = 0; i < 2; ++i)
    {
        for(int p = 1; p < P; ++p)
        {
            int f = 1<<(p-1);
            for(int j = 0; j < n[i]-f; ++j)
            {
                d[i][p][j] = d[i][p-1][j] | d[i][p-1][j+f];
            }
        }
    }
}

bool query(int l1, int r1, int l2, int r2) //[l, r)
{
    int len1 = r1 - l1, len2 = r2 - l2;
    int p1 = llp2(len1), p2 = llp2(len2);
    return ((d[0][p1][l1] | d[0][p1][r1-(1<<p1)]) & (d[1][p2][l2] | d[1][p2][r2-(1<<p2)])).any();
}

ll qsum(int i, int l, int r) //[l, r]
{
    ll ans = s[i][r];
    if (l > 0) ans -= s[i][l-1];
    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin >> n[0] >> n[1];
    for(int i = 0; i < 2; ++i)
    {
        for(int j = 0; j < n[i]; ++j)
        {
            int x; cin >> x;
            d[i][0][j].set(x-1);
        }
        for(int j = 0; j < n[i]; ++j)
        {
            cin >> s[i][j];
        }
        partial_sum(s[i], s[i] + n[i], s[i]);
    }
    build();
    for(int l1 = 0; l1 < n[0]; ++l1)
    for(int r1 = l1; r1 < n[0]; ++r1)
    for(int l2 = 0; l2 < n[1]; ++l2)
    for(int r2 = l2; r2 < n[0]; ++r2)
    {
        if (!query(l1, r1+1, l2, r2+1))
        {
            ll res = qsum(0, l1, r1) + qsum(1, l2, r2);
            if (res > ans)
            {
                ans = res;
                a[0] = {l1, r1};
                a[1] = {l2, r2};
            }
        }
    }
    for(int i = 0; i < 2; ++i)
    {
        ll v = qsum(i, 0, n[i]-1);
        if (v > ans)
        {
            ans = v;
            a[i] = {0, n[i]-1};
            a[i^1] = {-1, -1};
        }
    }
    cout << ans << '\n';
    for(int i = 0; i < 2; ++i)
    {
        cout << a[i].first << ' ' << a[i].second << '\n';
    }
}
