#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <stack>
#include <set>

using namespace std;

typedef long long ll;

vector<vector<pair<ll, ll>>> g;
vector<ll> used;

int main()
{
	ll n, m;
	cin >> n >> m;

	used.resize(n);
	g.resize(n);

	for (int i = 0; i < m; ++i)
	{
		ll k;

		cin >> k;
		ll pred, to, len;
		cin >> pred;
		--pred;

		for (int j = 0; j < k; ++j)
		{
			cin >> len >> to;
			--to;

			g[pred].push_back({to, len});

			pred = to;
		}
	}

	vector<pair<ll, ll>> d(n, { 1e18, 1e18 });
	d[0] = { 0, 0 };
	set<pair<ll, ll>> sett;
	sett.insert({ 0, 0 });

	while (!sett.empty())
	{
		ll v = sett.begin()->second;
		sett.erase(sett.begin());

		for (int j = 0; j < g[v].size(); ++j)
		{
			ll to = g[v][j].first;
			ll len = g[v][j].second;

			if (d[to].first > d[v].first + len)
			{
				sett.erase(make_pair(d[v].first, to));

				d[to].second = d[v].second + len * len;
				d[to].first = d[v].first + len;

				sett.insert(make_pair(d[v].first, to));
			}
			else if (d[to].first == d[v].first + len && d[to].second > d[v].second + len * len)
			{
				d[to].second = d[v].second + len * len;

				sett.insert(make_pair(d[v].first, to));
			}
		}
	}

	cout << d[n - 1].first << " " << d[n - 1].second << endl;

	return 0;
}

/*
2 1
1 1 3 2

5 2
4 1 3 2 3 3 5 5 10 4
3 4 2 2 1 3 4 1

5 2
3 1 1 2 2 3 3 4
3 2 2 3 3 4 4 5

*/