#include <iostream>
#include <string>
#include <algorithm>

bool upper(std::string& a, std::string& b) {
	if (a.size() > b.size()) {
		return true;
	}
	if (a.size() < b.size()) {
		return false;
	}
	for (int i = 0; i < a.size(); ++i) {
		if (a[i] > b[i]) {
			return true;
		} else if (a[i] < b[i]) {
			return false;
		}
	}
	return false;
}

std::string plus(std::string& a, std::string& b) {
	std::string res;
	std::reverse(a.begin(), a.end());
	std::reverse(b.begin(), b.end());
	int carry = 0;
	for (int i = 0; i < std::min(a.size(), b.size()); ++i) {
		res.push_back((a[i] - '0' + b[i] - '0' + carry) % 10 + '0');
		carry = (a[i] - '0' + b[i] - '0' + carry) / 10;
	}
	for (int i = std::min(a.size(), b.size()); i < a.size(); ++i) {
		res.push_back((a[i] - '0' + carry) % 10 + '0');
		carry = (a[i] - '0' + carry) / 10;
	}
	for (int i = std::min(a.size(), b.size()); i < b.size(); ++i) {
		res.push_back((b[i] - '0' + carry) % 10 + '0');
		carry = (b[i] - '0' + carry) / 10;
	}
	if (carry != 0) {
		res.push_back(carry + '0');
	}
	while (res.size() > 1 && res.back() == '0') {
		res.pop_back();
	}
	std::reverse(a.begin(), a.end());
	std::reverse(b.begin(), b.end());
	std::reverse(res.begin(), res.end());
	return res;
}

std::string minus(std::string& a, std::string& b) {
	std::string res;
	std::reverse(a.begin(), a.end());
	std::reverse(b.begin(), b.end());
	bool need = false;
	for (int i = 0; i < b.size(); ++i) {
		if (need) {
			if (a[i] == '0') {
				a[i] = '9';
			} else {
				--a[i];
				need = false;
			}
		}
		if (a[i] >= b[i]) {
			res.push_back((a[i] - '0') - (b[i] - '0') + '0');
		} else {
			res.push_back((a[i] + 10 - '0') - (b[i] - '0') + '0');
			need = true;
		}
	}
	for (int i = b.size(); i < a.size(); ++i) {
		if (need) {
			if (b[i] == '0') {
				a[i] = '9';
			} else {
				--a[i];
				need = false;
			}
		}
		res.push_back(a[i]);
	}
	while (res.size() > 1 && res.back() == '0') {
		res.pop_back();
	}
	std::reverse(a.begin(), a.end());
	std::reverse(b.begin(), b.end());
	std::reverse(res.begin(), res.end());
	return res;
}

int main(void) {
	std::string a, b;
	std::cin >> a >> b;
	if (a[0] != '-' && b[0] != '-') {
		std::cout << plus(a, b) << std::endl;
	} else if (a[0] == '-' && b[0] != '-') {
		a.erase(0, 1);
		if (upper(a, b)) {
			std::string res = minus(a, b);
			if (res[0] != '0') {
				std::cout << '-';
			}
			std::cout << res << std::endl;
		} else {
			std::swap(a, b);
			std::cout << minus(a, b) << std::endl;
		}
	} else if (a[0] != '-' && b[0] == '-') {
		b.erase(0, 1);
		if (upper(a, b)) {
			std::cout << minus(a, b);
		} else {
			std::swap(a, b);
			std::string res = minus(a, b);
			if (res[0] != '0') {
				std::cout << '-';
			}
			std::cout << res << std::endl;
		}
	} else {
		a.erase(0, 1);
		b.erase(0, 1);
		std::cout << '-' << plus(a, b) << std::endl;
	}
	return 0;
}