#include <iostream>
#include <vector>
#include <map>

using namespace std;

map<pair<int, int>, bool> queriesCache;

// inclusive
bool query(int l, int r) {
    pair<int, int> pr = make_pair(l, r);
    auto it = queriesCache.find(pr);
    if (it != queriesCache.end())
        return it->second;

    cout << "? " << l + 1 << " " << r + 1 << endl;
    cout.flush();
    string ans;
    cin >> ans;
    bool res = ans[0] == 'Y';
    queriesCache[pr] = res;
    return res;
}

struct Seg {
    int l, r;
    Seg(int l, int r): l(l), r(r) {}
};

string solve(int n) {
    string ans(n, ' ');

    vector<Seg> comps;
    vector<int> compN(n, -1);
    for (int l = 0; l < n - 1; l++) {
        if (query(l, l + 1)) {
            int i = comps.size();
            comps.push_back(Seg(l, l + 1));
            compN[l] = i;
            compN[l + 1] = i;
            ans[l] = '(';
            ans[l + 1] = ')';
            l++;
        }
    }

    vector<Seg> compsNew;
    while (true) {
        bool wasChange = false;
        for (Seg s : comps) {
            int i = compsNew.size();
            int l = s.l, r = s.r;

            //printf("[%d %d]\n", l, r);

            if (l == 0 || r == n - 1) {
                compsNew.push_back(s);
                compN[l] = compN[r] = i;
                continue;
            }

            int cl = compN[l - 1], cr = compN[r + 1];
            if (cl != -1) {
                compsNew[cl].r = r;
                compN[r] = cl;
                wasChange = true;
                continue;
            }

            if (cr != -1 || !query(l - 1, r + 1)) {
                compsNew.push_back(s);
                compN[l] = i, compN[r] = i;
                continue;
            } else {
                compsNew.push_back(Seg(l - 1, r + 1));
                ans[l - 1] = '(', ans[r + 1] = ')';
                compN[l - 1] = compN[r + 1] = i;
                wasChange = true;
            }
        }


        comps.swap(compsNew);
        compsNew.clear();

        if (!wasChange)
            break;
    }

    return ans;
}

int main() {
    int n;
    cin >> n;
    cout << "! " << solve(n) << endl;
}
