#include <iostream>
#include <fstream>
#include <cstdio>
#include <vector>

using namespace std;

typedef unsigned int uint;

const int MAX_N = 1e6 + 11;
const int MAX_LOGX = 31;

int n;
uint nums[MAX_N];
uint ans[MAX_N * 3 + 10];
uint mask[MAX_N * 3 + 10];

void printBin(uint x) {
    for (int i = 3; i >= 0; i--) {
        cout << ((x >> i) & 1);
    }
    cout << endl;
}

void mergeAnss(uint a, uint ma, uint b, uint mb, uint &c, uint &mc) {
    if (a == -1 || b == -1) {
        c = mc = -1;
        return;
    }

    uint mAnd = ma & mb;
    if ((a & mAnd) != (b & mAnd)) {
        c = mc = -1;
        return;
    }
    mc = ma | mb;
    c = (a | b) & mc;
}

void nbAns(uint a, uint b, uint &ans, uint &mask) {
    uint x = a ^ b;

    uint lastDiff = (1 << MAX_LOGX);

    while (lastDiff && (x & lastDiff) == 0)
        lastDiff >>= 1;
    //printf("ld: %d\n", lastDiff);
    if (lastDiff == 0) {
        ans = mask = 0;
        return;
    }

    mask = lastDiff;
    ans = 0;
    if (a & lastDiff) {
        ans = lastDiff;
    }
}

uint solve(int l, int r) {
    uint ansFin = 0, maskFin = 0;
    for (int i = l + 1; i < r; i++) {
        uint a = nums[i - 1], b = nums[i];
        uint ans, mask;
        nbAns(a, b, ans, mask);

        //printBin(ans);
        //printBin(mask);
        //cout << endl;

        mergeAnss(ans, mask, ansFin, maskFin, ansFin, maskFin);
    }

    //printf("[%d - %d):\n", l, r);
    //printBin(ansFin);
    //printBin(maskFin);

    return ansFin;
}

uint solve() {
    return solve(0, n);
}

void updateK(int l, int r, int k) {
    int m = (l + r) / 2;
    uint aL = ans[k * 2 + 1], mL = mask[k * 2 + 1];
    uint aR = ans[k * 2 + 2], mR = mask[k * 2 + 2];

    mergeAnss(aL, mL, aR, mR, ans[k], mask[k]);

    //printf("ST [%d - %d):\n", l, r);

    if (m > 0) {
        //printBin(ans[k]);
        //printBin(mask[k]);
        uint a = nums[m - 1], b = nums[m];
        uint nba, nbm;
        nbAns(a, b, nba, nbm);
        mergeAnss(nba, nbm, ans[k], mask[k], ans[k], mask[k]);
        //printf("--\n");
    }

    //printBin(ans[k]);
    //printBin(mask[k]);
    //solve(l, r);
    //cout << endl;
}

void setNum(int i, uint x, int l, int r, int k) {
    //printf("SN [%d - %d)\n", l, r);
    if (l == r - 1)
        return;


    int m = (l + r) / 2;
    if (i < m)
        setNum(i, x, l, m, k * 2 + 1);
    else
        setNum(i, x, m, r, k * 2 + 2);

    updateK(l, r, k);
}

void setNum(int i, int x) {
    nums[i] = x;
    setNum(i, x, 0, n, 0);
}



int main() {
    ifstream fin("order.in");

    fin >> n;
    for (int i = 0; i < n; i++) {
        fin >> nums[i];
    }

    for (int i = 0; i < n * 4; i++)
        ans[i] = mask[i] = 0;

    for (int i = 0; i < n; i++) {
        setNum(i, nums[i]);
    }

    //cout << solve() << " v " << ans[0] << endl << endl;
    cout << (int)ans[0] << endl;
    int q;
    fin >> q;
    for (int queryI = 0; queryI < q; queryI++) {
        int i, x;
        fin >> i >> x;
        i--;
        //printf("\n");
        nums[i] = x;
        setNum(i, x);
        //pr();
        //cout << solve() << " v " << ans[0] << endl;
        cout << (int)ans[0] << endl;
        //printf("%d (%d)\n", solve(), solveStupid());
        //break;
    }

    fin.close();
    return 0;
}
