#include <iostream>
#include <fstream>
#include <cstdio>
#include <vector>

using namespace std;

struct Exp {
    int l, r, c;
    Exp() {}
    Exp(int l, int r, int c): l(l), r(r), c(c) {}
};

typedef long long ll;

const int MAX_N = 100;
const int MAX_A = 1e7; // !!!!!!!!!
const long long INF = 1e18 + 2;
const long long MP = 1e9;

int n, a;
int minR;
Exp exps[MAX_N];

struct SegTree {
    int sz;
    vector<ll> tree;

    SegTree(int n) {
        sz = 1;
        while (sz < n)
            sz *= 2;
        tree = vector<ll>(sz * 2 - 1, 0); // !!!!!!!
    }

    void set(int i, ll x, int L, int R, int k) {
        if (L == R - 1) {
            tree[k] = x;
            return;
        }

        int mid = (L + R) / 2;
        if (i < mid)
            set(i, x, L, mid, k * 2 + 1);
        else
            set(i, x, mid, R, k * 2 + 2);
        tree[k] = min(tree[k * 2 + 1], tree[k * 2 + 2]);
    }

    void set(int i, ll x) {
        set(i, x, 0, sz, 0);
    }

    ll getMin(int l, int r, int L, int R, int k) {
        if (l <= L && R <= r)
            return tree[k];

        if (r <= L || R <= l)
            return INF;

        int mid = (L + R) / 2;
        return min(getMin(l, r, L, mid, k * 2 + 1),
                   getMin(l, r, mid, R, k * 2 + 2));
    }

    ll getMin(int l, int r) {
        return getMin(l, r, 0, sz, 0);
    }
};

int main() {
    ifstream fin("anti.in");
    fin >> n >> a;
    minR = -1;
    for (int i = 0; i < n; i++) {
        fin >> exps[i].l >> exps[i].r >> exps[i].c;
        if (minR == -1 || minR > exps[i].r)
            minR = exps[i].r;
    }
    fin.close();

    SegTree dp(a + 1);

    for (int t = 0; t <= a; t++) {
        if (t + minR > a)
            dp.set(t, t * MP);
    }

    for (int t = a; t >= 0; t--) {
        ll val = dp.getMin(t, t + 1);
        for (int i = 0; i < n; i++) {
            int l = exps[i].l, r = exps[i].r, c = exps[i].c;

            if (t + r > a)
                continue;

            ll minP = dp.getMin(t + l, t + r + 1);
            val = max(val, minP - c);
        }
        dp.set(t, val);
        //printf("dp[%2d] = %lld\n", t, dp[t]);
    }


    cout << dp.getMin(0, 1) << endl;
}
