#include <iostream>
#include <fstream>
#include <cstdio>
#include <set>

using namespace std;

const int MAX_N = 5e5 + 11;

typedef long long ll;

int qa, qb;
int numsA[MAX_N];
int ratA[MAX_N];
int numsB[MAX_N];
int ratB[MAX_N];

bool used[MAX_N * 2];

void solveStupid() {
    for (int i = 0; i < qa + qb; i++)
        used[i] = false;

    long long sum = 0;
    long long bestSum = 0;
    int bestLa = 0, bestRa = 0, bestLb = 0, bestRb = 0;
    for (int la = 0; la < qa; la++) {
        for (int ra = la; ra <= qa; ra++) {



            for (int lb = 0; lb < qb; lb++) {
                int rb = lb;
                for (; rb <= qb; rb++) {
                    if (sum > bestSum) {
                        bestSum = sum;
                        bestLa = la, bestRa = ra;
                        bestLb = lb, bestRb = rb;
                    }

                    if (rb < qb) {
                        if (used[numsB[rb]])
                            break;
                        used[numsB[rb]] = true;
                        sum += ratB[rb];
                    }
                }

                for (rb--; rb >= lb; rb--) {
                    used[numsB[rb]] = false;
                    sum -= ratB[rb];
                }
            }



            if (ra < qa) {
                sum += ratA[ra];
                used[numsA[ra]] = true;
            }
        }
        for (int ra = qa - 1; ra >= la; ra--) {
            sum -= ratA[ra];
            used[numsA[ra]] = false;
        }
    }

    cout << bestSum << endl;
    if (bestLa < bestRa)
        cout << bestLa + 1 << " " << bestRa << endl;
    else
        cout << "0 0" << endl;

    if (bestLb < bestRb)
        cout << bestLb + 1 << " " << bestRb << endl;
    else
        cout << "0 0" << endl;
}

void solve2() {
    for (int i = 0; i < qa + qb; i++)
        used[i] = false;

    long long sum = 0;
    long long bestSum = 0;
    int bestLa = 0, bestRa = 0, bestLb = 0, bestRb = 0;
    for (int la = 0; la < qa; la++) {
        for (int ra = la; ra <= qa; ra++) {

            int lb = 0, rb = 0;
            while (lb < qb) {
                long long sumB = 0;
                while (rb < qb && !used[numsB[rb]]) {
                    sumB += ratB[rb];
                    rb++;
                }

                if (sum + sumB > bestSum) {
                    bestSum = sum + sumB;
                    bestLa = la, bestRa = ra;
                    bestLb = lb, bestRb = rb;
                }
                lb = max(rb, lb + 1);
                rb = lb;
            }

            if (ra < qa) {
                sum += ratA[ra];
                used[numsA[ra]] = true;
            }
        }
        for (int ra = qa - 1; ra >= la; ra--) {
            sum -= ratA[ra];
            used[numsA[ra]] = false;
        }
    }

    cout << bestSum << endl;
    if (bestLa < bestRa)
        cout << bestLa + 1 << " " << bestRa << endl;
    else
        cout << "0 0" << endl;

    if (bestLb < bestRb)
        cout << bestLb + 1 << " " << bestRb << endl;
    else
        cout << "0 0" << endl;
}

struct Seg {
    int l, r;
    Seg(int l, int r): l(l), r(r) {}
    bool operator<(const Seg b) const {
        return l < b.l;
    }
};

ll partSums[MAX_N + 5];

ll getSum(int l, int r) {
    return partSums[r] - partSums[l];
}

struct SegBySum {
    int l, r;
    SegBySum(int l, int r): l(l), r(r) {}
    bool operator<(const SegBySum b) const {
        ll s1 = getSum(l, r);
        ll s2 = getSum(b.l, b.r);
        return s1 < s2 || (s1 == s2 && l < b.l);
    }
};

int iInB[MAX_N * 2 + 1];

void solve3() {
    partSums[0] = 0;
    for (int right = 1; right <= qb; right++)
        partSums[right] = partSums[right - 1] + ratB[right - 1];

    for (int i = 0; i < qa + qb; i++)
        iInB[i] = -1;
    for (int i = 0; i < qb; i++)
        iInB[numsB[i]] = i;

    long long sum = 0;
    long long bestSum = 0;
    int bestLa = 0, bestRa = 0, bestLb = 0, bestRb = 0;
    for (int la = 0; la < qa; la++) {
        set<Seg> segs;
        set<SegBySum> segsBySum;
        segs.insert(Seg(0, qb));
        segsBySum.insert(SegBySum(0, qb));
        for (int ra = la; ra <= qa; ra++) {
            /*
            for (Seg s : segs) {
                printf("[%d %d) ", s.l, s.r);
            }
            cout << endl;
            */

            SegBySum bestSeg = *segsBySum.rbegin();
            ll sumB = getSum(bestSeg.l, bestSeg.r);
            if (sum + sumB > bestSum) {
                bestSum = sum + sumB;
                bestLa = la, bestRa = ra;
                bestLb = bestSeg.l, bestRb = bestSeg.r;
            }

            if (ra < qa) {
                sum += ratA[ra];
                int i = iInB[numsA[ra]];
                if (i != -1) {
                    //printf("[%d %d): +%d\n", la + 1, ra + 1, i + 1);

                    auto it = segs.upper_bound(Seg(i, 0));
                    it--;
                    Seg s = *it;
                    Seg sLeft = Seg(s.l, i);
                    Seg sRight = Seg(i + 1, s.r);
                    segs.erase(s);
                    segsBySum.erase(SegBySum(s.l, s.r));
                    segs.insert(sLeft);
                    segs.insert(sRight);
                    segsBySum.insert(SegBySum(s.l, i));
                    segsBySum.insert(SegBySum(i + 1, s.r));
                }
            }
        }
        //cout << endl;
        for (int ra = qa - 1; ra >= la; ra--) {
            sum -= ratA[ra];
        }
    }

    cout << bestSum << endl;
    if (bestLa < bestRa)
        cout << bestLa + 1 << " " << bestRa << endl;
    else
        cout << "0 0" << endl;

    if (bestLb < bestRb)
        cout << bestLb + 1 << " " << bestRb << endl;
    else
        cout << "0 0" << endl;
}

int main() {
    ifstream fin("internship.in");
    fin >> qa >> qb;
    for (int i = 0; i < qa; i++)
        fin >> numsA[i];
    for (int i = 0; i < qa; i++)
        fin >> ratA[i];
    for (int i = 0; i < qb; i++)
        fin >> numsB[i];
    for (int i = 0; i < qb; i++)
        fin >> ratB[i];
    fin.close();


    for (int i = 0; i < qa; i++)
        numsA[i]--;

    for (int i = 0; i < qb; i++)
        numsB[i]--;

    //solveStupid();
    //cout << endl;
    solve3();
}
