#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;

unordered_map < int, int > mn, mx;
unordered_map < int, set < int > > base, all;
unordered_map < int, int > ms, cn;
const int PW = 3;
vector < int > must(PW, 0), cant(PW, 0);

void add(int v, int lv, int x, int i) {
	if (lv == PW) {
		base[v].insert(i);
		mn[v] = *base[v].begin();
		auto j = base[v].end();
		j--;
		mx[v] = *j;
		return;
	}
	must[lv] -= ms[v], cant[lv] -= cn[v];
	ms[v] -= ms[v], cn[v] -= cn[v];
	all[lv].insert(v);
	if (x & (1 << (PW - lv - 1)))
		add(2 * v + 2, lv + 1, x, i);
	else
		add(2 * v + 1, lv + 1, x, i);
	bool is_l = mn.count(2 * v + 1), is_r = mn.count(2 * v + 2);
	if (is_l && is_r && mx[2 * v + 1] > mn[2 * v + 2]) {
		ms[v]++;
		must[lv]++;
	}
	if (is_l && is_r && mn[2 * v + 1] < mx[2 * v + 2]) {
		cn[v]++;
		cant[lv]++;
	}
	mx[v] = max((is_l ? mx[2 * v + 1] : 0), (is_r ? mx[2 * v + 2] : 0));
	mn[v] = min((is_l ? mn[2 * v + 1] : 1e9), (is_r ? mn[2 * v + 2] : 1e9));
	return;
}

void del(int v, int lv, int x, int i) {
	if (lv == PW) {
		base[v].erase(i);
		if (base[v].empty()) {
			base.erase(v);
			mn.erase(v);
			mx.erase(v);
			return;
		}
		mn[v] = *base[v].begin();
		auto j = base[v].end();
		j--;
		mx[v] = *j;
		return;
	}
	must[lv] -= ms[v], cant[lv] -= cn[v];
	ms[v] -= ms[v], cn[v] -= cn[v];
	all[lv].insert(v);
	if (x & (1 << (PW - lv - 1)))
		del(2 * v + 2, lv + 1, x, i);
	else
		del(2 * v + 1, lv + 1, x, i);
	bool is_l = mn.count(2 * v + 1), is_r = mn.count(2 * v + 2);
	if (!is_l && !is_r) {
		all[lv].erase(v);
		mn.erase(v);
		mx.erase(v);
		ms.erase(v);
		cn.erase(v);
		return;
	}
	if (is_l && is_r && mx[2 * v + 1] > mn[2 * v + 2]) {
		ms[v]++;
		must[lv]++;
	}
	if (is_l && is_r && mn[2 * v + 1] < mx[2 * v + 2]) {
		cn[v]++;
		cant[lv]++;
	}
	mx[v] = max((is_l ? mx[2 * v + 1] : 0), (is_r ? mx[2 * v + 2] : 0));
	mn[v] = min((is_l ? mn[2 * v + 1] : 1e9), (is_r ? mn[2 * v + 2] : 1e9));
	return;
}

int get() {
	int ans = 0;
	for (int i = 0; i < PW; i++) {
		if (must[i] && cant[i])
			return -1;
		if (must[i])
			ans |= 1 << (PW - i - 1);
	}
	return ans;
}

int main() {
	iostream::sync_with_stdio(0);

	int n;
	cin >> n;

	vector < int > a(n);

	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		a[i] = x;
		add(0, 0, x, i);
	}

	cout << get() << '\n';

	int q;
	cin >> q;

	for (int i = 0; i < q; i++) {
		int p, v;
		cin >> p >> v;
		p--;
		del(0, 0, a[p], p);
		a[p] = v;
		add(0, 0, a[p], p);
		cout << get() << '\n';
	}

	return 0;
}