#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const long long MX = 1e5;
long long dp[MX];

int main() {
	iostream::sync_with_stdio(0);

	int n, a;
	cin >> n >> a;

	const long long INF = 1e9, IINF = 1e18;

	vector < pair < pair < long long, long long >, long long > > q(n);
	while (n--) {
		long long l, r, c;
		cin >> l >> r >> c;
		q[n] = { {l, r}, c };
	}
	sort(q.begin(), q.end(), [](pair < pair < long long, long long >, long long > &a, pair < pair < long long, long long >, long long > &b) {
		return a.first.second < b.first.second;
	});
	for (int i = 0; i <= a; i++) {
		for (auto &j : q) {
			long long l = j.first.first, r = j.first.second, c = j.second;
			if (i - r < 0)
				break;
			long long worst = IINF;
			for (int add = l; add <= r; add++)
				worst = min(worst, dp[i - add] - c);
			dp[i] = max(dp[i], worst);
		}
		for (int j = 0; j <= i; j++)
			dp[j] += INF;
	}

	long long mx = 0;
	for (long long i = 0; i <= a; i++) {
		mx = max(mx, dp[i] - (a - i + 1) * INF);
	}

	cout << mx;

	return 0;
}