#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <cassert>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<ll> vll;
typedef vector<pii> vpii;

#define X first
#define Y second
#define inb push_back
#define outb pop_back
#define mk make_pair

int solve();

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = 2e5 + 7;
const ll LINF = (ll)8e18 + 7;

struct edge
{
	int x, dir, l, r;
	edge() { dir = 0; };
	edge(int x, int dir, int l, int r) : x(x), dir(dir), l(l), r(r) {};
};

int n;
int le[MAXN], re[MAXN];
int tim[MAXN];
edge el[MAXN], er[MAXN];
int was[MAXN];
int cnt;
int it;

void dfs(int u, int t)
{
	++cnt;
	was[u] = it;
	if (u > 0 && was[u - 1] != it)
	{
		int nu = u - 1;
		if (le[nu] <= t && t <= re[nu])
		{
			dfs(u - 1, t);
		}
		else
		{
			if (le[nu] > t && t + tim[u] >= le[nu])
				dfs(u - 1, le[nu]);
		}
	}
	if (u < n - 1 && was[u + 1] != it)
	{
		int nu = u;
		if (le[nu] <= t && t <= re[nu])
		{
			dfs(u + 1, t);
		}
		else
		{
			if (le[nu] > t && t + tim[u] >= le[nu])
				dfs(u + 1, le[nu]);
		}
	}
}

void sol()
{
	for (int i = 0; i < n; ++i)
	{
		int f = 1;
		for (int t = 0; t <= 500; ++t)
		{
			cnt = 0;
			++it;
			dfs(i, t);
			if (cnt == n)
			{
				f = 0;
				cout << t << "\n";
				break;
			}
		}
		if (f)
			puts("-1");
	}
	exit(0);
}

int okl[MAXN], okr[MAXN];
int lstl = n;

void sol1()
{
	int cur = 0;
	lstl = n;
	for (int i = 0; i < n - 1; ++i)
	{
		if (cur > re[i])
		{
			lstl = i;
			break;
		}
		cur = max(cur, le[i]);
	}
	cur = 0;
	int lstr = -1;
	for (int i = n - 2; i >= 1; --i)
	{
		if (cur > re[i])
		{
			lstr = i - 1;
			break;
		}
		cur = max(cur, le[i]);
	}
	for (int i = 0; i < n; ++i)
	{
		if (lstr <= i && lstl >= i)
			puts("0");
		else
			puts("-1");
	}
	exit(0);
}

int solve()
{
	cin >> n;
	int teq5000 = 1;
	for (int i = 0; i < n; ++i)
	{
		cin >> tim[i];
		if (tim[i] != 5000 && tim[i] != 1000000000)
			teq5000 = 0;
	}
	if (n == 1)
		puts("0"), exit(0);
	for (int i = 0; i < n - 1; ++i)
		cin >> le[i] >> re[i];
	if (teq5000)
		sol1();
	if (n <= 500)
		sol();
	return 0;
}
