#include <iostream>
#include <string>
#include <vector>
#include <tuple>
#include <algorithm>


using namespace std;

vector<pair<long long, long long>> edges;
vector<long long> caches;
vector<pair<long long, long long>> times;


long long n;

long long sv(long long x, long long m)
{
	times.assign(n, make_pair(-1, -1));
	long long res = 0;
	times[x] = make_pair(m, m + caches[x]);
	for (long long i = x + 1; i < n; ++i)
	{
		if (edges[i - 1].first > times[i - 1].second)
			return -1;
		if (edges[i - 1].second < times[i - 1].first)
			return -1;
		times[i].first = max(edges[i - 1].first, times[i - 1].first);
		times[i].second = times[i].first + caches[i];
	}
	for (long long i = x - 1; i >= 0; --i)
	{
		if (edges[i].first > times[i + 1].second)
			return -1;
		if (edges[i].second < times[i + 1].first)
			return -1;
		times[i].first = max(edges[i].first, times[i + 1].first);
		times[i].second = times[i].first + caches[i];
	}
	return res;
}

long long solve(long long x)
{
	for (int i = 0; i <= 5000; ++i)
	{
		if (sv(x, i) != -1)
			return i;
	}
	return -1;
}


int main()
{
	bool f1 = true;
	cin >> n;
	edges.resize(n);
	caches.resize(n);
	times.resize(n);
	for (long long i = 0; i < n; ++i)
	{
		cin >> caches[i];
		if (caches[i] != 5000)
			f1 = false;
	}
	for (long long i = 0; i < n - 1; ++i)
	{
		long long l, r;
		cin >> l >> r;
		edges[i] = make_pair(l, r);
	}
	if (f1)
	{
		for (int i = 0; i < n; ++i)
		{
			cout << sv(i, 0) << endl;
		}
		return 0;
	}
	for (long long i = 0; i < n; ++i)
	{
		cout << solve(i) << endl;
	}
	return 0;
}