#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int) (x).size()
#define mp(x, y) make_pair(x, y)
#define pb(x) push_back(x)
#define all(x) (x).begin(), x.end()

typedef long long ll;

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;

void run();

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

struct Treap {
	int x, y;
	Treap *l, *r;
	
	Treap(int x) : x(x), y(rand()), l(0), r(0) {}
};

Treap* merge(Treap *a, Treap *b) {
	if (a == 0 || b == 0) {
		return a == 0 ? b : a;
	}
	
	if (a->y > b->y) {
		a->r = merge(a->r, b);
		return a;
	} else {
		b->l = merge(a, b->l);
		return b;
	}
}

pair<Treap*, Treap*> split(Treap *t, int x) {
	if (t == 0) {
		return {0, 0};
	}
	
	if (t->x <= x) {
		auto tmp = split(t->r, x);
		t->r = tmp.first;
		tmp.first = t;
		return tmp;
	} else {
		auto tmp = split(t->l, x);
		t->l = tmp.second;
		tmp.second = t;
		return tmp;
	}
}

Treap* add(Treap *t, int x) {
	auto tmp = split(t, x);
	tmp.first = merge(tmp.first, new Treap(x));
	tmp.first = merge(tmp.first, tmp.second);
	return tmp.first;
}

int get_min(Treap *t) {
	if (t == nullptr) {
		return INF;
	}
	
	if (t->l != nullptr) {
		return get_min(t->l);
	} else {
		return t->x;
	}
}

const int N = (int) 7e5 + 123;

void run() {
	Treap *root = 0;
	for (int i = 0; i < N; i++) {
		root = add(root, rand());
	}
	
	cout << get_min(root) << "\n";
}
