#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <random>
#include <algorithm>
#include <functional>

const int N = 1<<20;

struct edge_t {
    int v, u, tm;
} edges[N];

struct dist_t {
    int tm;
    int64_t qu;
    dist_t() : tm(1<<30), qu(-1) {};
    dist_t(int _tm, int64_t _qu) :
        tm(_tm), qu(_qu) {};
} dists[N];

bool operator<(const dist_t& a, const dist_t& b)
{
    if (a.tm != b.tm) return a.tm < b.tm;
    return a.qu > b.qu;
}

dist_t add(const dist_t& d, int tm)
{
    return dist_t(d.tm + tm, d.qu + (int64_t)tm*tm);
}

int main()
{
    int n, m; scanf("%d%d", &n, &m);

    int sz = 0;
    for (int i = 0; i < m; ++i) {
        int s, v, d; scanf("%d%d", &s, &v), --v;
        std::vector<int> vs(1, v);
        std::vector<int> ds;
        vs.reserve(s+2);
        ds.reserve(s+2);
        for (int j = 0; j < s; ++j) {
            scanf("%d%d", &d, &v), --v;
            ds.push_back(d),
            vs.push_back(v);
        }
        for (int j = 0; j < (int)vs.size(); ++j) {
            int d_sum = 0;
            for (int k = j+1; k < (int)vs.size(); ++k) {
                d_sum += ds[k-1];
                assert(sz < N);
                edges[sz++] = {vs[j], vs[k], d_sum};
            }
        }
    }

    dists[0] = dist_t(0, 0);

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < sz; ++j) {
            dist_t d = add(dists[edges[j].v], edges[j].tm);
            if (d < dists[edges[j].u])
                dists[edges[j].u] = d;
        }

    printf("%d %lld\n", dists[n-1].tm, dists[n-1].qu);

    return 0;
}
