#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <random>
#include <algorithm>
#include <functional>

const int N = 1<<20;

struct edge_t {
    std::vector<int> vs;
    std::vector<int> ds;
} edges[N];

struct dist_t {
    int tm;
    int64_t qu;
    dist_t() : tm(1<<30), qu(-1) {};
    dist_t(int _tm, int64_t _qu) :
        tm(_tm), qu(_qu) {};
} dists[N];

bool operator<(const dist_t& a, const dist_t& b)
{
    if (a.tm != b.tm) return a.tm < b.tm;
    return a.qu > b.qu;
}

dist_t add(const dist_t& d, int tm)
{
    return dist_t(d.tm + tm, d.qu + (int64_t)tm*tm);
}

int main()
{
    int n, m; scanf("%d%d", &n, &m);

    for (int i = 0; i < m; ++i) {
        int s, v, d; scanf("%d%d", &s, &v), --v;
        std::vector<int> vs(1, v);
        std::vector<int> ds;
        vs.reserve(s+2);
        ds.reserve(s+2);
        for (int j = 0; j < s; ++j) {
            scanf("%d%d", &d, &v), --v;
            ds.push_back(d),
            vs.push_back(v);
        }
        edges[i] = {vs, ds};
    }

    dists[0] = dist_t(0, 0);

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) {
            int tm = dists[edges[j].vs[0]].tm;
            int64_t qu = dists[edges[j].vs[0]].qu;
            int it_tm = 0;
            for (int k = 1; k < (int)edges[j].vs.size(); ++k) {
                it_tm += edges[j].ds[k-1];
                dist_t d = dist_t(tm + it_tm, qu + (int64_t)it_tm*it_tm);
                if (dists[edges[j].vs[k]] < d) {
                    tm = dists[edges[j].vs[k]].tm;
                    qu = dists[edges[j].vs[k]].qu;
                    it_tm = 0;
                } else
                    dists[edges[j].vs[k]] = d;
            }
        }

    printf("%d %lld\n", dists[n-1].tm, dists[n-1].qu);

    return 0;
}
