#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <random>
#include <algorithm>

const int N = 1000;

char val1[N];
char val2[N];
char res[N];

bool abs_cmp(char* a1, char* a2)
{
    int n1 = strlen(a1);
    int n2 = strlen(a2);
    if (n1 != n2) return n1 < n2;
    for (int i = 0; i < n1; ++i)
        if (a1[i] != a2[i])
            return a1[i] < a2[i];
    return false;
}

void abs_sum(char* a1, char* a2, char* s)
{
    int n1 = strlen(a1);
    int n2 = strlen(a2);
    std::reverse(a1, a1+n1);
    std::reverse(a2, a2+n2);
    for (int i = 0; i < n1; ++i) a1[i] -= '0';
    for (int i = 0; i < n2; ++i) a2[i] -= '0';
    int ns = std::max(n1, n2);
    int r = 0;
    for (int i = 0; i < ns; ++i)
        r += a1[i] + a2[i],
        s[i] = r%10,
        r /= 10;
    while (r)
        s[ns++] = r%10,
        r /= 10;
    for (int i = 0; i < ns; ++i) s[i] += '0';
    std::reverse(s, s+ns);
}

void abs_sub(char* a1, char* a2, char* dif)
{
    int n1 = strlen(a1);
    int n2 = strlen(a2);
    std::reverse(a1, a1+n1);
    std::reverse(a2, a2+n2);
    for (int i = 0; i < n1; ++i) a1[i] -= '0';
    for (int i = 0; i < n2; ++i) a2[i] -= '0';
    int nd = std::max(n1, n2);
    int r = 0, d = 0;
    for (int i = 0; i < nd; ++i) {
        r += a1[i] - a2[i] + d;
        while (r < 0)
            r += 10,
            d -= 10;
        dif[i] = r%10;
        r /= 10;
        d /= 10;
    }
    while (nd > 1 && !dif[nd-1]) --nd;
    for (int i = 0; i < nd; ++i) dif[i] += '0';
    std::reverse(dif, dif+nd);
}

int main()
{
    scanf("%s", val1);
    scanf("%s", val2);
    bool neg1 = (val1[0] == '-');
    bool neg2 = (val2[0] == '-');
    if (neg1 == neg2) {
        if (neg1)
            res[0] = '-',
            abs_sum(val1+1, val2+1, res+1);
        else
            abs_sum(val1, val2, res);
    } else if (neg1 && !neg2) { /// val2 - val1
        if (abs_cmp(val2, val1+1))
            res[0] = '-',
            abs_sub(val1+1, val2, res+1);
        else
            abs_sub(val2, val1+1, res);
    } else if (neg2 && !neg1) { /// val1 - val2
        if (abs_cmp(val1, val2+1))
            res[0] = '-',
            abs_sub(val2+1, val1, res+1);
        else
            abs_sub(val1, val2+1, res);
    }

    printf("%s", res);

    return 0;
}
