#include <algorithm>
#include <iostream>
#include <bitset>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <ctime>
#include <random>

using namespace std;

template<class T> inline void chkmin(T& a, T b) { if (a > b) a = b; }
template<class T> inline void chkmax(T& a, T b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 50000;

int cnt = 0;

bool Ask(int l, int r) {
	++cnt;
	assert(cnt < 10000);
	cout << "? " << l + 1 << ' ' << r << '\n';
	string ans;
	cin >> ans;
	return ans == "Yes";
}

bitset<MAXN> res;

void Solve(int l, int r) {
	if (l == r) return;
	res[l] = 1;
	if (l + 2 == r) return;
	if (Ask(l + 1, r - 1)) {
		Solve(l + 1, r - 1);
		return;
	}
	for (int m = l + 2; m < r - 2; m += 2) {
		if (Ask(l, m)) {
			Solve(l + 1, m - 1);
			Solve(m, r);
			return;
		}
	}
	Solve(l + 1, r - 3);
	Solve(r - 2, r);
}

int main() {
	int n;
	cin >> n;
	Solve(0, n);
	cout << "! ";
	for (int i = 0; i < n; ++i) {
		cout << (res[i] ? '(' : ')');
	}
	cout << '\n';
	//while (true) ++n;
	//cout << n << '\n';
}

