#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long INF = 1000000000000000000;

pair<long long, long long> s(pair<long long, long long> a1, pair<long long, long long> a2) {
	return{ max(a1.first, a2.first), min(a1.second, a2.second) };
}

bool in(pair<long long, long long> a, long long val) {
	return a.first <= val && a.second >= val;
}

int main()
{
	int n;
	cin >> n;
	vector<long long> t(n);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	vector<pair<long long, long long> > seg(n - 1);
	for (int i = 0; i < n - 1; i++) {
		cin >> seg[i].first >> seg[i].second;
	}
	vector<pair<long long, long long> > pref(n), suf(n);
	pref[0] = { 0, INF };
	suf[n - 1] = { 0, INF };
	for (int i = 1; i < n; i++) {
		if (pref[i - 1] == make_pair(-1ll, -1ll)) {
			pref[i] = { -1, -1 };
			continue;
		}
		pair<long long, long long> p = s(pref[i - 1], seg[i - 1]);
		if (p.first > p.second) {
			pref[i] = { -1, -1 };
		}
		else {
			long long l, r;
			if (in(pref[i - 1], seg[i - 1].first)) {
				l = max(0ll, seg[i - 1].first - t[i]);
			}
			else {
				l = p.first;
			}
			r = p.second;
			pref[i] = { l, r };
		}
	}
	for (int i = n - 2; i >= 0; i--) {
		if (suf[i + 1] == make_pair(-1ll, -1ll)) {
			suf[i] = { -1, -1 };
			continue;
		}
		pair<long long, long long> p = s(suf[i + 1], seg[i]);
		if (p.first > p.second) {
			suf[i] = { -1, -1 };
		}
		else {
			long long l, r;
			if (in(suf[i + 1], seg[i].first)) {
				l = max(0ll, seg[i].first - t[i]);
			}
			else {
				l = p.first;
			}
			r = p.second;
			suf[i] = { l, r };
		}
	}
	/*for (int i = 0; i < n; i++) {
		cout << pref[i].first << ' ' << pref[i].second << endl;
	}
	cout << endl;
	for (int i = 0; i < n; i++) {
		cout << suf[i].first << ' ' << suf[i].second << endl;
	}*/
	for (int i = 0; i < n; i++) {
		if (pref[i] == make_pair(-1ll, -1ll) || suf[i] == make_pair(-1ll, -1ll)) {
			cout << -1 << endl;
		}
		else {
			pair<long long, long long> p = s(pref[i], suf[i]);
			if (p.first <= p.second) {
				cout << p.first << endl;
			}
			else {
				cout << -1 << endl;
			}
		}
	}
    return 0;
}

