#include <algorithm>
#include <random>
#include <iostream>
#include <cstdio>
#include <vector>
#include <ctime>
#include <cmath>
using namespace std;
#define int long long

struct dot {
	int x, y, id;
	dot (int x = 0, int y = 0) : x(x), y(y) {}
	int operator | (dot A) {
		return ((x - A.x) * (x - A.x) + (y - A.y) * (y - A.y));
	}
};

struct vec {
	int x, y;
	vec (int x = 0, int y = 0) : x(x), y(y) {}
	vec(dot A, dot B) {
		x = B.x - A.x;
		y = B.y - A.y;
	}
	int operator * (vec A) {
		return x * A.x + y * A.y;
	}
	int operator % (vec A) {
		return x * A.y - y * A.x;
	}
};

vec operator >> (dot A, dot B) {
	return vec(A, B);
}

int sgn(int x) {
	if (x == 0)
		return 0;
	if (x < 0)
		return -1;
	return 1;
}

bool inside(dot A, dot B, dot C, dot P) {
	if ((sgn(((A >> C) % (A >> B))) * sgn(((A >> P) % (A >> B)))) <= 0)
		return false;
	return true;
}

bool doins(dot A, dot B, dot C, dot P) {
	return inside(A, B, C, P) && inside(B, C, A, P) && inside(C, A, B, P); 
}

dot read_dot(int i) {
	dot A;
	cin >> A.x >> A.y;
	A.id = i;
	return A;
}
int n;
vector <dot> arr;

vector <vector <dot> > imp(1);

dot cmp_dot;

std::random_device rd;
std::mt19937 g(rd());

bool cmp_hull (dot A, dot B) {
	if (((cmp_dot >> A) % (cmp_dot >> B)) == 0) {
		return (cmp_dot|A) < (cmp_dot|B);
	}
	return (((cmp_dot >> A) % (cmp_dot >> B)) > 0);
}

bool cmp(dot A, dot B) {
	return (A.y < B.y || (A.y == B.y && A.x < B.x));
}

void disp_poly(vector <dot> & arr) {
	cout << arr.size() << " ";
	for (auto x : arr) {
		cout << x.id << " ";
	}
	cout << endl;
}

vector <vector <int> > graph(1);

bool operator != (dot A, dot B) {
	return (A.x != B.x || A.y != B.y);
}

void sol() {
	int cur = 1;
	while(1) {
		shuffle(graph[cur].begin(), graph[cur].end(), g);
		if (graph[cur].empty()) {
			cout << "! ";
			disp_poly(imp[cur]);
			return;
		}
		for (auto x : graph[cur]) {
			if (x == graph[cur].back()) {
				cur = x;
				break;
			}
			cout << "? ";
			disp_poly(imp[x]);
			string resp;
			cin >> resp;
			if (resp == "Yes") {
				cur = x;
				break;
			}
		}
	}
	// vector <int> arr2(1e9);
}



int num_ver = 1;

void build (vector <dot> & arr, int n, int p = 0) {
	cmp_dot = *min_element(arr.begin(), arr.end(), cmp);
	sort(arr.begin(), arr.end(), cmp_hull);
	vector <dot> ans;
	ans.push_back(cmp_dot);
	vector <dot> draft;
	for (auto A : arr) {
		if (A.x == cmp_dot.x && A.y == cmp_dot.y) {continue;}
		while (ans.size() > 1 && ((ans[ans.size() - 2] >> ans.back()) % (ans.back() >> A)) <= 0) {
			draft.push_back(ans.back());
			ans.pop_back();
		}
		ans.push_back(A);
	}
	// arr.clear();
	int my_id = num_ver;
	num_ver++;
	imp.push_back(ans);
	graph[p].push_back(my_id);
	graph.push_back(vector <int> (0));
	

	if (draft.empty()) {
		// imp.push_back(ans);
		return;
	}
	n = arr.size();
	int x = rand() % (int)(draft.size());
	iter_swap(draft.begin(), draft.end());
	vec cur = vec(ans[0], draft[0]);
	int pt = 0;
	vector <dot> curr;
	curr.push_back(ans[0]);
	curr.push_back(draft[0]);
	for(; pt < n; pt++) {
		if ((vec(ans[0], arr[pt]) % cur) >= 0 && arr[pt] != ans[0] && arr[pt] != draft[0]) {
			curr.push_back(arr[pt]);
		}
	}
	build(curr, curr.size(), my_id);
	curr.resize(2);
	for(; pt < n; pt++) {
		if (arr[pt] != ans[0] && arr[pt] != draft[0]) {
			curr.push_back(arr[pt]);
		}
	}
	build(curr, curr.size(), my_id);
}



signed main() {

	cin >> n;
	arr.resize(n);
	for (int i = 0; i < n; i++) {
		arr[i] = read_dot(i + 1);
	}
	int q;
	cin >> q;

	build(arr, n);

	// cmp_dot = *min_element(arr.begin(), arr.end(), cmp);
	// sort(arr.begin(), arr.end(), cmp_hull);
	// for (int i = 1; i < n - 1; i++) {
	// 	imp.push_back(vector <dot> ({arr[0], arr[i], arr[i + 1]}));
	// }
	// vector <dot> curr;
	// for (int i = 2; i < n - 1; i++) {
	// 	if (((arr[i - 1] >> arr[i]) % (arr[i] >> arr[i + 1])) <= 0) {
	// 		if (curr.size() == 0) {
	// 			curr.push_back(arr[i - 1]);
	// 			curr.push_back(arr[i]);
	// 		}
	// 		curr.push_back(arr[i + 1]);
	// 	} else {
	// 		if (not curr.empty()) {
	// 			imp.push_back(curr);
	// 			curr.clear();
	// 		}
	// 	}
	// }
	// if (not curr.empty()) {
	// 	imp.push_back(curr);
	// }


	for (int i = 0; i < q; i++) {
		sol();
	}
	// for (auto u : graph) {
	// 	for (auto v : u) {
	// 		cout << v << " ";
	// 	}
	// 	cout << endl;
	// }
	return 0;
}