#include <algorithm>
#include <iostream>
#include <iterator>
#include <cstdio>
#include <vector>
#include <set>
using namespace std;
#define int long long
const int INF = 1e10;

struct tree {
	int n;
	vector <int> pref;
	tree() {}
	tree(vector <int> & arr) {
		n = arr.size();
		pref.resize(n + 1, 0);
		for (int i = 0; i < n; i++) {
			pref[i + 1] = pref[i] + arr[i];
		}
	}
	int get(int l, int r) {
		return pref[r + 1] - pref[l];
	}
};

tree A_tree, B_tree;

set <pair <int, pair <int, int> > > cur;
set <pair <int, int> > blocks;

pair <int, pair <int, int> > get_val(pair <int, int> A) {
	return make_pair(-B_tree.get(A.second, A.first), A);
}

void split(int x) {
	auto it = blocks.lower_bound({x, -1});
	auto curr = *it;
	blocks.erase(it);
	cur.erase(get_val(curr));
	if (curr.second == x && curr.first == x) {
		return;
	}
	if (curr.second == x) {
		blocks.insert({curr.first, curr.second + 1});
		cur.insert(get_val({curr.first, curr.second + 1}));
	} else if (x == curr.first) {
		blocks.insert({curr.first - 1, curr.second});
		cur.insert(get_val({curr.first - 1, curr.second}));
	} else {
		blocks.insert({curr.first, x + 1});
		cur.insert(get_val({curr.first, x + 1}));

		blocks.insert({x - 1, curr.second});
		cur.insert(get_val({x - 1, curr.second}));
	}
}

signed main() {
	freopen("internship.in", "r", stdin);
	freopen("internship.out", "w", stdout);

	int n, m;
	cin >> n >> m;
	vector <int> A(n, 0);
	vector <int> A_pr(n,0);
	vector <int> B(m, 0);
	vector <int> B_pr(m,0);
	for (int i = 0; i < n; i++) {
		cin >> A[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> A_pr[i];
	}

	for (int i = 0; i < m; i++) {
		cin >> B[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> B_pr[i];
	}

	A_tree = tree(A_pr);
	B_tree = tree(B_pr);


	vector <int> place_to(10000, -1);
	for (int i = 0; i < m; i++) {
		place_to[B[i]] = i;

	}

	int ans = -6;
	pair <int, int> xx = {-1, -1};
	pair <int, int> yy = {-1, -1};

	for (int i = 0; i < n; i++) {
		cur.clear();
		blocks.clear();

		blocks.insert(make_pair(m - 1, 0));
		cur.insert(get_val(make_pair(m - 1, 0)));
		for (int j = i; j < n; j++) {
			if (place_to[A[j]] != -1) {
				split(place_to[A[j]]);
			}
			if (-(*cur.begin()).first + A_tree.get(i, j) >= ans) {
				ans = -(*cur.begin()).first + A_tree.get(i, j);
				xx = {i, j};
				yy = {(*cur.begin()).second.second, (*cur.begin()).second.first};
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = i; j < n; j++) {
			if (A_tree.get(i, j) >= ans) {
				ans = A_tree.get(i, j);
				xx = {i, j};
				yy = {-1, -1};
			}
		}
	}

	for (int i = 0; i < m; i++) {
		for (int j = i; j < m; j++) {
			if (B_tree.get(i, j) >= ans) {
				ans = B_tree.get(i, j);
				yy = {i, j};
				xx = {-1, -1};
			}
		}
	}
	cout << ans << endl;
	cout << xx.first + 1 << " " << xx.second + 1 << endl;
	cout << yy.first + 1 << " " << yy.second + 1 << endl;

	fclose(stdin);
	fclose(stdout);
	return 0;
}