#include <fstream>
#include <vector>
#include <deque>


using namespace std;

struct dl{
    int a;
    int b;
    int cost;
};

vector<vector<pair<int, int> > > path(1000, vector<pair<int, int> > (0));
int res = 0;

int dfs(int v, int now, int u, int n, int x) {
    if (now > u) return 0;
    if (v == n - 1) res = max(res, x);
    for (auto t : path[v]) {
        dfs(t.first, now + t.second, u, n, x + t.second * t.second);
    }
    return 0;
}

vector<dl> q(1000);

const int INF = 100000000;

int dejxtra(int v, int n) {
    vector<int> t(n, INF);
    t[v] = 0;
    vector<int> r(n, INF);
    r[v] = -2;
    for (auto k : path[v]) {
        r[k.first] = min(r[k.first], k.second);
    }
    while (true) {
        int min_dist = INF;
        int u1 = -1;
        for (int i = 0; i < n; i++) {
            if (min_dist > r[i] and r[i] >= 0) {
                u1 = i;
                min_dist = r[i];
            }
        }
        if (min_dist == INF) break;
        t[u1] = min_dist;
        r[u1] = -2;
        for (auto k : path[u1]) {
            if (r[k.first] != -2) {
                r[k.first] = min(r[k.first], min_dist + k.second);
            }
        }
    }
    return t[n - 1];
}


int main() {
    ifstream cin("trains.in");
    ofstream cout("trains.out");
    int u;
    int n, m, a, b, c, d;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> c >> d;
        path[b - 1].push_back(make_pair(d - 1, c));
    }
    u = dejxtra(0, n);
    dfs(0, 0, u, n, 0);
    cout << u << " " << res << endl;
}
