// A.cpp : Defines the entry point for the console application.
//

#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = (int) 1e5;

int tree[4 * MAXN];
vector<int> arr;

void build(int v, int tl, int tr)
{
	if (tl == tr - 1)
	{
		tree[v] = arr[tl];
		return;
	}
	double flp = (tl + tr + 0.0) / 2 - ((tl + tr) / 2);
	int tm;
	if (flp != 0.0)
	{
		tm = (tl + tr) / 2 + 1;
	}
	else
	{
		tm = (tl + tr) / 2;
	}

	build(v * 2, tl, tm);
	build(v * 2 + 1, tm, tr);
	tree[v] = tree[v * 2 + 1] + tree[v * 2];
	return;
}

int get(int v, int tl, int tr, int l, int r)
{
	if (tl > r - 1 || tr - 1 < l)
	{
		return 0;
	}

	if (tl >= l && tr <= r)
	{
		return tree[v];
	}

	int tm;
	double flp = (tl + tr + 0.0) / 2 - ((tl + tr) / 2);
	if (flp != 0.0)
	{
		tm = (tl + tr) / 2 + 1;
	}
	else
	{
		tm = (tl + tr) / 2;
	}

	return get(v * 2, tl, tm, l, r) + get(v * 2 + 1, tm, tr, l, r);
}

void change(int v, int tl, int tr, int new_v, int pos)
{
	if (!(tl <= pos && tr - 1 >= pos))
	{
		return;
	}

	if (tl + 1 == tr)
	{
		tree[v] = new_v;
		return;
	}

	double flp = (tl + tr + 0.0) / 2 - ((tl + tr) / 2);
	int tm;
	if (flp != 0.0)
	{
		tm = (tl + tr) / 2 + 1;
	}
	else
	{
		tm = (tl + tr) / 2;
	}
	change(v * 2, tl, tm, new_v, pos);
	change(v * 2 + 1, tm, tr, new_v, pos);
	tree[v] = tree[v * 2] + tree[v * 2 + 1];
	return;
}

int main()
{
	int n = 200;

	for (int i = 0; i < n; ++i)
	{
		int now = 0;
		arr.push_back(now);
	}

	build(1, 0, n);

	int a, b;
	cin >> a >> b;
	change(1, 0, n, a, 0);
	change(1, 0, n, b, 1);
	cout << get(1, 0, n, 0, 2);

    return 0;
}

