#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <set>
using namespace std;
#define rep(i, n) for (int i = 0; i < n; i++)
#define repp(i, a, b) for (int i = a; i < b; i++)
#define all(v) v.begin(), v.end()
typedef long long ll;
typedef pair<int, int> pii;
const ll prof = 1e9;

template <class T> 
class stmin {
	vector<T> st;
	int sz;
	T inf;
	void STBuild(int v, int tl, int tr, vector<T> &a) {
		if (tl == tr - 1) {
			if (tl >= a.size()) st[v] = inf;
			else st[v] = a[tl];
			return;
		}
		int tm = (tl + tr) / 2;
		STBuild(v * 2 + 1, tl, tm, a);
		STBuild(v * 2 + 2, tm, tr, a);
		st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
	}
	T STMin(int v, int tl, int tr, int l, int r) {
		if (l <= tl && r >= tr) return st[v];
		if (l >= tr || tl >= r) return inf;
		int tm = (tl + tr) / 2;
		return min(STMin(v * 2 + 1, tl, tm, l, r),
			STMin(v * 2 + 2, tm, tr, l, r));
	}
	void STUpdate(int v, int tl, int tr, int pos, T val) {
		if (tl == tr - 1) {
			st[v] = val;
			return;
		}
		int tm = (tl + tr) / 2;
		if (pos < tm) STUpdate(v * 2 + 1, tl, tm, pos, val);
		else STUpdate(v * 2 + 2, tm, tr, pos, val);
		st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
	}
public:
	void build(vector<T> &v) {
		sz = 1;
		inf = 1e18;
		while (sz < v.size()) sz *= 2;
		st.resize(sz * 2, inf);
		STBuild(0, 0, sz, v);
	}
	T minimum(int l, int r) {
		return STMin(0, 0, sz, l, r + 1);
	}
	void update(int pos, T val) {
		STUpdate(0, 0, sz, pos, val);
	}
};
int main() {
	ios_base::sync_with_stdio(0);
	int n, a;
	cin >> n >> a;
	vector<int> l(n), r(n), cost(n);
	vector<ll> best(a + 1, 1e18);
	stmin<ll> st;
	st.build(best);
	rep(i, n) cin >> l[i] >> r[i] >> cost[i];
	for (int i = a; i >= 0; i--) {
		best[i] = i * prof;
		rep(q, n) {
			if (r[q] + i > a) continue;
			ll curmax = 1e18;
			/*repp(j, i + l[q], i + r[q] + 1) {
				curmax = min(curmax, best[j] - cost[q]);
			}
			best[i] = max(best[i], curmax);*/
			curmax = st.minimum(i + l[q], i + r[q]) - cost[q];
			best[i] = max(best[i], curmax);
		}
		st.update(i, best[i]);
	}
	cout << best[0];
}