#include <iostream>
#include <cstdio>
#include <vector>
#include <memory.h>
#include <cmath>
#include <algorithm>

using namespace std;

const int INF = 1e9 + 7, maxn = 2e3 + 7;

int n;
bool used[maxn];
vector <vector <pair <int, int>>> adj_list;
vector <int> d, d2;
vector <pair <int, int>> pr;

void Dijkstra(int v) {
    d[v] = 0;
    d2[v] = 0;
    for (int i = 0; i < n; ++i) {
        int mx = -1, a;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && d[j] != INF && (mx == -1 || mx > d[j])) {
                mx = d[j];
                a = j;
            }
        }
        used[a] = true;
        for (auto b : adj_list[a]) {
            int u = b.first, w = b.second;
            if (d[u] >= d[a] + w) {
                d[u] = d[a] + w;
                if (d2[u] < d2[a] + w * w) {
                    d2[u] = d2[a] + w * w;
                }
            }
        }
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    freopen("trains.in", "r", stdin);
    freopen("trains.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    int m;
    cin >> n >> m;
    adj_list.resize(n + 1);
    d.resize(n + 1, INF);
    d2.resize(n + 1, -1);
    pr.resize(n + 1, {-1, -1});
    for (int i = 0; i < m; ++i) {
        int si;
        cin >> si;
        int v;
        cin >> v;
        for (int j = 0; j < si; ++j) {
            int t, u;
            cin >> t >> u;
            adj_list[v].push_back({u, t});
            v = u;
        }
    }
    Dijkstra(1);
    cout << d[n] << " " << d2[n] << endl;
    return 0;
}
