#include <iostream>
#include <string>
#include <vector>
#include <bitset>
#include <cmath>

using namespace std;

pair <int, int> dots[100113];

int n;

const double EPs = 1e-3;

double pol(int i, int j, int k) {
	pair <int, int> a1 = dots[i], b1 = dots[j], c1 = dots[k];

	double x1 = dots[i].first, y1 = dots[i].second;
	double x2 = dots[j].first, y2 = dots[j].second;
	double x3 = dots[k].first, y3 = dots[k].second;

	double l1 = sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
	double l2 = sqrt((x1 - x3) * (x1 - x3) + (y1 - y3) * (y1 - y3));
	double l3 = sqrt((x3 - x2) * (x3 - x2) + (y3 - y2) * (y3 - y2));

	double p = (l1 + l2 + l3) / 2;

	return p * (p - l1) * (p - l2) * (p - l3);
}

bool good(int i, int j, int k) {
	pair <int, int> a1 = dots[i], b1 = dots[j], c1 = dots[k];

	double k1 = a1.second - b1.second, k2 = b1.second - c1.second, k3 = c1.second - a1.second, bb1, bb2, bb3;

	k1 /= a1.first - b1.first;
	k2 /= b1.first - c1.first;
	k3 /= c1.first - a1.first;

	bb1 = a1.second - a1.first * k1;
	bb2 = b1.second - b1.first * k2;
	bb3 = c1.second - c1.first * k3;

	for (int p = 1; p <= n; p++)
		if (p == i || p == j || p == k)
			continue;
		else if (pol(i, j, k) - pol(i, j, p) - pol(j, k, p) - pol(i, k, p) > EPS)
				return 0;

		return 1;
}
void query() {

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			if (j == i)
				continue;
			else
				for (int k = 1; k <= n; k++)
					if (k == j || k == i)
						continue;
					else if (good(i, j, k)) {

						cout << "? 3 " << i << ' ' << j << ' ' << k << endl;

						string s;

						cin >> s;

						if (s == "Yes") {
							cout << "! 3 " << i << ' ' << j << ' ' << k << endl;
							return;
						}
					}
}

int main() {
	int x, y;

	cin >> n;

	for (int i = 1; i <= n; i++) {
		cin >> x >> y;
		dots[i] = make_pair(x, y);
	}

	int q;

	cin >> q;

	for (int i = 0; i < q; i++)
		query();

	return 0;
}