#include <iostream>
#include <list>
#include <string>
#include <unordered_map>
#include <algorithm>

using namespace std;

unordered_map<long long, bool> mp;
int n;

struct Elem
{
	char val;
	Elem *prev, *next;

	Elem(char _val = 0, Elem *_prev = 0, Elem *_next = 0) : val(_val), prev(_prev), next(_next) {}
};

struct List
{
	Elem *root, *end;
	int size;

	List() : root(new Elem()), end(root), size(0) {}

	void push_back(char val)
	{
		Elem *nw = new Elem(val, end);
		end->next = nw;
		end = nw;
		++size;
	}

	void push_front(char val)
	{
		Elem *nw = new Elem(val, root, root->next);
		root->next->prev = nw;
		root->next = nw;
		++size;
	}

	void merge(List &other)
	{
		end->next = other.root->next;
		end->next->prev = end;
		end = other.end;
		size += other.size;
		other.root->next = 0;
	}

	void print(ostream &out)
	{
		for (Elem *curr = root->next; curr != 0; curr = curr->next)
			out << curr->val;
	}
};

bool get(int l, int r)
{
	if (l == 1 && r == n)
		return true;
	long long ind = ((long long)l << 32) | (long long)r;
	if (mp.count(ind))
		return mp[ind];
	std::cout << "? " << l << ' ' << r << endl;
	string res;
	cin >> res;
	return mp[ind] = res == "Yes";
}

int main()
{
	cin >> n;
	list<pair<int, List>> lst;
	string res;
	int cnt = 0;
	for (int i = 0; i < n - 1 && cnt < n; ++i)
	{
		if (get(i + 1, i + 2))
		{
			List tmp;
			tmp.push_back('(');
			tmp.push_back(')');
			lst.push_back(make_pair(i, tmp));
			cnt += 2;
			++i;
		}
	}
	/*while (cnt < n)
	{
		for (auto)
	}*/
	string ans;
	for (auto it = lst.begin(); it != lst.end(); ++it)
	{
		int rval;
		if (it == --lst.end())
			rval = n;
		else
		{
			auto it2 = ++it;
			--it;
			rval = it2->first;
		}
		int right = min(it->first, rval - (it->first + 2)) + 1, left = 0;
		while (right - left > 1)
		{
			int middle = (right + left) / 2;
			if (get(it->first - middle + 1, it->first + 2 + middle))
				left = middle;
			else
				right = middle;
		}
		int cnt = left;
		for (int i = 0; i < cnt; ++i)
			ans.push_back('(');
		ans += "()";
		for (int i = 0; i < cnt; ++i)
			ans.push_back(')');
	}
	std::cout << "! " << ans << endl;
	/*std::cout << "! ";
	for (list<pair<int, List>>::iterator it = lst.begin(); it != lst.end(); ++it)
		it->second.print(cout);
	std::cout << endl;*/
	return 0;
}

