#include <iostream>
#include <list>
#include <string>
#include <map>

using namespace std;

map<pair<int, int>, bool> mp;
int n;

struct Elem
{
	char val;
	Elem *prev, *next;

	Elem(char _val = 0, Elem *_prev = 0, Elem *_next = 0): val(_val), prev(_prev), next(_next) {}
};

struct List
{
	Elem *root, *end;
	int size;

	List() : root(new Elem()), end(root), size(0) {}

	void push_back(char val)
	{
		Elem *nw = new Elem(val, end);
		end->next = nw;
		end = nw;
		++size;
	}

	void push_front(char val)
	{
		Elem *nw = new Elem(val, root, root->next);
		root->next->prev = nw;
		root->next = nw;
		++size;
	}

	void merge(List &other)
	{
		end->next = other.root->next;
		end->next->prev = end;
		end = other.end;
		size += other.size;
		other.root->next = 0;
	}

	void print(ostream &out)
	{
		for (Elem *curr = root->next; curr != 0; curr = curr->next)
			out << curr->val;
	}
};

bool get(int l, int r)
{
	if (l == 1 && r == n)
		return true;
	if (mp.count({ l, r }))
		return mp[{l, r}];
	std::cout << "? " << l << ' ' << r << endl;
	string res;
	cin >> res;
	return mp[{l, r}] = res == "Yes";
}

int main()
{
	cin >> n;
	list<pair<int, List>> lst;
	string res;
	int cnt = 0;
	List tmp;
	tmp.push_back('(');
	tmp.push_back(')');
	for (int i = 0; i < n - 1 && cnt < n; ++i)
	{
		if (get(i + 1, i + 2))
		{
			lst.push_back(make_pair(i, tmp));
			cnt += 2;
			++i;
		}
	}
	while (cnt < n)
	{
		for (auto it2 = lst.begin(), it1 = it2++; it2 != lst.end();)
		{
			if (it1->first + it1->second.size == it2->first)
			{
				it1->second.merge(it2->second);
				it2 = ++lst.erase(it2);
			}
			else
			{
				++it1;
				++it2;
			}
		}
		for (auto it = lst.begin(); it != lst.end(); ++it)
		{
			bool flag = true;
			if (it == lst.begin())
			{
				if (it->first == 0)
					flag = false;
			}
			if (it == --lst.end())
			{
				if (it->first + it->second.size == n)
					flag = false;
			}
			if (flag)
			{
				if (get(it->first, it->first + it->second.size + 1))
				{
					--it->first;
					it->second.push_front('(');
					it->second.push_back(')');
					cnt += 2;
					if (cnt >= n)
						break;
				}
			}
		}
	}
	std::cout << "! ";
	for (list<pair<int, List>>::iterator it = lst.begin(); it != lst.end(); ++it)
		it->second.print(cout);
	std::cout << endl;
	return 0;
}

