#include <iostream>
#include <vector>
#include <string>

using namespace std;

int cross(const pair<int, int> &a, const pair<int, int> &b)
{
	return a.first * b.second - b.first * a.second;
}

bool in(const pair<int, int> &a, const pair<int, int> &b, const pair<int, int> &c, const pair<int, int> &p)
{
	pair<int, int> ab = { b.first - a.first, b.second - a.second };
	pair<int, int> ac = { c.first - a.first, c.second - a.second };
	pair<int, int> ca = { a.first - c.first, a.second - c.second };
	pair<int, int> cb = { b.first - c.first, b.second - c.second };
	pair<int, int> ap = { p.first - a.first, p.second - a.second };
	pair<int, int> cp = { p.first - c.first, p.second - c.second };
	if (cross(ac, ab) * cross(ac, ap) > 0 && cross(ab, ac) * cross(ab, ap) > 0)
		return cross(ca, cb) * cross(ca, cp) > 0 && cross(cb, ca)* cross(cb, cp) > 0;
	return false;
}

int main()
{
	int n;
	cin >> n;
	vector<pair<int, int>> ps(n);
	for (int i = 0; i < n; ++i)
		cin >> ps[i].first >> ps[i].second;
	vector<pair<pair<int, int>, int>> triangs;
	for (int p1 = 0; p1 < n; ++p1)
	{
		for (int p2 = p1 + 1; p2 < n; ++p2)
		{
			for (int p3 = p2 + 1; p3 < n; ++p3)
			{
				bool flag = false;
				for (int i = 0; i < n; ++i)
				{
					if (i == p1 || i == p2 || i == p3)
						continue;
					if (in(ps[p1], ps[p2], ps[p3], ps[i]))
					{
						flag = true;
						break;
					}
				}
				if (!flag)
					triangs.push_back({ {p1, p2}, p3 });
			}
		}
	}
	int q;
	cin >> q;
	string res;
	for (int i = 0; i < q; ++i)
	{
		for (auto elem : triangs)
		{
			cout << "? 3 " << elem.first.first + 1 << ' ' << elem.first.second + 1 << ' ' << elem.second + 1 << endl;
			cin >> res;
			if (res == "Yes")
			{
				cout << "! 3 " << elem.first.first + 1 << ' ' << elem.first.second + 1 << ' ' << elem.second + 1 << endl;
				break;
			}
		}
	}
    return 0;
}
/*
6
3 0
0 2
2 4
4 2
5 5
6 1
*/
