#include <iostream>
#include <vector>
#include <set>

using namespace std;

struct Dist
{
	int len, comf;

	Dist(int _len, int _comf) : len(_len), comf(_comf) {}

	bool operator<(const Dist &other) const
	{
		return len < other.len || (len == other.len && comf > other.comf);
	}

	Dist operator+(const Dist &other) const
	{
		return Dist(len + other.len, comf + other.comf);
	}

	Dist operator+(int dist) const
	{
		return Dist(len + dist, comf + dist * dist);
	}
};

int main()
{
	const int INF = (int)1e9 + 7;
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i)
	{
		int tmp, v, u, t;
		cin >> tmp >> v >> t >> u;
		g[v - 1].push_back({ u - 1, t });
	}
	vector<Dist> dist(n, Dist(INF, 0));
	dist[0] = Dist(0, 0);
	set<pair<Dist, int>> q;
	q.insert({ Dist(0, 0), 0 });
	while (!q.empty())
	{
		int v = q.begin()->second;
		q.erase(q.begin());
		for (auto elem : g[v])
		{
			if (dist[v] + elem.second < dist[elem.first])
			{
				q.erase(make_pair(dist[elem.first], elem.first));
				dist[elem.first] = dist[v] + elem.second;
				q.insert(make_pair(dist[elem.first], elem.first));
			}
		}
	}
	cout << dist[n - 1].len << ' ' << dist[n - 1].comf << endl;
    return 0;
}

