#include <iostream>
#include <string>
#include <vector>
#include <set>

using namespace std;
const int MAXN = 1000000;
const int INF = 10000010;
int prev1[MAXN];
int prev2[MAXN];
int next1[MAXN];
int next2[MAXN];
set<pair<int, int>> indexes;
int n;

inline int get_l(int i) {
    return (prev1[i] == - 1 ? 0 : prev1[i] - prev1[prev1[i]]);
}

inline int get_r(int i) {
    return (next1[i] == n ? 0 : next1[next1[i]] - next1[i]);
}

int get(int i) {
    return next1[i] - i - max(get_l(i), get_r(i));
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> q;
    for (int r = 0; r < q; r++) {
        string s, t;
        cin >> s >> t;
        n = (int) s.length();
        for (int i = 0; i < n; i++) {
            prev1[i] = -1;
            prev2[i] = -1;
            next1[i] = n;
            next2[i] = n;
        }
        for (int i = 1; i < n; i++) {
            prev1[i] = (s[i] == s[i - 1] ? prev1[i - 1] : i - 1);
            prev2[i] = (t[i] == t[i - 1] ? prev2[i - 1] : i - 1);
        }
        for (int i = n - 2; i >= 0; i--) {
            next1[i] = (s[i] == s[i + 1] ? next1[i + 1] : i + 1);
            next2[i] = (t[i] == t[i + 1] ? next2[i + 1] : i + 1);
        }
       /* for (int i = 0; i < n; i++) {
            cout << next1[i] << " " << get_l(i) << " " << get_r(i) << endl;
        }
        cout << endl; */
        if (next1[0] == n) {
            cout << (s == t ? "Yes\n" : "No\n");
            continue;
        }
        bool good = true;
        for (int i = 0; i < n; i++) {
            if (prev1[i] != i - 1) continue;
            if (next1[i] > next2[i]) {
                good = false;
                break;
            }
            if (s[i] == t[i]) continue;
            indexes.insert(make_pair(get(i), i));
        }
       /* if (!good) {
            cout << "No\n";
            continue;
        }*/
        cout << good << endl;
        while ((int) indexes.size() != 0) {
            auto e = *indexes.begin();
            int i = e.second;
          //  cout << e.first << " " << e.second << endl;
            indexes.erase(*indexes.begin());
          //  cout << "I am here\n";
            int l = get_l(i);
            int r = get_r(i);
           // cout << next1[i] - i << " " << l << " " << r << endl;
            if (next1[i] - i >= max(l, r)) {
                good = false;
                break;
            }
            if (r != 0) {
               auto it = indexes.lower_bound(make_pair(get(next1[i]), next1[i]));
                if (it != indexes.end() && (*it).second == next1[i]) {
                    indexes.erase(*it);
                }
            }
          //  cout << "I am here\n";
            pair<int, int> q1, q2, q3;
            int j1 = (l == 0 ? -1 : prev1[prev1[i]] + 1);
            if (j1 != -1) {
                q1 = make_pair(get(j1), j1);
            }
            int j2 = (r == 0 ? -1 : next1[next1[i]]);
            if (j2 != -1) {
                q2 = make_pair(get(j2), j2);
            }
            int j3 = (prev1[prev1[i]] == -1 ? -1 : prev1[prev1[prev1[i]]] + 1);
            if (j3 != -1) {
                q3 = make_pair(get(j3), j3);
            }
         //   cout << "change " << j1 << " " << j2 << " " << j3 << endl;
            next1[(l == 0 ? i : prev1[prev1[i]] + 1)] = (r != 0 ? next1[next1[i]] : n);
            s[i] = t[i];
            if (l != 0) next1[i] = (r != 0 ? next1[next1[i]] : n);
            prev1[i] = (l != 0 ? prev1[prev1[i]] : -1);
            if (r != 0) {
       //         cout << "**** " << next1[i] << endl;
                prev1[next1[i] - 1] = prev1[i];
            }
          /*   for (int i = 0; i < n; i++) {
            cout << prev1[i] << " " << get_l(i) << " " << get_r(i) << endl;
            }
            cout << endl;
            for (auto item : indexes) {
                  cout << item.first.first << " " << item.first.second << " " << item.second << endl;
            }*/
            if (j1 != -1) {
                auto it = indexes.lower_bound(q1);
                if (it != indexes.end() && (*it).second == j1) {
                //    cout << "* " << j1 << " " << get_l(j1) << " " << get_r(j1) << endl;
                    indexes.erase(*it);
                    indexes.insert(make_pair(get(j1), j1));
                }
            }
            j1 = j2;
            if (j1 != -1) {
              //  cout << j1 << endl;
                auto it = indexes.lower_bound(q2);
                if (it != indexes.end() && (*it).second == j1) {
                 //   cout << "** " << j1 << " " << get_l(j1) << " " << get_r(j1) << endl;
                    indexes.erase(*it);
                    indexes.insert(make_pair(get(j1), j1));
                }
            }
            j1 = j3;
            if (j1 != -1) {
                auto it = indexes.lower_bound(q3);
                if (it != indexes.end() && (*it).second == j1) {
                  //  cout << "*** " << j1 << " " << get_l(j1) << " " << get_r(j1) << endl;
                    indexes.erase(*it);
                    indexes.insert(make_pair(get(j1), j1));
                }
            }
         //   cout << "I am done\n";
        }
        cout << (good ? "Yes\n" : "No\n");
    }
    return 0;
}
