
#define ll long long
#include <iostream>
#include <set>
#include <vector>
#include <random>
#include <algorithm>

using namespace std;
int mode;
bool ask();
struct point
{
	ll x, y, n;
	bool operator==(const point& z1) const
	{
		return ((x == z1.x) && (y == z1.y));
	}
	bool operator<(const point& z1) const;
	point operator-(const point& z1) const
	{
		point z;
		z.x = x - z1.x;
		z.y = y - z1.y;
		z.n = -1;
		return z;
	}
	ll operator^(const point& z1) const
	{
		return x * z1.y - y * z1.x;
	}
};
point center;
bool point::operator<(const point& z1) const
{
	if (mode == 0)
	{
		if (x != z1.x)
			return x < z1.x;
		return y < z1.y;
	}
	else if (mode == 1)
	{
		point v0 = *this - center, v1 = z1 - center;
		if (v0 == v1)
			return false;
		if ((v1.x == 0) && (v1.y == 0))
			return false;
		if ((v0.x == 0) && (v0.y == 0))
			return true;
		if ((v0.x == 0) && (v0.y < 0))
			return false;
		if ((v1.x == 0) && (v1.y < 0))
			return true;
		if (v0.x == 0)
			return (v1.x < 0);
		if (v1.x == 0)
			return (v0.x > 0);
		if ((v0.x < 0) && (v1.x > 0))
			return false;
		if ((v0.x > 0) && (v1.x < 0))
			return true;
		return v0.y * v1.x < v1.y * v0.x;
	}
}

int n;
char *Z;
const int ZZ = 4;
vector<point> z;

bool ask()
{
	cin.getline(Z, ZZ);
	return (*Z == 'Y');
}

struct mnogoug
{
	vector<point> pts;
	vector<point> hull;
	mnogoug *chd;
	int nchd;
	bool fnl;
	void divide()
	{
		if (nchd)
			return;
		int g = abs(rand()) % (pts.size() - hull.size());
		while ((pts[g] == hull[0]) || (pts[g] == hull[1]) || (pts[g] == hull[hull.size() - 1]))
			g = abs(rand()) % pts.size();
		center = pts[g];
		bool isnth = true;
		int i;
		for (i = 0; isnth && (i < hull.size()); ++i)
			isnth = !(pts[g] == hull[i]);
		if (isnth)
		{
			nchd = 3;
			int minout = 1;
			while (((hull[0] - center) ^ (hull[minout] - center)) > 0)
				++minout;
			--minout;
			int maxout = hull.size() - 1;
			while (((hull[0] - center) ^ (hull[maxout] - center)) < 0)
				--maxout;
			++maxout;
			chd = new mnogoug[3];
			chd[0].pts.push_back(hull[0]);
			chd[0].pts.push_back(center);
			chd[0].pts.push_back(hull[minout]);
			chd[1].pts.push_back(hull[minout]);
			chd[1].pts.push_back(center);
			chd[1].pts.push_back(hull[maxout]);
			chd[2].pts.push_back(hull[maxout]);
			chd[2].pts.push_back(center);
			chd[2].pts.push_back(hull[0]);
			for (int i = 0; i < pts.size(); ++i)
			{
				if ((((hull[0] - center) ^ (pts[i] - center)) > 0) && (((pts[i] - center) ^ (hull[minout] - center)) > 0))
					chd[0].pts.push_back(pts[i]);
				else if ((((hull[minout] - center) ^ (pts[i] - center)) > 0) && (((pts[i] - center) ^ (hull[maxout] - center)) > 0))
					chd[1].pts.push_back(pts[i]);
				else if ((((hull[maxout] - center) ^ (pts[i] - center)) > 0) && (((pts[i] - center) ^ (hull[0] - center)) > 0))
					chd[2].pts.push_back(pts[i]);
			}
			chd[0].c_hull();
			chd[1].c_hull();
			chd[2].c_hull();
		}
		else
		{
			chd = new mnogoug[2];
			nchd = 2;
			chd[0].pts.push_back(hull[0]);
			chd[0].pts.push_back(center);
			chd[1].pts.push_back(hull[0]);
			chd[1].pts.push_back(center);
			for (int i = 0; i < pts.size(); ++i)
			{
				if (!((pts[i] == center) || (pts[i] == hull[0])))
				{
					if (((hull[0] - center) ^ (pts[i] - center)) > 0)
					{
						chd[0].pts.push_back(pts[i]);
					}
					else
					{
						chd[1].pts.push_back(pts[i]);
					}
				}
			}
			chd[0].c_hull();
			chd[1].c_hull();
		}
	}
	void outp()
	{
		cout << hull.size();
		for (int i = 0; i < hull.size(); ++i)
			cout << ' ' << hull[i].n + 1;
		cout << endl;
	}
	void c_hull()
	{
		mode = 0;
		center = *pts.begin();
		for (int i = 1; i < pts.size(); ++i)
		if (pts[i] < center)
			center = pts[i];
		mode = 1;
		sort(pts.begin(), pts.end());
		for (int i = 0; i < pts.size(); ++i)
		{
			while ((hull.size() >= 3) && (((hull[hull.size() - 2] - hull[hull.size() - 1]) ^ (pts[i] - hull[hull.size() - 1])) > 0))
				hull.pop_back();
			hull.push_back(pts[i]);
		}
		fnl = (hull.size() == pts.size());
		nchd = 0;
	}
	void check()
	{
		if (fnl)
		{
			cout << "! ";
			outp();
		}
		else
		{
			divide();
			bool nfd = true;
			int i;
			for (i = 0; nfd && (i < nchd - 1); ++i)
			{
				cout << "? ";
				chd[i].outp();
				if (ask())
					nfd = false;
			}
			if (!nfd)
				--i;
			chd[i].check();
		}
	}
};

int main()
{
	//freopen("tigers.in", "r", stdin);
	//freopen("tigers.out", "w", stdout);
	srand(2391);
	cin >> n;
	Z = new char[ZZ];
	z.resize(n);
	mnogoug m;
	for (int i = 0; i < n; ++i)
	{
		cin >> z[i].x >> z[i].y;
		z[i].n = i;
		m.pts.push_back(z[i]);
	}
	m.c_hull();
	int q;
	cin >> q;
	cin.getline(Z, ZZ);
	for (int Q = 0; Q < q; ++Q)
		m.check();
	return 0;
}
