// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <unordered_map>

using namespace std;

vector<pair<int, bool>> compress(string from) {
	vector<pair<int, bool>> sfrom;
	int n = (int)from.size();

	sfrom.push_back({ 1, (from[0] == '+') });
	for (int i = 1; i < n; i++) {
		if (from[i] == from[i - 1])
			sfrom.back().first++;
		else
			sfrom.push_back({ 1, from[i] == '+' });
	}
	return sfrom;
}

struct Node {
	Node *L = nullptr, *R = nullptr;

	int length = 0;
	bool type = 1;
};

Node* ov_start;

void solve_block(vector<pair<int, bool>> cur, int length) {
	int n = int(cur.size());

	Node *start = ov_start = nullptr;
	for (int i = 0; i < n; i++) {
		Node *ne = new Node();
		if (!ov_start)
			ov_start = ne;
		ne->length = cur[i].first;
		ne->type = cur[i].second;
		ne->L = start;
		if (start)
			start->R = ne;
		start = ne;
	}


	Node *N = ov_start;
	for (N = ov_start; N->R;) {
		bool done_smth = false;

		if (!N->type) {
			N = N->R;
			continue;
		}

		while (N->L && (N->L->length < N->length || N->L->type == N->type)) {
			
			N->length += N->L->length;
			N->L = N->L->L;
			done_smth = true;
		}

		while (N->R && (N->R->length < N->length || N->R->type == N->type)) {
			N->length += N->R->length;
			N->R = N->R->R;
			done_smth = true;
		}

		if (done_smth && (N->L || N->R)) 
			continue;
		else if (N->R) {
			N = N->R;
		}
		else 
			break;
	}
	
	if (N->length == length && N->type) {
		cout << "Yes";
	}
	else
		cout << "No";
	cout << endl;

}

void solve(string from, string to) {

	vector<pair<int, bool>> sfrom, sto;

	int n = (int)from.size();

	sfrom = compress(from);
	sto = compress(to);

	solve_block(sfrom, sto[0].first);
	
}

int main()
{

	string from, to;
	int n;
	cin >> n;

	for (int i = 0; i < n; i++) {
		cin >> from >> to;
		solve(from, to);
	}

    return 0;
}

