#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::pair;
using std::swap;
using std::vector;
using std::set;
using std::map;
using std::string;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#ifdef LOCAL
#define dbg(as...) {\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	string _cur, _loc;\
	while (getline(_ss, _cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += "," + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else 
#define dbg(as...) {}
#endif

template<typename T> 
void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}

template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ',';
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(3);
		srand(300);
	}
} init;

const int MAXN = 5e3 + 1;
using myf = long double;
struct point{
	myf x, y;
	int i;
	point() {}
	point (myf _x, myf _y, int _i) : x(_x), y(_y), i(_i) {}
};
struct vc{
	myf x, y;
	vc() {}
	vc (myf _x, myf _y) : x(_x), y(_y) {}
	vc(point a, point b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
};
myf operator % (vc a, vc b) {
	return a.x * b.y - a.y * b.x;
}

vector<point> convex_hull(vector<point> a) {
	int n = a.size();
	vector<point> ans;
	int pos = min_element(a.begin(), a.end(), [](const point & p1, const point & p2) {
		return p1.y == p2.y ? p1.x < p2.x : p1.y < p2.y;
	}) - a.begin();
	swap(a[0], a[pos]);
	point start = a[0];
	ans.pb(start);
	sort(a.begin(), a.end(), [start](const point & p1, const point & p2) {
		return vc(start, p1) % vc(start, p2) > 0;
	});
	for (int i = 1; i < n; ++i) {
		while (ans.size() > 2 && vc(ans[ans.size() - 2], ans.back()) % vc(ans.back(), a[i]) < 0) 
			ans.pop_back();
		ans.pb(a[i]);
	}
	return ans;
} 

bool check(point a, point b, point c, point o) {
    vc oa(o, a), ob(o, b), oc(o, c);
    return !(oa % ob > 0 && ob % oc > 0 && oc % oa > 0) && !(oa % ob < 0 && ob % oc < 0 && oc % oa < 0);
}

int32_t main() {

	int n;
	cin >> n;
	vector<point> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
		a[i].i = i + 1;
	}

	auto ch = convex_hull(a);
	int q;
	cin >> q;
	while (q--) {
		for (point p : ch) {
			dbg(p.i);
			int pos = min_element(a.begin(), a.end(), [p](const point & p1, const point & p2) {
				return abs(p.i - p1.i) < abs(p.i - p2.i);
			})- a.begin();
			swap(a[0], a[pos]);
			sort(a.begin() + 1, a.end(), [p](const point & p1, const point & p2) {
				return vc(p, p1) % vc(p, p2) > 0;
			});

			for (point p2 : a) dbg(p2.i);
			for (int i = 2; i < n; ++i) {
				cout << "? 3 " << p.i << ' ' << a[i].i << ' ' << a[i - 1].i << std::endl;
				string res;
				cin >> res;
				if (res[0] == 'Y') {
					cout << "! 3 " << p.i << ' ' << a[i].i << ' ' << a[i - 1].i << std::endl;
					goto nexttiger;
				}
			}
		}
		nexttiger:;
	}

	// sort(a.begin(), a.end(), [](const point & p1, const point & p2) {
	// 	return p1.x < p2.x;
	// });

	// int q;
	// cin >> q;
	// while (q--) {
	// 	vector<point> cur;
	// 	vector<point> old;
	// 	int i = 0;
	// 	for (; i < n; ++i) {
	// 		cur.pb(a[i]);
	// 		if (cur.size() > 2) {
	// 			auto ch = convex_hull(cur);
	// 			if (cur.size() == 3) {
	// 				cout << "? " << ch.size();
	// 				for (point p : ch) cout << ' ' << p.i;
	// 				cout << std::endl;
	// 				string res;
	// 				cin >> res;
	// 				if (res[0] == 'Y') {
	// 					cout << "! " << ch.size(); 
	// 					for (point p : ch) cout << ' ' << p.i;
	// 					cout << std::endl;
	// 					i = n + n;
	// 					break;
	// 				}
	// 			}
	// 			if (i == n + n) break;
	// 			if (!old.empty()) {
	// 				vector<point> extra;
	// 				sort(old.begin(), old.end(), [](const point & p1, const point & p2) {
	// 					return p1.i < p2.i;
	// 				});
	// 				point o = a[i];
	// 				for (int j = 0; j < ch.size(); ++j) {
	// 					if (ch[j].i == a[i].i) {
	// 						extra.pb(ch[(j + ch.size() - 1) % ch.size()]);
	// 						extra.pb(ch[(j + ch.size() + 1) % ch.size()]);
	// 					}
	// 				}
	// 				sort(ch.begin(), ch.end(), [](const point & p1, const point & p2) {
	// 					return p1.i < p2.i;
	// 				});
	// 				set_difference(old.begin(), old.end(), ch.begin(), ch.end(), back_inserter(extra), [](const point & p1, const point & p2) {
	// 					return p1.i < p2.i;
	// 				});
	// 				dbg(i);
	// 				dbg("old");
	// 				for (point p : old) {
	// 					dbg(p.i);
	// 				}
	// 				dbg("new");
	// 				for (point p : ch) {
	// 					dbg(p.i);
	// 				}
	// 				dbg("diff");
	// 				for (point p : extra) {
	// 					dbg(p.i);
	// 				}
	// 				sort(extra.begin(), extra.end(), [o](const point & p1, const point & p2) {
	// 					return vc(o, p1) % vc(o, p2) > 0;
	// 				});
	// 				for (int j = 1; j < extra.size(); ++j) {
	// 					cout << "? 3 " << a[i].i << ' ' << extra[j - 1].i << ' ' << extra[j].i << std::endl;
	// 					string res;
	// 					cin >> res;
	// 					if (res[0] == 'Y') {
	// 						cout << "! 3 " << a[i].i << ' ' << extra[j - 1].i << ' ' << extra[j].i << std::endl;
	// 						i = n + n;
	// 						break;
	// 					}
	// 				}
	// 				if (i == n + n) break;
	// 			}
	// 			old = ch;
	// 		}
	// 	}
	// 	assert(i == n + n);
 //  	}
	return 0;
}
