#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>

using namespace std;

struct point {
    long long x, y;
    point () {}
    point (long long x1, long long y1) {
        x = x1;
        y = y1;
    }
    point (point p1, point p2) {
        x = p2.x - p1.x;
        y = p2.y - p1.y;
    }
};

long long cross_prod(point p1, point p2) {
    return p1.x * p2.y - p1.y * p2.x;
}

long long dot_prod(point p1, point p2) {
    return p1.x * p2.x + p1.y * p2.y;
}

bool in_triangle(point a, point b, point c, point p) {
    long long sq1, sq2, sq3, sq;
    sq1 = abs(cross_prod(point(p, b), point(p, c)));
    sq2 = abs(cross_prod(point(p, a), point(p, c)));
    sq3 = abs(cross_prod(point(p, a), point(p, b)));
    sq = abs(cross_prod(point(a, b), point(a, c)));
    return (sq1 + sq2 + sq3 == sq);
}

bool quest(int i, int j, int k) {
    string s;
    cout << "? 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << '\n';
    fflush(stdout);
    cin >> s;
    if (s == "Yes") {
        cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << '\n';
        return true;
    }
    else {
        return false;
    }
}

int main() {
    int n, q;
    cin >> n;
    vector <point> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].x >> v[i].y;
    }
    vector <vector <vector <bool> > > good(n, vector <vector <bool> > (n, vector <bool> (n, true)));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                if ((i == j) || (i == k) || (j == k)) {
                    good[i][j][k] = false;
                }
                else {
                    for (int l = 0; l < n; l++) {
                        if ((l != i) && (l != j) && (l != k)) {
                            if (in_triangle(v[i], v[j], v[k], v[l])) {
                                good[i][j][k] = false;
                            }
                        }
                    }
                }
            }
        }
    }
    cin >> q;
    for (int i1 = 0; i1 < q; i1++) {
        bool flag = true;
        for (int i = 0; i < n && flag; i++) {
            for (int j = i + 1; j < n && flag; j++) {
                for (int k = j + 1; k < n && flag; k++) {
                    if (good[i][j][k]) {
                        if (quest(i, j, k)) {
                            flag = false;
                        }
                    }
                }
            }
        }
    }
    return 0;
}
