#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;

struct variante {
    int left, right;
    long long sum;
    variante () {}
    variante (int l , int r, long long s) {
        left = l;
        right = r;
        sum = s;
    }
};

variante quest(vector <int> &v, vector <long long> &costs, vector <bool> &used, int m) {
    long long counter = 0;
    int left;
    variante res(-1, -1, 0);
    left = -1;
    for (int i = 0; i < m; i++) {
        if (left == -1) {
            if (!used[v[i]]) {
                left = i;
                counter = costs[i];
            }
        }
        else {
            if (!used[v[i]]) {
                counter += costs[i];
            }
            else {
                if (counter > res.sum) {
                    res = variante(left, i - 1, counter);
                    left = -1;
                }
            }
        }
    }
    if (counter > res.sum) {
        res = variante(left, m - 1, counter);
    }
    //cout << res.left << ' ' << res.right << ' ' << res.sum << '\n';
    return res;
}

int main() {
    ifstream fin;
    fin.open("internship.in");
    ofstream fout;
    fout.open("internship.out");
    int n, m;
    long long counter1, counter2, res;
    bool flag = true;
    variante best1, best2, var1, var2;
    fin >> n >> m;
    vector <int> v1(n);
    vector <long long> cost1(n);
    vector <int> v2(m);
    vector <long long> cost2(m);
    for (int i = 0; i < n; i++) {
        fin >> v1[i];
    }
    for (int i = 0; i < n; i++) {
        fin >> cost1[i];
    }
    for (int i = 0; i < m; i++) {
        fin >> v2[i];
    }
    for (int i = 0; i < m; i++) {
        fin >> cost2[i];
    }
    best1 = variante(-1, -1, 0);
    best2 = variante(0, m - 1, 0);
    for (int i = 0; i < m; i++) {
        best2.sum += cost2[i];
    }
    //cout << best1.sum + best2.sum << '\n';
    for (int i1 = 0; i1 < n; i1++) {
        counter1 = 0;
        for (int j1 = i1; j1 < n; j1++) {
            vector <bool> used(n + m + 1, false);
            var1 = variante(i1, j1, 0);
            for (int k = i1; k <= j1; k++) {
                used[v1[k]] = true;
                var1.sum += cost1[k];
            }
            //var2 = quest(v2, cost2, used, m);
            for (int i = 0; i < m; i++) {
                for (int j = i; j < m; j++) {
                    var2 = variante(i, j, 0);
                    flag = true;
                    for (int k = i; k <= j; k++) {
                        if (used[v2[k]]) {
                            flag = false;
                        }
                        var2.sum += cost2[k];
                    }
                    if (flag) {
                        if (var1.sum + var2.sum > best1.sum + best2.sum) {
                            best1 = var1;
                            best2 = var2;
                            //cout << "best1: " << best1.left << ' ' << best1.right << ' ' << best1.sum << '\n';
                            //cout << "best2: " << best2.left << ' ' << best2.right << ' ' << best2.sum << '\n';
                        }
                    }
                }
            }
        }
    }
    fout << best1.sum + best2.sum << '\n' << best1.left + 1 << ' ' << best1.right + 1 << '\n' << best2.left + 1 << ' ' << best2.right + 1 << '\n';
    fin.close();
    fout.close();
    return 0;
}
