#include <iostream>
#include <algorithm>
#include <string>

using namespace std;


struct block
{
	int l, r;
	block *next, *prev;
	char typ;
	block() {}
	block(int l, int r, char typ) : l(l), r(r), typ(typ) { next = prev = 0; }
};

block *fir = 0;
block *las = 0;
block *tmp = 0;
string t;

void check(block *a)
{
	if (!a || a->typ == t[a->l])
		return;
	block *l = a->prev, *r = a->next;
	if (l && l->r - l->l > a->r - a->l)
	{
		if (l->l == 1)
			tmp = a;
		if (l->prev)
			l->prev->next = a;
		a->l = l->l;
		a->typ = l->typ;
		a->prev = l->prev;
		if (r)
		{
			if (r->next)
				r->next->prev = a;
			a->r = r->r;
			a->next = r->next;
		}
	}
	else if (r && r->r - r->l > a->r - a->l)
	{
		if (r->next)
			r->next->prev = a;
		a->r = r->r;
		a->typ = r->typ;
		a->next = r->next;
		if (l)
		{
			if (l->l == 1)
				tmp = a;
			if (l->prev)
				l->prev->next = a;
			a->l = l->l;
			a->prev = l->prev;
		}
	}
	check(a->prev);
	check(a->next);
}

void check1(block *a)
{
	if (!a || a->typ == t[a->l])
		return;
	block *l = a->prev, *r = a->next;
	if (l && l->r - l->l > a->r - a->l)
	{
		if (l->l == 1)
			tmp = a;
		if (l->prev)
			l->prev->next = a;
		a->l = l->l;
		a->typ = l->typ;
		a->prev = l->prev;
		if (r)
		{
			if (r->next)
				r->next->prev = a;
			a->r = r->r;
			a->next = r->next;
		}
		check1(a->prev);
		check1(a->next);
	}
	else if (r && r->r - r->l > a->r - a->l)
	{
		if (r->next)
			r->next->prev = a;
		a->r = r->r;
		a->typ = r->typ;
		a->next = r->next;
		if (l)
		{
			if (l->l == 1)
				tmp = a;
			if (l->prev)
				l->prev->next = a;
			a->l = l->l;
			a->prev = l->prev;
		}
		check1(a->prev);
		check1(a->next);
	}

}

string s, tp;

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int q;
	cin >> q;
	for (int Q = 0; Q < q; Q++)
	{
		fir = las = tmp = 0;
		cin >> s >> t;
		int cnt = 0;
		for (int i = 0; i < t.length(); i++)
			if (t[i] == '+')
				++cnt;
		if (cnt == t.length())
		{
			int n = s.length();
			s = '.' + s + '.';
			t = '.' + t + '.';
			int last = -1;
			for (int i = 1; i <= n; i++)
			{
				if (i == 1 || i == n || s[i - 1] != s[i] || s[i + 1] != s[i])
				{
					if ((i == n && last == -1) || (i == 1 && i < n && s[i + 1] != s[i] && last == -1) || (i > 1 && i < n && last == -1 && s[i - 1] != s[i] && s[i + 1] != s[i]))
						last = i;
					if (last == -1)
						last = i;
					else
					{
						if (!las)
						{
							fir = new block(last, i, s[i]);
							las = fir;
						}
						else
						{
							las->next = new block(last, i, s[i]);
							las->next->prev = las;
							las = las->next;
						}

						last = -1;
					}
				}
			}

			tmp = fir;

			while (fir)
			{
				if (fir)
					check(fir);
				fir = fir->next;
			}

			tp = "";
			while (tmp)
			{
				if (tmp)
				{
					for (int i = 0; i < tmp->r - tmp->l + 1; i++)
						tp.push_back(tmp->typ);
				}
				tmp = tmp->next;
			}
			//cout << tp;
			if (tp == t.substr(1, n))
				cout << "Yes\n";
			else
				cout << "No\n";
		}
		else
		{
			int n = s.length();
			s = '.' + s + '.';
			t = '.' + t + '.';
			int last = -1;
			for (int i = 1; i <= n; i++)
			{
				if (i == 1 || i == n || s[i - 1] != s[i] || s[i + 1] != s[i])
				{
					if ((i == n && last == -1) || (i == 1 && i < n && s[i + 1] != s[i] && last == -1) || (i > 1 && i < n && last == -1 && s[i - 1] != s[i] && s[i + 1] != s[i]))
						last = i;
					if (last == -1)
						last = i;
					else
					{
						if (!las)
						{
							fir = new block(last, i, s[i]);
							las = fir;
						}
						else
						{
							las->next = new block(last, i, s[i]);
							las->next->prev = las;
							las = las->next;
						}

						last = -1;
					}
				}
			}

			tmp = fir;

			while (fir)
			{
				if (fir)
					check(fir);
				fir = fir->next;
			}

			tp = "";
			while (tmp)
			{
				if (tmp)
				{
					for (int i = 0; i < tmp->r - tmp->l + 1; i++)
						tp.push_back(tmp->typ);
				}
				tmp = tmp->next;
			}
			//cout << tp;
			if (tp == t.substr(1, n))
				cout << "Yes\n";
			else
				cout << "No\n";
		}
	}

}