#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:512000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

typedef long long ll;
typedef double ld;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define for1(i, n) for(int i = 1; i <=(int)(n); i++)

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int MAXN = 67;

struct vt {
	ll x, y;

	ll operator ^(const vt &v) const{
		return x * v.y - y * v.x;
	}

	vt operator -(const vt &v) const {
		return{ x - v.x, y - v.y };
	}
} a[MAXN];

int n, q;
bool ok[MAXN][MAXN][MAXN];

bool inside(vt cur_p, vt p1, vt p2, vt p3) {
	vt v1 = p1 - cur_p;
	vt v2 = p2 - cur_p;
	vt v3 = p3 - cur_p;

	ll s1 = abs(v1 ^ v2) + abs(v2 ^ v3) + abs(v3 ^ v1);

	ll s2 = abs((p2 - p1) ^ (p3 - p1));

	return s1 == s2;
}


bool cor(int i, int j, int z) {
	forn(w, n) {
		if (w == i || w == j || w == z) continue;
		if (inside(a[w], a[i], a[j], a[z])) {
			return false;
		}
	}
	return true;
}

bool ask(vector<int> v) {
	cout << "? " << v.size() << ' ';
	for (int x : v) cout << x << ' ';
	cout << endl;
	string tmp;
	cin >> tmp;
	if (tmp == "Yes") {
		cout << "! " << v.size() << ' ';
		for (int x : v) cout << x << ' ';
		cout << endl;
		return true;
	}
	return false;
}

void guess() {
	forn(i, n) {
		forn(j, i) {
			forn(z, j) {
				if (!ok[i][j][z]) continue;

				if (ask({ i + 1, j + 1, z + 1 })) {
					return;
				}
			}
		}
	}
}

void solve() {
	scanf("%d", &n);
	forn(i, n) {
		scanf("%lld%lld", &a[i].x, &a[i].y);
	}

	forn(i, n) {
		forn(j, i) {
			forn(z, j) {
				ok[i][j][z] = cor(i, j, z);
			}
		}
	}
	scanf("%d", &q);
	forn(_, q) {
		guess();
	}
}