#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:512000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <queue>
using namespace std;

typedef long long ll;
typedef double ld;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define for1(i, n) for(int i = 1; i <=(int)(n); i++)

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

struct edge {
	int to, time, comp;
};

const int MAXN = (int)1e3 + 7;
const int MAXM = (int)1e6 + 7;
const ll LINF = (ll)1e18;

int n, m;
vector<edge> g[MAXN], rg[MAXN], new_g[MAXN];
ll d[MAXN], rd[MAXN];
vector<int> order[MAXM], tick[MAXM];
map<int, int> indx[MAXN];

void djstr(int start, ll *dist, vector<edge> *graph) {
	fill(dist + 1, dist + 1 + n, LINF);
	dist[start] = 0;
	priority_queue<pair<ll, int> > q;
	q.push({ 0, start });
	while (!q.empty()) {
		ll curd = -q.top().first; int curv = q.top().second;
		q.pop();
		if (curd > dist[curv]) continue;

		for (auto e : graph[curv]) {
			ll nd = curd + e.time;
			if (nd < dist[e.to]) {
				dist[e.to] = nd;
				q.push({ -dist[e.to], e.to });
			}
		}
	}
}

bool cmp(const int &v1, const int &v2) {
	return d[v1] < d[v2];
}

ll dp[MAXN];

ll sqr(ll x) {
	return x * x;
}

void dfs(int comp, int ind, ll p, ll sum) {
	int v = order[comp][ind];
	dp[v] = max(dp[v], p + sqr(sum));
	
	if (ind + 1 == order[comp].size()) return;

	int nxt = order[comp][ind + 1];
	if (d[v] + tick[comp][ind] + rd[nxt] != d[n]) return;
	dfs(comp, ind + 1, p, sum + tick[comp][ind]);
}

void solve() {
	scanf("%d%d", &n, &m);
	for1(comp, m) {
		int q;
		scanf("%d", &q);
		int pcity = 0, ptime = 0;
		for (int i = 0; i <= q; i++) {
			int city, time = 0;
			if (i == q) {
				scanf("%d", &city);
			}
			else {
				scanf("%d%d", &city, &time);
			}
			indx[city][comp] = order[comp].size();
			order[comp].push_back(city);
			tick[comp].push_back(time);
			if (i > 0) {
				g[pcity].push_back({ city, ptime, comp });
			}
			pcity = city, ptime = time;
		}
	}
	for1(v, n) {
		for (auto e : g[v]) {
			rg[e.to].push_back({ v, e.time, e.comp });
		}
	}

	djstr(1, d, g);
	djstr(n, rd, rg);

	for1(v, n) {
		for (auto e : g[v]) {
			if (d[v] + e.time + rd[e.to] == d[n]) {
				new_g[v].push_back(e);
			}
		}
	}

	vector<int> vert;
	for1(v, n) vert.push_back(v);
	sort(vert.begin(), vert.end(), cmp);

	for (int v : vert) {
		for1(comp, m) {
			auto it = indx[v].find(comp);
			if (it == indx[v].end()) continue;
			int ind = it->second;
			dfs(comp, ind, dp[v], 0);
		}
	}
	ll maxim = 0;
	cout << d[n] << ' ' <<  dp[n];
}