#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <set>
#include <string>
#include <vector>
#include <map>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ldouble;

#define mk make_pair
#define eps 1e-8
#define linf 8e18
#define inf 2e9
#define Size 1000006
#define all(x) x.begin(), x.end()


int par[Size];
int sz[Size];
bool ok[Size];
int R[Size];
int L[Size];

void create(int x, int t, int l, int r) {
	L[x] = l;
	R[x] = r;
	par[x] = x;
	ok[x] = t;
	sz[x] = 1;
}

int find_set(int x) {
	if (x == par[x])
		return x;
	return par[x] = find_set(par[x]);
}

void union_sets(int a, int b) {
	a = find_set(a);
	b = find_set(b);
	if (a != b) {
		if (sz[a] < sz[b])
			swap(a, b);
		L[a] = min(L[a], L[b]);
		R[a] = max(R[a], R[b]);
		par[b] = a;
		sz[a] += sz[b];
	}
}

set<pair<int, pair<int, int>>> S;

void toset(int a, int b) {
	int del = 0, s = 0, s2 = 0;
	if (sz[find_set(a)] == sz[find_set(b)])
		return;
	if (sz[find_set(a)] < sz[find_set(b)]) {
		del = sz[find_set(a)];
		s = find_set(a);
		s2 = find_set(b);
		if (!ok[find_set(a)])
			return;
	}
	else {
		del = sz[find_set(b)];
		s = find_set(b);
		s2 = find_set(a);
		if (!ok[find_set(b)])
			return;
	}


	S.insert(mk(del, mk(s, s2)));
}

bool check(int a, int b, int d) {
	int del = 0, s = 0, s2 = 0;
	if (sz[find_set(a)] == sz[find_set(b)])
		return false;
	if (sz[find_set(a)] < sz[find_set(b)]) {
		del = sz[find_set(a)];
		if (!ok[find_set(a)])
			false;
	}
	else {
		del = sz[find_set(b)];
		if (!ok[find_set(b)])
			false;
	}

	return del == d;
}

ll Fac(ll x) {
	ll an = 1;
	for (int i = 1; i <= x; i++)
		an *= i;
	return an;
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
#else
	//freopen("test.in", "r", stdin); freopen("A.out", "w", stdout);
#endif

	int T;
	cin >> T;
	for (int u = 0; u < T; u++) {
		string a, b;
		cin >> a >> b;


		if (Fac(a.size()) < 10005) {

			vector<int> P;

			bool f = 0;
			for (int i = 0; i < a.size() - 1; i++) {
				if (a[i] == a[i + 1] && b[i] != b[i + 1]) {
					f = 1;
					break;
				}
				if ((a[i] == b[i]) != (a[i + 1] == b[i + 1])) {
					P.push_back(i);
				}
			}

			if (f) {
				cout << "No\n";
				continue;
			}
			f = 0;
			for (int i = 0; i < Fac(P.size()); i++) {

				for (int j = 0; j < a.size(); j++)
					create(j, a[j] != b[j], j - 1, j + 1);

				for (int j = 1; j < a.size(); j++) {
					if ((a[j] == b[j]) == (a[j - 1] == b[j - 1]))
						union_sets(j - 1, j);
				}

				for (int j = 0; j < P.size(); j++) {
					if (sz[find_set(P[j])] != sz[find_set(P[j] + 1)])
						union_sets(P[j], P[j] + 1);
				}

				if (sz[find_set(0)] == a.size() && ok[find_set(0)] == 0) {
					cout << "Yes\n";
					f = 1;
					break;
				}

				next_permutation(all(P));
			}
			if (!f)
				cout << "No\n";
		}
		else {

			bool f = 0;
			for (int i = 0; i < b.size() - 1; i++) {
				if (b[i] != b[i + 1] && a[i] == a[i + 1]) {
					f = 1;
				}
			}

			if (f) {
				cout << "No\n";
				continue;
			}

			for (int i = 0; i < a.size(); i++)
				create(i, a[i] != b[i], i - 1, i + 1);

			for (int i = 1; i < a.size(); i++) {
				if ((a[i] == b[i]) == (a[i - 1] == b[i - 1]))
					union_sets(i - 1, i);
			}

			S.clear();

			for (int i = 0; i < a.size() - 1; i++) {
				if (find_set(i) != find_set(i + 1)) {
					toset(i, i + 1);
				}
			}

			while (S.size()) {
				auto cur = *S.rbegin();
				S.erase(*S.rbegin());

				int s1 = find_set(cur.second.first);
				int s2 = find_set(cur.second.second);
				if (s1 == s2)
					continue;

				if (!check(s1, s2, cur.first)) {
					continue;
				}

				union_sets(s1, s2);
				s1 = find_set(s1);
				if (L[s1] != -1) {
					if (ok[find_set(L[s1])] == ok[s1])
						union_sets(L[s1], s1);
					s1 = find_set(s1);

					if (L[s1] != -1) {
						toset(L[s1], s1);
					}
				}

				if (R[s1] != a.size()) {
					if (ok[find_set(R[s1])] == ok[s1])
						union_sets(R[s1], s1);
					s1 = find_set(s1);

					if (R[s1] != a.size()) {
						toset(R[s1], s1);
					}
				}
			}

			if (sz[find_set(0)] != a.size())
				f = 1;

			if (ok[find_set(0)] == 1)
				f = 1;

			if (f)
				cout << "No\n";
			else
				cout << "Yes\n";
		}
	}

	return 0;
}