#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <set>
#include <string>
#include <map>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ldouble;

#define mk make_pair
#define eps 1e-8
#define linf 8e18
#define inf 2e9
#define Size 1000006

int par[Size];
int sz[Size];
bool ok[Size];
int R[Size];
int L[Size];

void create(int x, int t, int l, int r) {
	L[x] = l;
	R[x] = r;
	par[x] = x;
	ok[x] = t;
	sz[x] = 1;
}

int find_set(int x) {
	if (x == par[x])
		return x;
	return par[x] = find_set(par[x]);
}

void union_sets(int a, int b) {
	a = find_set(a);
	b = find_set(b);
	if (a != b) {
		if (sz[a] < sz[b])
			swap(a, b);
		ok[b] = ok[a];
		L[a] = min(L[a], L[b]);
		R[a] = max(R[a], R[b]);
		par[b] = a;
		sz[a] += sz[b];
	}
}

set<pair<int, int>> S;

void toset(int a, int b) {
	int del = 0, s = 0, s2 = 0;
	if (sz[find_set(a)] == sz[find_set(b)])
		return;
	if (sz[find_set(a)] < sz[find_set(b)]) {
		del = sz[find_set(a)];
		s = find_set(a);
		if (!ok[find_set(a)])
			return;
	}
	else {
		del = sz[find_set(b)];
		s = find_set(b);
		if (!ok[find_set(b)])
			return;
	}


	S.insert(mk(del, s));
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
#else
	//freopen("test.in", "r", stdin); freopen("B.out", "w", stdout);
#endif

	int T;
	cin >> T;
	for (int u = 0; u < T; u++) {
		string a, b;
		cin >> a >> b;

		bool f = 0;
		for (int i = 0; i < b.size() - 1; i++) {
			if (b[i] != b[i + 1] && a[i] == a[i + 1]) {
				f = 1;
			}
		}

		if (f) {
			cout << "No\n";
			continue;
		}

		for (int i = 0; i < a.size(); i++)
			create(i, a[i] != b[i], i - 1, i + 1);
		
		for (int i = 1; i < a.size(); i++) {
			if ((a[i] == b[i]) == (a[i - 1] == b[i - 1]))
				union_sets(i - 1, i);
		}

		S.clear();

		for (int i = 0; i < a.size() - 1; i++) {
			if (find_set(i) != find_set(i + 1)) {
				toset(i, i + 1);
			}
		}

		while (S.size()) {
			auto cur = *S.rbegin();
			S.erase(*S.rbegin());
			
			int i = cur.second;
			while (i < a.size() && ok[i]) {
				union_sets(cur.second, i);
				ok[i++] = 0;
			}
			if (i != a.size())
				union_sets(cur.second, i);
			i = cur.second - 1;
			while (i >= 0 && ok[i]) {
				union_sets(cur.second, i);
				ok[i--] = 0;
			}
			if (i != -1)
				union_sets(cur.second, i);

			i = cur.second;

			if (R[i] != a.size())
				toset(i, R[i]);
			if (L[i] != -1)
				toset(L[i], i);
		
		}

		if (sz[find_set(0)] != a.size())
			f = 1;

		if (ok[find_set(0)] == 1)
			f = 1;

		if (f)
			cout << "No\n";
		else
			cout << "Yes\n";
	}

	return 0;
}