#include <iostream>
#include <string>
#include <vector>
#include <set>


using namespace std;


struct node {
	int key, prior, size;
	node *l, *r;
};


typedef node* node_ref;


int get_size(node_ref root) {
	if (!root) {
		return 0;
	}

	return root->size;
}


void update(node_ref root) {
	root->size = get_size(root->l) + get_size(root->r) + 1;
}


void split(node_ref root, node_ref &left, node_ref &right, int x) {
	if (!root) {
		return;
	}

	if (root->key <= x) {
		split(root -> r, root -> r, right, x);
		left = root;
		update(left);
	}
	else {
		split(root->l, left, root->l, x);
		right = root;
		update(right);
	}
}


void insert(node_ref &root, node_ref new_node) {
	if (!root) {
		root = new_node;
		return;
	}

	if (new_node->prior >= root->prior) {
		split(root, new_node->l, new_node->r, new_node->key);
		root = new_node;
		update(root);
		return;
	}

	if (new_node->key <= root->key) {
		insert(root->l, new_node);
	}
	else {
		insert(root->r, new_node);
	}
}


void print(node_ref root) {
	if (!root) {
		return;
	}

	print(root->r);
	cout << root->prior << ' ';
	print(root->l);
}


node_ref new_node(int key, int prior) {
	node_ref new_node = new node();
	new_node->key = key;
	new_node->prior = prior;
	new_node->l = NULL;
	new_node->r = NULL;
	return new_node;
}


node_ref root = NULL;


int main() {
	string s;
	getline(cin, s);
	int i = 0;
	string new_elem = "";
	vector<int> a;
	while (i < (int) s.size()) {
		if (s[i] != ' ') {
			new_elem += s[i];
		}
		else {
			a.push_back(stoi(new_elem));
			new_elem = "";
		}

		++i;
	}

	if (new_elem.size() > 0) {
		a.push_back(stoi(new_elem));
	}

	int n = a.size();
	set <pair<int, vector <int> > > my_set;
	for (int i = 0; i < n; ++i) {
		insert(root, new_node(i, a[i]));
	}

	print(root);
	return 0;
}