#ifdef _DEBUG
#	include <iostream>
#	include <algorithm>
#	include <vector>
#	include <string>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;

struct edge
{
	int next, len, col;
};

int _less(pair<int, int> a, pair<int, int> b)
{
	return a.first < b.first || a.first == b.first && a.second > b.second;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int n, m;
	cin >> n >> m;

	vector<vector<edge>> a(n);

	for (int i = 0; i < m; i++)
	{
		int l;
		cin >> l;

		vector<int> t(2 * l + 1);

		for (int j = 0; j < l * 2 + 1; j++)
			cin >> t[j];

		for (int j = 0; j < l; j++)
		{
			a[t[j * 2] - 1].push_back(edge());
			a[t[j * 2] - 1].back().next = t[j * 2 + 2] - 1;
			a[t[j * 2] - 1].back().len = t[j * 2 + 1];
			a[t[j * 2] - 1].back().col = i;
		}
	}

	vector<pair<int, int>> res(n, make_pair(INF, INF));
	vector<int> f(n, 0);
	res[0] = make_pair(0, 0);

	while (f.back() == 0)
	{
		int min = 0;
		while (f[min] == 1 || res[min].first == INF)
			min++;

		for (int i = min + 1; i < n; i++)
			if (f[i] == 0 && _less(res[i], res[min]))
				min = i;

		f[min] = 1;

		for (int i = 0; i < a[min].size(); i++)
		{
			pair<int, int> t = make_pair(res[min].first + a[min][i].len, res[min].second + a[min][i].len * a[min][i].len);

			if (_less(t, res[a[min][i].next]))
				res[a[min][i].next] = t;
		}
	}

	cout << res.back().first << ' ' << res.back().second << endl;
}