#ifdef _DEBUG
#	include <iostream>
#	include <vector>
#	include <string>
#	include <list>
#	include <algorithm>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;

const ll PR = (ll)1e9;
#ifdef _DEBUG
	const int SIZE = 64;
#else
	const int SIZE = 262144;
#endif

struct elem
{
	ll l, r, d;
};

elem res[2 * SIZE], cost[2 * SIZE];

void init()
{
	for (ll i = SIZE; i < SIZE * 2; i++)
	{
		res[i].d = res[i].l = res[i].r = cost[i].l = cost[i].r = i - SIZE;
		cost[i].d = 0;
	}

	for (ll i = SIZE - 1; i > 0; i--)
	{
		res[i].l = cost[i].l = res[i * 2].l;
		res[i].r = cost[i].r = res[i * 2 + 1].r;
		res[i].d = min(res[i * 2].d, res[i * 2 + 1].d);
		cost[i].d = 0;
	}
}

ll get_min(ll l, ll r)
{
	ll p = 1, ans = PR;

	while (l <= r)
		if (res[p].l == l && res[p].r <= r)
		{
			ans = min(ans, res[p].d);
			l = res[p].r + 1;
		}
		else if (l > res[p].r)
			p = p / 2;
		else if (res[p * 2].r >= l)
			p = p * 2;
		else
			p = p * 2 + 1;

	return ans;
}

ll get_max(ll l, ll r)
{
	ll p = 1, ans = 0;

	while (l <= r)
		if (cost[p].l == l && cost[p].r <= r)
		{
			ans = max(ans, cost[p].d);
			l = cost[p].r + 1;
		}
		else if (l > cost[p].r)
			p = p / 2;
		else if (cost[p * 2].r >= l)
			p = p * 2;
		else
			p = p * 2 + 1;

		return ans;
}

void change(ll p, ll r, ll c, ll m)
{
	p += SIZE;

	if (r == m)
	{
		ll q = p / 2;
		cost[p].d = c;
		while (q > 0)
		{
			cost[q].d = max(cost[q * 2].d, cost[1 * 2 + 1].d);
			q /= 2;
		}
	}

	res[p].d = r;
	p /= 2;
	while (p > 0)
	{
		res[p].d = min(res[p * 2].d, res[p * 2 + 1].d);
		p /= 2;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	ll n, a;
	cin >> n >> a;

	vector<ll> l(n), r(n), c(n);
	for (ll i = 0; i < n; i++)
		cin >> l[i] >> r[i] >> c[i];

	ll l_res = 0, r_res = a + 1;
	while (l_res + 1 < r_res)
	{
		ll m = (r_res - l_res) / 2 + l_res;
		init();
		for (ll i = a; i >= 0; i--)
		{
			for (ll j = 0; j < n; j++)
				if (i + r[j] < a + 1)
				{
					ll t = get_min(i + l[j], i + r[j]), cs = get_max(i + l[j], i + r[j]);

					if (t >= m && (cs < cost[i + SIZE].d || cost[i + SIZE].d == 0))
						change(i, t, cs + c[j], m);
				}
		}

		if (res[SIZE].d >= m)
			l_res = m;
		else
			r_res = m;
	}

	init();

	ll m = l_res;
	for (ll i = a; i >= 0; i--)
	{
		for (ll j = 0; j < n; j++)
			if (i + r[j] < a + 1)
			{
				ll t = get_min(i + l[j], i + r[j]), cs = get_max(i + l[j], i + r[j]);

				if (t >= m && (cs < cost[i + SIZE].d || cost[i + SIZE].d == 0))
					change(i, t, cs + c[j], m);
			}
	}

	cout << res[SIZE].d * PR - cost[SIZE].d << endl;
}