#include <iostream>
#include <vector>

using namespace std;

long double abs(long double x) {
    if (x < 0) return -x;
    return x;
}

struct point {
    int x, y, id;
    point(): x(0), y(0), id(0) {}
    point(int x, int y): x(x), y(y), id(0) {}
    point(int x, int y, int id): x(x), y(y), id(id) {}
    point(point a, point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
};

long long operator%(point a, point b) {
    return a.x * b.y - a.y * b.x;
}

point operator-(point a, point b) {
    return point(a.x - b.x, a.y - b.y);
}

long double square(point p1, point p2, point p3) {
    return abs((p2 - p1) % (p3 - p1)) / 2.0L;
}

const long double eps = 1e-5L;

bool inside(point a, point p1, point p2, point p3) {
    return abs(square(a, p1, p2) + square(a, p1, p3) + square(a, p2, p3) - square(p1, p2, p3)) < eps;
}

int main() {
    int n;
    cin >> n;
    vector<point> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        p[i].id = i + 1;
    }
    int q;
    string ans;
    cin >> q;
    while (q-- > 0) {
        bool found = false;
        for (int i = 0; i < n && !found; i++) {
            for (int j = i + 1; j < n && !found; j++) {
                for (int k = j + 1; k < n && !found; k++) {
                    bool ok = true;
                    for (int m = 0; m < n; ++m) {
                        if (m == i || m == j || m == k) continue;
                        if (inside(p[m], p[i], p[j], p[k])) {
                            ok = false;
                            cout << i << ' ' << j << ' ' << k << ": " << m << endl;
                            break;
                        }
                    }
                    if (ok) {
                        cout << "? " << p[i].id << ' ' << p[j].id << ' ' << p[k].id << endl;
                        cin >> ans;
                        if (ans == "Yes") {
                            cout << "! " << p[i].id << ' ' << p[j].id << ' ' << p[k].id << endl;
                            found = true;
                        }
                    }
                }
            }
        }
    }
    return 0;
}