#include <iostream>
#include <vector>

using namespace std;

struct Node {
    Node *prev = nullptr, *next = nullptr;

    int size = 0;
    bool sign = true;

    Node(Node* prev, int value, bool sign) {
        this->prev = prev;
        if (prev) {
            this->next = prev->next;
            prev->next = this;
        }
        this->size = value;
        this->sign = sign;
    }

    bool tryUnite() {
        //cout << size << ' ' << sign << endl;
        if (prev && prev->size < this->size) {
            size += prev->size;
            if (prev->prev) {
                size += prev->prev->size;
                if (prev->prev->prev) {
                    prev->prev->prev->next = this;
                    prev = prev->prev->prev;
                } else
                    prev = nullptr;
            } else
                prev = nullptr;
            //cout << -1 << endl;
            return -1;
        }
        if (next && next->size < this->size) {
            this->size += next->size;
            if (next->next) {
                this->size += next->next->size;
                if (next->next->next) {
                    next->next->next->prev = this;
                    next = next->next->next;
                } else
                    next = nullptr;
            } else
                next = nullptr;
            //cout << 1 << endl;
            return 1;
        }
        return 0;
    }
};

struct List {
    Node *head = nullptr, *tail = nullptr;

    void add(int value, bool sign) {
        Node *result = new Node(tail, value, sign);
        if (!head)
            head = result;
        tail = result;
    }

    List(const string& s, int l, int r, bool inv) {
        int start = l;
        for (int i = l + 1; i <= r; ++i)
            if (i == r || s[i] != s[i - 1]) {
                this->add(i - start, (s[start] == '+') ^ inv);
                start = i;
            }
    }
};

int main() {
    int q;
    cin >> q;
    while (q--) {
        string s, t;
        cin >> s >> t;

        bool good = true;

        for (int i = 0, len = s.length(); i < len - 1; i++) {
            if (t[i] != t[i + 1] && (s[i] != t[i] || s[i + 1] != t[i + 1])) {
                good = false;
                break;
            }
        }

        if (!good) {
            cout << "No" << endl;
            continue;
        }

        int start = 0;

        for (int i = 1, len = t.length(); i <= len; i++) {
            if (i == len || t[i] != t[i - 1]) {
                List data = List(s, start, i, t[start] == '-');

                Node *ptr, *_ptr;

                for (ptr = data.head; ptr != nullptr; ptr = ptr->next) {
                    if (ptr->sign)
                        while (ptr->tryUnite() != 0);
                    _ptr = ptr;
                }


                if (_ptr->size != (i - start) || !_ptr->sign) {
                    good = false;
                    break;
                }

                start = i;
            }
        }

        if (good)
            cout << "Yes" << endl;
        else
            cout << "No" << endl;


    }
    return 0;
}