#include <iostream>

using namespace std;

const int MAXN = 2097152;
const int MAXV = 4097160;
const int inf = 0;

int tree[MAXV];

void push(int v) {
    if (v * 2 + 1 < MAXV)
        tree[v * 2 + 1] = max(tree[v * 2 + 1], tree[v]);
    if (v * 2 + 2 < MAXV)
        tree[v * 2 + 2] = max(tree[v * 2 + 2], tree[v]);
    tree[v] = inf;
}

void update(int value, int l, int r, int v = 0, int tl = 0, int tr = MAXN) {
    if (v >= MAXV) return;
    if (tr <= l || r <= tl) return;
    if (l <= tl && tr <= r) {
        tree[v] = max(tree[v], value);
        return;
    }
    push(v);
    update(value, l, r, v * 2 + 1, tl, (tl + tr) / 2);
    update(value, l, r, v * 2 + 2, (tl + tr) / 2, tr);
}

int get(int u, int v = 0, int tl = 0, int tr = MAXN) {
    if (v >= MAXV) return inf;
    if (tr <= u || u < tl) return inf;
    if (tr - tl == 1) return tree[v];
    push(v);
    return max(get(u, v * 2 + 1, tl, (tl + tr) / 2), get(u, v * 2 + 2, (tl + tr) / 2, tr));
}


int main() {
    for (int i = 0; i < MAXV; i++) tree[i] = inf;

    int n, a;
    cin >> n >> a;

    int l[100], r[100], c[100];

    for (int i = 0; i < n; ++i)
        cin >> l[i] >> r[i] >> c[i];

    //update(0, 0, 1);

    long long ans = 1LL << 60;
    long long unitcost = (long long)1e9;
    for (int i = 0; i <= a; ++i) {
        int cost = get(i);
        //ans = max(ans, unitcost * i - cost);
        bool can = false;
        for (int j = 0; j < n; ++j)
            if (i + r[j] <= a) {
                can = true;
                update(cost + c[j], i + l[j], i + r[j] + 1);
            }
        if (!can) {
            ans = min(ans, unitcost * i - cost);
        }
    }

    cout << ans << endl;

    return 0;
}