#pragma comment(linker, "/Stack:512000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long LL;

const int MAXB = 5;
const int MAXN = (int)1e6 + 100;

int a[MAXN];
int n;

char b[MAXB];

inline int BIT(int a, int b) {
  return (a & (1 << b)) >> b;
}

bool findB(int bit, int L, int R) {
  if (bit < 0 || L >= R) return 1;

  bool only1 = 1, only0 = 1, less = 1, greater = 1;
  int pos = -1;
  for (int i = L; i < R; ++i) {
    if (BIT(a[i], bit) == 1) only0 = 0;
    else only1 = 0;

    if (i != L && BIT(a[i], bit) > BIT(a[i - 1], bit)) greater = 0, pos = i;
    if (i != L && BIT(a[i], bit) < BIT(a[i - 1], bit)) less = 0, pos = i;
  }

  if (only1 || only0) return findB(bit - 1, L, R);
  
  if (!less && !greater) return 0;

  if (less) {
    if (b[bit] == 1) return 0;
    b[bit] = 0;
    findB(bit - 1, L, pos);
    findB(bit - 1, pos, R);
  }
  else {
    if (b[bit] == 0) return 0;
    b[bit] = 1;
    findB(bit - 1, L, pos);
    findB(bit - 1, pos, R);
  }
  return 1;
}

int calcB() {
  for (int i = 0; i < MAXB; ++i)
    b[i] = -1;

  bool ok = findB(MAXB - 1, 0, n);
  if (!ok) return -1;
  int B = 0;
  for (int i = 0; i < MAXB; ++i) {
    if (b[i] == -1) b[i] = 0;
    if (b[i]) B |= (1 << i);
  }
  return B;
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "order"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  
  scanf("%d", &n);
  for (int i = 0; i < n; ++i) {
    scanf("%d", &a[i]);
  }

  int B = calcB();
  printf("%d\n", B);

  int q;
  scanf("%d", &q);

  for (int i = 0; i < q; ++i) {
    int p, v;
    scanf("%d%d", &p, &v);
    a[p - 1] = v;
    B = calcB();
    printf("%d\n", B);
  }
  return 0;
}