#pragma comment(linker, "/Stack:128000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

typedef long long LL;

const LL INFll = (LL) 1e18;
const LL k = (LL)1e9;

/*
const int MAX_MEM = 120000000;

char MEM[MAX_MEM];
char *m_pos = MEM;

inline void* operator new(size_t n){
  char *res = m_pos;
  m_pos += n;
  return (void*)res;
}

inline void operator delete(void*) {};
*/
int n, a;

struct Exp {
  int L, R, c;

  bool operator<(const Exp &e) const {
    return R != e.R ? R < e.R : L != e.L ? L > e.L : c < e.c;
  }
};

Exp exps[150];
const int MAXA = (int)3e5 + 100;

struct MaxQ {
  vector<pair<LL, LL>> in, out;

  void add(LL x) {
    in.push_back({ x, in.empty() ? x : max(x, in.back().second) });
  }

  void pop() {
    if (out.empty()) {
      if (in.empty()) return;

      while (!in.empty()) {
        LL x = in.back().first;
        in.pop_back();
        out.push_back({ x, out.empty() ? x : max(x, out.back().second) });
      }
    }

    out.pop_back();
  }

  LL get() {
    LL ans = 0;
    if (!in.empty()) ans = max(ans, in.back().second);
    if (!out.empty()) ans = max(ans, out.back().second);
    return ans;
  }
};

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "anti"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  cin >> n >> a;

  for (int i = 0; i < n; ++i) {
    cin >> exps[i].L >> exps[i].R >> exps[i].c;
  }

  sort(exps, exps + n);

  LL ans = 0;

  int root = 1;

  vector<MaxQ> qs(n);
  vector<LL> dp(a + 1);
  for (int cur = 1; cur <= a; ++cur) {
    LL mem = 0;
    for (int i = 0; i < n && exps[i].R <= cur; ++i) {
      mem = max(mem, qs[i].get() - exps[i].c - (a - cur) * k);
    }
    for (int i = 0; i < n; ++i) {
      if (cur >= exps[i].L) qs[i].add(dp[cur - exps[i].L] + (a - cur + exps[i].L - 1) * k);
      if (cur >= exps[i].R - 1) qs[i].pop();
    }
    ans = max(ans, mem);
    dp[cur] = mem;
  }

  cout << ans << endl;
  return 0;
}