#pragma comment(linker, "/Stack:128000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

typedef long long LL;

const int MAX_MEM = 120000000;

char MEM[MAX_MEM];
char *m_pos = MEM;

inline void* operator new(size_t n){
  char *res = m_pos;
  m_pos += n;
  return (void*)res;
}

inline void operator delete(void*) {};

const LL INFll = (LL) 1e18;
const LL k = (LL)1e9;

int n, a;

struct Exp {
  int L, R, c;
};

vector<Exp> exps;
vector<LL> mem;

LL dfs(int cur, int last) {
  if (mem[cur] != -1) return mem[cur];

  LL opt = 0;
  for (int i = last; i < n; ++i) {
    if (cur - exps[i].R >= 0) {
      LL d = INFll;
      for (int j = exps[i].L; j <= exps[i].R; ++j)
        d = min(d, dfs(cur - j, i) - exps[i].c + k * j);
      opt = max(opt, d);
    }
  }
  return mem[cur] = opt;
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "anti"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  cin >> n >> a;
  exps.resize(n);
  mem.resize(a + 1, -1);
  
  for (int i = 0; i < n; ++i) {
    cin >> exps[i].L >> exps[i].R >> exps[i].c;
  }

  LL ans = 0;
  for (int i = a; i >= 0; --i) ans = max(ans, dfs(i, 0));

  cout << ans << endl;
  return 0;
}