#pragma comment(linker, "/Stack:128000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

typedef long long LL;

const LL INFll = (LL) 1e18;
const LL k = (LL)1e9;

int n, a;

struct Exp {
  int L, R, c;

  bool operator<(const Exp &e) const {
    return R != e.R ? R < e.R : L != e.L ? L > e.L : c < e.c;
  }
};

vector<Exp> exps;

struct ST {
  LL val;
  LL push;

  ST *left, *right;

  ST(int L, int R) {
    val = 0;
    push = 0;
    left = right = nullptr;
    if (L != R - 1) {
      int md = (L + R) / 2;
      left = new ST(L, md);
      right = new ST(md, R);
    }
  }
};

void update(ST *root) {
  if (root->left == nullptr)
    root->val = root->push;
  else
    root->val = root->push + min(root->left->val, root->right->val);
}

void push(ST *root) {
  if (root->push == 0) return;

  if (root->left == nullptr) {
    root->val = root->push;
  }
  else {
    root->left->push += root->push;
    root->right->push += root->push;
    root->push = 0;

    update(root->left);
    update(root->right);
    update(root);
  }
}

void add(ST *root, int L, int R, int ql, int qr, LL x) {
  if (L >= qr || R <= ql) return;
  if (ql <= L && R <= qr) {
    root->push += x;
    update(root);
    return;
  }
  push(root);

  int md = (L + R) / 2;

  add(root->left, L, md, ql, qr, x);
  add(root->right, md, R, ql, qr, x);

  update(root);
}

LL get(ST *root, int L, int R, int ql, int qr) {
  if (L >= qr || R <= ql) return INFll;
  if (ql <= L && R <= qr) {
    return root->val;
  }
  push(root);

  int md = (L + R) / 2;

  return root->push + min(get(root->left, L, md, ql, qr), get(root->right, md, R, ql, qr));
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "anti"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  cin >> n >> a;
  exps.resize(n);

  for (int i = 0; i < n; ++i) {
    cin >> exps[i].L >> exps[i].R >> exps[i].c;
  }

  sort(exps.begin(), exps.end());

  LL ans = 0;

  ST *root = new ST(0, a + 2);

  for (int cur = 1; cur <= a; ++cur) {
    add(root, 0, a + 2, 0, cur, k);
    LL mem = 0;
    for (int i = 0; i < n && exps[i].R <= cur; ++i) {
      LL tmp = get(root, 0, a + 2, cur - exps[i].R, cur - exps[i].L + 1) - exps[i].c;
      mem = max(mem, tmp);
    }
    add(root, 0, a + 2, cur, cur + 1, mem);
    ans = max(ans, mem);
  }

  cout << ans << endl;
  return 0;
}