#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i];
    cout << endl;
}

const int MAX_N = 1e6;
const int LOG_N = 3;

int tree[LOG_N][MAX_N];
int s[MAX_N];
pair<bool, bool> lst[LOG_N];


int cnt(int r, int k){
    int answer = 0;
    while (r >= 0){
        answer += tree[k][r];
        r = ((r + 1) & r) - 1;
    }
    return answer;
}


int get(int l, int r, int k){
    if (l == 0)
        return cnt(r, k);
    return cnt(r, k) - cnt(l, k);
}


int n;


void update(int pos, int v, int k){
    for (int i = pos; i < n; i |= i + 1)
        tree[k][i] += v;
}


void getAns(int l, int r, int k){
    if (k == -1)
        return;
    int left = l;
    int right = r + 1;
    if (s[l] & (1 << k)){
        while (left + 1 < right){
            int m = (left + right) / 2;
            int cntt = get(l, m, k);
            if (cntt == m - l + 1)
                left = m;
            else
                right = m;
        }
        if (get(l, r, k) != get(l, left, k)){
            lst[k].first = false;
            lst[k].second = false;
            return;
        }
        getAns(l, left, k - 1);
        if (left < r){
            lst[k].first = false;
            getAns(left + 1, r, k - 1);
        }
    }
    else{
        while (left + 1 < right){
            int m = (left + right) / 2;
            int cntt = get(l, m, k);
            if (cntt == 0)
                left = m;
            else
                right = m;
        }
        if (get(l, r, k) != r - left){
            lst[k] = make_pair(false, false);
            return;
        }
        getAns(l, left, k - 1);
        if (left < r){
            lst[k].second = false;
            getAns(left + 1, r, k - 1);
        }
    }
}


int main()
{
    #ifdef ONLINE_JUDGE
        freopen("test.in", "r", stdin);
    #endif // ONLINE_JUDGE
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> s[i];
    for (int i = 0; i < n; i++){
        int cur = s[i];
        for (int j = 0; j < LOG_N; j++){
            update(i, cur & 1, j);
            cur /= 2;
        }
    }
    int q;
    cin >> q;
    int pos, v;
    for (int qq = 0; qq < q + 1; qq++){
        for (int i = 0; i < LOG_N; i++)
            lst[i] = make_pair(true, true);
        getAns(0, n - 1, LOG_N - 1);
        int answer = 0;
        for (int i = LOG_N - 1; i >= 0; i--){
            if (lst[i].first == 1)
                continue;
            if (lst[i].second == 1){
                answer += (1 << i);
                continue;
            }
            answer = -1;
            break;
        }
        cout << answer << "\n";
        if (qq != q){
            cin >> pos >> v;
            int vv = v;
            pos--;
            int cur = s[pos];
            for (int i = 0; i < LOG_N; i++){
                if ((v & 1) != (cur & 1)){
                    if (v & 1)
                        update(pos, 1, i);
                    else
                        update(pos, -1, i);
                }
                cur /= 2;
                v /= 2;
            }
            s[pos] = vv;
        }
    }
    return 0;
}
