#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define vec vector
#define pb push_back

const int INF = 1e9;

struct seg {
    int l, r;
    seg() {}
    seg(int l, int r): l(l), r(r) {}
    void write() { cout << l << "; " << r << '\n'; }
};
seg operator *(const seg a, const seg b) {
    if (a.r == -INF || b.r == -INF) { return seg(INF, -INF); }
    seg ans(max(a.l, b.l), min(a.r, b.r));
    if (ans.l > ans.r) { return seg(INF, -INF); }
    return ans;
}

int main() {
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);

    int n;
    cin >> n;
    if (n == 1) { cout << "0\n"; return 0; }
    vec<int> arr(n);
    for (int &k : arr) { cin >> k; }
    vec<int> l(n - 1), r(n - 1);
    for (int k = 0; k < n - 1; k++) { cin >> l[k] >> r[k]; }

    vec<seg> up(n, seg(-INF, INF)), down(n, seg(-INF, INF));
    seg cur = seg(l[0], r[0]);
    for (int k = 0; k < n - 1; k++) {
        if (cur.l == l[k]) {
            cur.l -= arr[k + 1];
        }

        down[k + 1] = cur;
        if (k != n - 2) {
            cur = cur * seg(l[k + 1], r[k + 1]);
        }
    }
    cur = seg(l[n - 2], r[n - 2]);
    for (int k = n - 2; k >= 0; k--) {
        if (cur.l == l[k]) {
            cur.l -= arr[k];
        }
        up[k] = cur;
        if (k != 0) {
            cur = cur * seg(l[k - 1], r[k - 1]);
        }
    }
    for (int k = 0; k < n; k++) {
        seg ans = up[k] * down[k] * seg(0, INF);
        if (ans.r == -INF) { cout << "-1\n"; continue; }
        cout << ans.l << '\n';
    }
    cout << '\n';
    return 0;
}
